/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.conversions;

// class which converts int & short to byte array.
// In each byte array the MOST byte is bytearray[0]

final public class ByteArrayConversion {

    static final int i3 = 0x000000ff;
    static final int i2 = 0x0000ff00;
    static final int i1 = 0x00ff0000;
    static final int i0 = 0xff000000;

    static final short s1 = (short)0x00ff;
    static final short s0 = (short)0xff00;

    static public byte[] IntToByteArray(int i) {

        byte[] ByteArray = new byte[4];

        ByteArray[3] = (byte)(i & i3);
        ByteArray[2] = (byte)((i & i2)>>>8);
        ByteArray[1] = (byte)((i & i1)>>>16);
        ByteArray[0] = (byte)((i & i0)>>>24);

        return ByteArray;

    }
    static public int ByteArrayToInt(byte[] ByteArray) {
        return   ((((int)ByteArray[0])<<24) & i0) |
                 ((((int)ByteArray[1])<<16) & i1) |
                 ((((int)ByteArray[2])<<8) & i2)  |
                 ((int)ByteArray[3] & i3);
    }
    static public byte[] ShortToByteArray(short s) {

        byte[] ByteArray = new byte[2];

        ByteArray[1] = (byte)(s & s1);
        ByteArray[0] = (byte)((s & s0)>>>8);

        return ByteArray;
    }
    static public short ByteArrayToShort(byte[] ByteArray) {
        return   (short)(((((short)ByteArray[0])<<8) & s0)  |
                           ((short)ByteArray[1] & s1));
    }
}
