/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.datastructures;

import java.util.Hashtable;
import java.util.Enumeration;

public class AssociativeArrayC extends Hashtable {

		public AssociativeArrayC() {
			super();
		}

//    private Hashtable KeysAndValues = new Hashtable();

    public String toString() {
        return ToString();
    }

    public String ToString() {
        Enumeration Keys;
        String Key,Value;
        String AssoString;


        if (size() == 0) return null;
        AssoString = String.valueOf(size());

        for (Keys = keys() ; Keys.hasMoreElements();) {
            Key = (String)Keys.nextElement();
            Value = (String)get(Key);
            //Debug.println("*-*AssociativeArrayC:Key = " + Key + ", Value = " +  Value);
            AssoString = AssoString + " '" + Key.length()   + " " + Key +
                                      " '" + Value.length() + " " + Value;
        }
        //Debug.println("*-*AssociativeArrayC:AssoString = " + AssoString);
        return AssoString;
    }

    public void FromString(String AssoString)
                                throws IllegalAssoSyntaxException {

        Reset();

        try {
            String Key,Value;
            String Temp;
            int len;
            int fromindex = 0;
            int toindex = AssoString.indexOf(" ",fromindex);
            String numargsStr = AssoString.substring(fromindex,toindex);
            int numargs = Integer.parseInt(numargsStr);
            fromindex = toindex;

            for (int i = 0; i < numargs; i++) {
                Temp = AssoString.substring(fromindex,fromindex+2);
                if (!Temp.equals(" '"))
                    throw new IllegalAssoSyntaxException
                                ("Input String : " + AssoString);
                
                // retrieve the key length
                fromindex = fromindex + 2;
                toindex = AssoString.indexOf(" ",fromindex);
                len = Integer.parseInt(AssoString.substring(fromindex,toindex));
                
                // retrieve the key value 
                fromindex = toindex + 1;
                Key = AssoString.substring(fromindex,fromindex+len);
                
                // retrieve the value length
                fromindex = fromindex + len;
                Temp = AssoString.substring(fromindex,fromindex+2);
                if (!Temp.equals(" '"))
                    throw new IllegalAssoSyntaxException
                                ("Input String : " + AssoString);
                fromindex = fromindex+2;
                toindex = AssoString.indexOf(" ",fromindex);
                len = Integer.parseInt(AssoString.substring(fromindex,toindex));
                
                // retrieve the value
                fromindex = toindex + 1;
                Value = AssoString.substring(fromindex,fromindex+len);

                AddCouple(Key,Value);

                fromindex = fromindex + len;
            }
        }
        catch (Exception e) {
            throw new IllegalAssoSyntaxException
                                ("Input String : " + AssoString);
        }
    }

    public String GetValueOfParameter(String Key)
                                throws AssoKeyDoesNotExistException{

        String Value = (String)get(Key);
        if (Value == null)
            throw new AssoKeyDoesNotExistException
                ("Key : " + Key + "  does not exist in " + this.ToString());
        else
            return Value;

    }

    public void AddCouple(String Key,String Value) {

        put(Key,Value);

    }
    
    public void AddArrayCouple(String Key,String Value,int Index) {

		Key = Key + Index;		
		AddCouple(Key,Value);

    }

    public boolean KeyExists(String Key) {

        try {
            String Value = GetValueOfParameter(Key);
            return true;
        }
        catch (AssoKeyDoesNotExistException e) {return false;}

    }

    public void Reset() {

        clear();

    }
}
