/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.datastructures;

import java.util.Vector;

public class Queue extends Vector {

    /**
     * Puts an item into the queue.
     * @param item the item to be put into the queue.
     */
    public Object put(Object item) {
        addElement(item);

        return item;
    }
    public Object putOnTop(Object item) {
        insertElementAt(item,0);

        return item;
    }

    /**
     * Gets an item from the front of the queue.
     * @exception EmptyQueueException If the queue is empty.
     */
    public Object get() throws EmptyQueueException{
        Object  obj;

        try {
            obj = peek();
            removeElementAt(0);

            return obj;
        }
        catch (EmptyQueueException e) {throw e;}
    }

    /**
     * Peeks at the front of the queue.
     * @exception EmptyQueueException If the queue is empty.
     */
    public Object peek() throws EmptyQueueException {
        int     len = size();

        if (len == 0)
                throw new EmptyQueueException();
        return elementAt(0);
    }

    /**
     * Returns true if the queue is empty.
     */
    public boolean empty() {
        return size() == 0;
    }

    /**
     * Sees if an object is in the queue.
     * @param o the desired object
     * @return the distance from the front, or -1 if it is not found.
     */
    public int search(Object o) {
        int i = indexOf(o, 0);

        if (i >= 0) {
            return i;
        }
        return -1;
    }

    public void clear() {
        removeAllElements();
    }

}
