/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.gui;

import java.awt.Button;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Label;

public class OKDialog extends Dialog {

    protected Button okButton;
    protected static Frame createdFrame;
    protected static Frame specialFrame;
    protected static OKDialog specialOKDialog;

    public OKDialog(Frame parent,String message) {
        super(parent,true);

        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();

        okButton = new Button("OK");
        Label messageLabel = new Label(message);

        setLayout(gridbag);

        constraints.fill = GridBagConstraints.NONE;
        constraints.anchor = GridBagConstraints.CENTER;
        constraints.ipadx = 20;
        constraints.ipady = 20;
        constraints.weightx = 1.0;
        constraints.weighty = 1.0;
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.gridheight = GridBagConstraints.RELATIVE;

        gridbag.setConstraints(messageLabel, constraints);
        add(messageLabel);

        constraints.ipadx = 0;
        constraints.ipady = 0;
        constraints.weightx = 0.0;
        constraints.weighty = 0.0;
        constraints.gridwidth = 1;
        constraints.gridheight = GridBagConstraints.REMAINDER;

        gridbag.setConstraints(okButton, constraints);
        add(okButton);

        pack();
    }

		// Overrides deprecated method
    public boolean action(Event evt, Object whichAction) {
        if (evt.target == okButton) {
            hide();
            if (createdFrame != null) {
                createdFrame.hide();
            }
        }
        return true;
    }

    public static void createOKDialog(String dialogString) {
        if (createdFrame == null) {
            createdFrame = new Frame("Dialog");
        }
        OKDialog okDialog = new OKDialog(createdFrame, dialogString);
        createdFrame.setSize(okDialog.getSize().width,
                             okDialog.getSize().height);
        okDialog.setLocation(400, 400);
        okDialog.show();
    }

    public static void createSpecialOKDialog(String dialogString) {
        if (specialFrame == null) {
            specialFrame = new Frame("Dialog");
        }
        specialOKDialog = new OKDialog(specialFrame, dialogString);
        specialFrame.setSize(specialOKDialog.getSize().width,
                            specialOKDialog.getSize().height);
    }

    public static void showSpecialOKDialog() {
        specialOKDialog.show();
    }
}
