/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.synch;

/**
 * Title:
 * Description:  Classes in this project serves as synchronization means.
 * Copyright:    Copyright (c) 2001
 * Company:      Radview
 * @author
 * @version 1.0
 */

public class ManualEvent {
	protected boolean _state;

	public ManualEvent() {
		_state = false;
	}

  public ManualEvent(boolean state) {
		boolean _state = state;
  }

	public synchronized void reset() {
		_state = false;
	}

	public synchronized void set() {
		_state = true;
		notifyAll();
	}

	public synchronized boolean waitFor(long timeoutmillis) throws InterruptedException {

		long baseTime = System.currentTimeMillis();

		while (!_state && ( (System.currentTimeMillis() - baseTime) < timeoutmillis) ) {
			wait(System.currentTimeMillis() - baseTime);
		}

		return _state;
	}

	public synchronized boolean waitFor() throws InterruptedException {
		while (!_state) wait();
		return _state;
	}
}
