/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.wlutil;

/**
 * Title:        WebLoad Utilities from Java.
 * Description:  This project will contain connection to WebLoad Utilities from Java
 * Currently connected:
 * 1. Trace Application
 * 2. TVEnv (access to WebLoad.ini variables)
 * Copyright:    Copyright (c) 2002
 * Company:      Radview
 * @author Yahali Sherman
 * @version 1.0
 */

public class RVPlatformSupport
{
	private static boolean libraryLoaded = false;

	/**
	 * Inits the class and loads the relevant dll.
	 * Must be called before using the class!!!
	 */
	public static void init(String dllDir)
	{
		 if(!libraryLoaded) {
			 try {
				 String lib = dllDir + "\\RVPlatformSupport.dll";
				 System.load(lib);
				 libraryLoaded = true;
			 }
			 catch(Exception exp) {
			 }
                         catch(Error err) {
                         }
		 }
	}

	public static long getForegroundBrowserHWND()
	{
		if(libraryLoaded) {
		    try {
		   	    return getForegroundWindowHWND();
		    }
		    catch(Exception e) {
		    }
		}

		return 0;
	}

  /**
	 * This method returns a handle to the foreground window
	 * (the window with which the user is currently working)
	 **/
	public static native long getForegroundWindowHWND();
}
