/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_ELEMENT__
#define __WL_ELEMENT__


#include <ordered.h>
#include <RVCString.h>
#include "wlArray.h"


class DllExport CWLElement : public CKVP 
{
private:
	RVOrdered  m_Options;
	RVCString  m_Type;
	int		   m_Checked;//! for future reference to "checked" and "selected"

public:
	CWLElement(){}
	CWLElement(const char* key_, const char* value_, const char* type_):CKVP(key_, value_) 
	{
		m_Type = type_;
	}
//	CWLElement(const CWLElement& anElement) { *this = anElement; }
	virtual ~CWLElement() {}

	CWLElement&		operator=(CWLElement&);
	bool			operator==(CWLElement&);
	const char*		Name() { return Key(); } //! just a change of name from value				
	const char*		Type() { return m_Type.data(); }
	RVOrdered*		Options() {return &m_Options; }
	int				checked(){ return m_Checked; }	
	void			setType(const char* type){m_Type = type;}
	void			setName(const char* name){setKey(name);}
	
};

#endif