/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_XML
#define __WL_XML

#include <collectable.h>
#include <thr.h>
#include "platform.h"
#include "wldocument.h"

enum docTypeState{
	ENCODING_REMOVE,
	DOCTYPE_FIND,
	DOCTYPE_DECLARED,
	DOCTYPE_ROOT_NAME,
	DOCTYPE_SEARCH_EXTERNAL,
	DOCTYPE_PUBLIC,
	DOCTYPE_SYSTEM,
	DOCTYPE_PARSE_INTERNAL,
	DOCTYPE_PARSE_EXTERNAL,
	DOCTYPE_PARSE_DONE,
	DOCTYPE_PARSE_ERROR
};


class RWSCtring;
class CWLXmlPrivate;
class urlBase;
class CWLHtmlVirtualQueue;
class CWLXmlEntityResolver;


class DllExport CWLXmlParseInterfacePointer {
public:
	CWLXmlParseInterfacePointer() {}
	virtual ~CWLXmlParseInterfacePointer() {}
};

class  DllExport CWLXmlDocument : public CWLDocument{
public:
	CWLXmlDocument(CWLDocument *docPtr);
	CWLXmlDocument(){ m_TransObj.SetObj(this); m_TransObj.SetObjType(XML);}
	virtual ~CWLXmlDocument();
private:
	CWLXmlEntityResolver*					m_pDtdExternal;//! ptr to the external part of the dtd
	CWLXmlEntityResolver*					m_pDtdInternal;
	CWLXmlParseInterfacePointer*	m_pInterfacePtr;
	
	RVCriticalSection*						m_XmlPrivatesCountMutex;

	RVCString				m_InnerHTML;
	RVCString				m_Id;
	RVCString				m_Src;
//	int							m_PrivatesCount;
	CWLDocument*		m_pDom;
	int							startDocTypePtr;
	int							m_EndDocTypePtr;
	RVCString				m_DocTypeErrorString;
	docTypeState		m_DocTypeState;
	size_t					strPtr;
	size_t					startElementPtr;
	bool						m_bSearchForCommentEnd;

public:
	virtual void				parse(const char* newData = NULL, size_t size = 0, bool* isDone = NULL);
	elementReadState		parseXML(const char* newData, size_t size);
	const char*					GetXmlStandAloneStr(RVCString& value, RVCString& error);
	void								appendToErrorString(char* description, size_t start, size_t length, char* ptr = NULL);

	
	
//	int									IncPrivatesCount();
//	int									DecPrivatesCount();
//	int									GetPrivatesCount();
	
	void								SetId(const char* id);
	void								SetSrc(const char* src);
	void								SetDom(CWLDocument* doc);
	void								SetPrivateInterface(CWLXmlParseInterfacePointer* prv);

	virtual RVCString&	GetDocUrl();
	void								SetInnerHTML(const char* text, size_t length);
	const char*					GetInnerHTML();
	const char*					GetId();
	const char*					GetSrc();

	CWLDocument*				GetDom();
	void								printAll();

	CWLXmlParseInterfacePointer* GetPrivateInterface();



//	void printAll(size_t i);
};
#endif

		
