/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "wlOption.h"


CWLOption::CWLOption(const char* value, const char* text, const char* id, bool selected)
{
	if(value)
		m_Value	 = value;
	if(text)
		m_Text	 = text;
	if(id)
		m_Id		 = id;
	m_Selected = selected;
}

CWLOption& CWLOption::operator=(CWLOption& anOption)
{
	m_Value			= anOption.Value();
	m_Text			= anOption.Text();
	m_Selected	= anOption.Selected();
	return *this;
}

const char*	CWLOption::Text()
{
	return m_Text.data();
}

const char*	CWLOption::Value()		
{
	if(!m_Value.data() || !m_Value.data()[0])
		return m_Text.data();
	return m_Value.data();
}

bool CWLOption::Selected()
{
	return m_Selected;
}

const char* CWLOption::Id()
{
	return m_Id.data();
}
