/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*! 
	This is a test program for htmlparse module.
	Also there is a possibility to see how each of the 
	DOM object can be accessed and its properties.

	The program gets as argument a regular HTML file.
*/
#include <string.h>
#if !defined(__TV_UNIX__)
#include <conio.h>
#endif
#include <stdio.h>
//#include <iostream.h>
#include "wlFrameContainer.h"
#include "wlDocument.h"
#include "wlscript.h"
#include "wlXml.h"
#include "wlform.h"
#include "wlhtmlvirtualqueue.h"
#include "tracedll.h"
#include <RVCString.h>
#include <thr.h>
#include <thr.h>
#include "tracedll.h"
//#include <iostream.h>
//================
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
//================

// Solaris doesn't declare ftime in <sys/timeb.h> for some reason
#ifdef __TV_solaris__
extern "C" {
int ftime(struct timeb *tp);
}
#endif

// Unix doesn't have a getch() function. It does have a getchar function.
#ifdef __TV_UNIX__
#define GETCH getchar
#else
#define GETCH getch
#endif

FILE* fp ;
int numOfBytes = 1024;
void determineFlags(bool& src_F, bool& href_F, bool& form_F, bool& buff_F, bool& table_F, bool& script_F)
{
	RVCString tmp;
//	cout<<"would you like to parse (srcs|hrefs|forms|html) ?(0,1)";
	cin>>tmp;
	cout<<'\n';
	if(tmp(0) == '1') src_F = 1;
	if(tmp(1) == '1') href_F = 1;
	if(tmp(2) == '1') form_F = 1;
	if(tmp(3) == '1') buff_F = 1;
	if(tmp(4) == '1') table_F = 1;
	if(tmp(5) == '1') script_F = 1;

}

void determineFlags_(bool& src_F, bool& href_F, bool& form_F, bool& buff_F, bool& table_F, bool& script_F, bool& xml_F)
{
	char opt;
	cout<<"Please enter:\n'y' for each category you want to parse,\n'n' for categories you do not want parsed.\n\n";
	cout<<"Parse All objects ?(y/n) -";
	 cin>>opt;
	if(opt == 'y'){
		href_F = src_F = form_F = table_F = script_F = xml_F = buff_F = true;
		return;
	}
	cout<<"Parse Links ?(y/n) - ";
	cin>>opt; href_F = ((opt == 'y' || opt == 'Y') ? true : false);
	cout<<"Parse Images ?(y/n) - ";
	cin>>opt; src_F = ((opt == 'y' || opt == 'Y') ? true : false);
	cout<<"Parse Forms ?(y/n) - ";
	cin>>opt; form_F = ((opt == 'y' || opt == 'Y') ? true : false);
	cout<<"Parse Tables ?(y/n) - ";
	cin>>opt; table_F = ((opt == 'y' || opt == 'Y') ? true : false);
	cout<<"Parse Scripts ?(y/n) - ";
	cin>>opt; script_F = ((opt == 'y' || opt == 'Y') ? true : false);
	cout<<"Parse XML islands ?(y/n) - ";
	cin>>opt; xml_F = ((opt == 'y' || opt == 'Y') ? true : false);
	cout<<"Save Source ?(y/n) - ";
	cin>>opt; buff_F = ((opt == 'y' || opt == 'Y') ? true : false);
	cout<<'\n';
}

CWLHtmlVirtualQueue globalQ;
CWLDocument         globalDoc;

int main(int argc, char* argv[])
{
	if (argc < 2) {
		cout << "Usage: parsetest <html file name> [b]" << endl;
		exit(0);
	}

	if (argc > 2){
		if(argv[2][0] == 'b')
			numOfBytes = 1;
	}

	fp = fopen(argv[1], "r+");
	if (!fp) {
		cout << "Can't open file:" << argv[1] << endl;
		exit(-1);
	}

	char TraceProgram[50] = "HttpLoad";
	CTraceMsg::Init (TraceProgram) ;
	frameContainer frameCont(&globalQ);
	RVCString name("name");
	RVCString frameName("NO_FRAME_NAME");
	RVCString url("http://server") ;
	char buff[1025];
	bool src_F = 1, href_F = 1, form_F = 1, buff_F = 1, table_F = 1, script_F = 1, xml_F = 1;
  determineFlags_(src_F, href_F, form_F, buff_F, table_F, script_F, xml_F);
  //! You can determine flags for the parsing here.
	CWLUserParseFlags parseFlags;
	parseFlags.m_Parse = CWLUserParseFlags::ParseAlways;
	parseFlags.m_ParseContents	= src_F;
	parseFlags.m_ParseLinks			= href_F;
	parseFlags.m_ParseForms			= form_F;
	parseFlags.m_SaveSource			= buff_F;
	parseFlags.m_ParseTables		= table_F;
	parseFlags.m_ParseScripts		= script_F;
	parseFlags.m_ParseXml			= xml_F;
	parseFlags.m_VerifyXml			= true;
	parseFlags.m_ParseInnerHTML		= true;

	//! Creation of the Empty Document object
	CWLDocument myDoc(name,frameName, url, RVCString("origUrl"), "topId","topTarget",
              parseFlags, &frameCont, NULL);
	long seconds = 0;
	unsigned short millis = 0;
	long totalms = 0;
#ifndef __TV_UNIX__
	struct _timeb timebuffer1,timebuffer2 ;
#else
        struct timeb timebuffer1,timebuffer2 ;
#endif

	//! begins to read a HTML file and parse on the fly
	do {
		int num = fread(buff, 1, numOfBytes, fp);
		buff[num] = '\0';
#ifndef __TV_UNIX__
		_ftime( &timebuffer1 );
#else
                ftime( &timebuffer1 );
#endif
		myDoc.parse(buff, num); //! the parsing is performing here
#ifndef __TV_UNIX__
		_ftime( &timebuffer2);
#else
                ftime( &timebuffer2 );
#endif
		seconds += timebuffer2.time - timebuffer1.time;
		millis  += timebuffer2.millitm - timebuffer1.millitm;
		totalms += 1000 * (timebuffer2.time - timebuffer1.time) + (timebuffer2.millitm - timebuffer1.millitm);
	} while (!feof(fp));

	//! Now all DOM is built and you can access objects.
	char c = 'y';
	size_t choice;
	cout<<"Total parsing time for: - XMLS -"<<
		(href_F?" LINKS -":"") <<(src_F?" IMAGES -":"")<<(form_F?" FORMS -":"")<<(table_F?" TABLES -":"")<<(script_F?" SCRIPTS - ":"")<<
		"in the page: "<<seconds<<'.'<<millis<<" seconds. Totalms: " << totalms <<"\n\n";
	cout<<"Document Title: "	<<myDoc.GetTitle()<<endl<<endl;
	size_t i;
	char patBuff[100];
	while(c =='y' || c == 'Y')
	{
		//! The main menu 
		/*! As the rule almost each object contains printAll() procedure
			So for looking as performing access to some property
			look at the method in appropriate object.
		*/
		cout<<"\nMENU - HTMLPARSE"<<endl;
		cout<<"================"<<endl;
		cout<<"what would you like to be printed:"<<endl;
		cout<<"1) Link(s)"<<endl;
		cout<<"2) Form(s)"<<endl;
		cout<<"3) Frame(s)"<<endl;
		cout<<"4) Image(s)"<<endl;
		cout<<"5) Table(s)"<<endl;
		cout<<"6) Script(s)"<<endl;
		cout<<"7) Xml(s)"<<endl;
		cout<<"8) Meta(s)"<<endl;
		cout<<"9) Html Source"<<endl;
		cout<<"10) Applet(s)"<<endl;
		cout<<"11)Embed(s)"<<endl;
		cout<<"12)TransactionObject(s)"<<endl;
		cout<<"0) Exit"<<endl<<endl;;
		cout<<"Enter your choice(0 - 9): ";
		cin>>choice;
		while(choice < 0 || choice > 12){
			cout<<"\nIllegal choice, Please enter a choice in the range (1 - 12).\n";
			cin>>choice;
			continue;
		}
		cout<<endl;
		switch(choice)
		{
		case 1: //! LINK object
			if(!myDoc.m_Links){
				cout<<"No Parsing of links requested !"<<'\n';
				break;
			}
			cout<<"\nLINKS: (Total - "<<(myDoc.m_Links)->entries()<<" Links)"<<endl<<endl;
			if(!(myDoc.m_Links)->entries())
				break;
			cout<<"\nMENU - LINKS"<<endl;
			cout<<"============"<<endl;
			cout<<"what would you like to do:"<<endl;
			cout<<"1) GetLinkByIndex(index)"<<endl;
			cout<<"2) GetLinkByName(pat)"<<endl;
			cout<<"3) GetLinkByUrl(pat)"<<endl;
			cout<<"4) Print all links in page"<<endl;
			cout<<"enter your choice(1 - 4)";
			cin>>choice;
			switch(choice){
				case(1):
					while(c == 'y' || c == 'Y'){
						cout<<"Please enter Link Index: ";
						cin>>choice;
						if(choice > -1 && choice < (myDoc.m_Links)->entries()){
							cout<<"Link["<<choice<<']'<<endl;
							cout<<"======="<<(choice > 10?"=":"")<<(choice > 100?"=":"")<<endl;
							(*(CWLLink*)(*(CWLLinkArray*)(myDoc.m_Links))[choice]).printAll();
						}
						else
							cout<<"Index of Link greater than number of links in page !\n";
						cout<<"\nWould you like to select another Index (y/n)? ";
						cin>>c;
					}
					break;

				case(2):
				case(3):
					while(c == 'y' || c == 'Y'){
						cout<<"Please Enter pattern: ";
						cin>>patBuff;
						CWLLink* pUrlObj;
						int noLinkExists;
						if(choice == 2)
							noLinkExists = (myDoc.m_Links)->findEntryByInnerHTMLMatch(patBuff, &pUrlObj);
						else
							noLinkExists = (myDoc.m_Links)->findEntryByUrlMatch(patBuff, &pUrlObj);
						if(!noLinkExists)
							pUrlObj->printAll();
						else
							cout<<"\nPattern cannot be matched !\n";
						cout<<"Would you like to select another pattern (y/n)? ";
						cin>>c;
					}
					break;
				case(4):
					for( size_t i = 0; i < (myDoc.m_Links)->entries();i++)
					{
						(*(CWLLink*)(*(CWLLinkArray*)(myDoc.m_Links))[i]).printAll();
						cout<<"Press any key to continue..."<<endl;
						GETCH();
					}
					break;
			}
			break;
		case 2:
			if(!myDoc.m_Forms){
				cout<<"No Parsing of form requested !"<<'\n';
				break;
			}
			cout<<"FORMS: (Total - "<<(myDoc.m_Forms)->entries()<<" Forms)"<<endl<<endl;
			if(!(myDoc.m_Forms)->entries())
				break;
			cout<<"\nMENU - FORMS"<<endl;
			cout<<"============"<<endl;
			cout<<"what would you like to do:"<<endl;
			cout<<"1) Print One Form - find form by Index\n";
			cout<<"2) Print One Form - find form by Name\n";
			cout<<"3) Print all forms in page\n";
			cout<<"Please enter your choice(1 - 3): ";
			cin>>choice;
			switch(choice){
				case(1):
					while(c == 'y' || c == 'Y'){
						cout<<"Please enter index of form: ";
						cin>>choice;
						if(choice > -1 && choice < (myDoc.m_Forms)->entries()){
							cout<<"Form["<<choice<<']'<<endl;
							cout<<"======="<<(choice > 10?"=":"")<<(choice > 100?"=":"")<<endl;
							(*(CWLForm*)(*(formList*)(myDoc.m_Forms))[choice]).printAll();
						}
						else
							cout<<"\nIndex of Image greater than number of links in page !\n";
						cout<<"Would you like to select another Index (y/n)? ";
						cin>>c;
					}
					break;
				case(2):
					while(c == 'y' || c == 'Y'){
						cout<<"Please enter Name of form: ";
						cin>>patBuff;
						cout<<"Form["<<patBuff<<']'<<endl;
						cout<<"=======";
						for(size_t ct = 0; ct < strlen(patBuff); ct++)
							cout<<'=';
						cout<<'\n';
						CWLForm* pForm;
						if(pForm = (myDoc.m_Forms)->Form(patBuff))
							pForm->printAll();
						else
							cout<<"No Form by this name found !\n";
						cout<<"Would you like to select another Name (y/n)? ";
						cin>>c;
					}
					break;
				case(3):
					for(size_t i= 0; i < (myDoc.m_Forms)->entries();i++)
					{
						cout<<"Form["<<i<<']'<<endl;
						cout<<"======="<<(i > 10?"=":"")<<(i > 100?"=":"")<<endl;
						(*(CWLForm*)(*(formList*)(myDoc.m_Forms))[i]).printAll();
						cout<<"Press any key to continue..."<<endl;
						GETCH();
					}
					break;
			}
			break;
		case 3:
			cout<<"FRAMES: (Total - "<<(myDoc.m_Frames)->entries()<<" Frames)"<<endl;
			if(!(myDoc.m_Frames)->entries())
				break;
			for(i= 0; i < (myDoc.m_Frames)->entries();i++)
			{
				(myDoc.m_Frames)->printAll();
				cout<<"Press any key to continue..."<<endl;
				GETCH();
			}
			break;
		case 4:
			if(!myDoc.m_SrcList){
				cout<<"No Parsing of images requested !"<<'\n';
				break;
			}
			cout<<"IMAGES: (Total - "<<(myDoc.m_SrcList)->entries()<<" Images)"<<endl;
			if(!(myDoc.m_SrcList)->entries())
				break;
			cout<<"MENU - IMAGES"<<endl;
			cout<<"============"<<endl;
			cout<<"what would you like to do:"<<endl;
			cout<<"1) Print one Image - find image by Index\n";
			cout<<"2) Print one Image - find image by Name\n";
			cout<<"3) Print all images in page\n";
			cin>>choice;
			switch(choice){
				case(1):
					while(c == 'y' || c == 'Y'){
						cout<<"Please enter index of Image: ";
						cin>>choice;
						if(choice > -1 && choice < (myDoc.m_SrcList)->entries()){
							cout<<"Image["<<choice<<']'<<endl;
							cout<<"======="<<(choice > 10?"=":"")<<(choice > 100?"=":"")<<endl;
							((CWLLocation*)((myDoc.m_SrcList)->at(choice)))->printAll();
						}
						else
							cout<<"Index of Image greater than number of images in page !\n";
						cout<<"Would you like to select another Index (y/n)? ";
						cin>>c;
					}
					break;
				case(2):
					while(c == 'y' || c == 'Y'){
						cout<<"Please enter Name of Image: ";
						cin>>patBuff;
						cout<<"Image["<<patBuff<<']'<<endl;
						cout<<"=======";
						for(size_t ct = 0; ct < strlen(patBuff); ct++)
							cout<<'=';
						cout<<'\n';
						CWLEmbed* image;
						if(image = myDoc.m_SrcList->Src(patBuff))
							image->printAll();
						else
							cout<<"No Image by this name found !\n";
						cout<<"Would you like to select another Index (y/n)? ";
						cin>>c;
					}
					break;
				case(3):{
				  for (i = 0; i < (myDoc.m_SrcList)->entries(); i++){
						cout<<"Image["<<i<<']'<<endl;
						cout<<"========"<<(i > 10?"=":"")<<(i > 100?"=":"")<<endl;
						CWLLocation* value =(CWLLocation*)((myDoc.m_SrcList)->at(i));
						value->printAll();
						cout<<"Press any key to continue..."<<endl;
						GETCH();
					}
								}
				default:
					break;
			}
			break;
		case 5:
			{
			if(!myDoc.m_Tables){
				cout<<"No Parsing of tables requested !"<<'\n';
				break;
			}
			cout<<"TABLES: (Total - "<<(myDoc.m_Tables)->entries()<<" Tables)"<<endl;
			if(!(myDoc.m_Tables)->entries())
				break;
			CWLTable  *t;
			RVOrderedIterator tables(*(myDoc.m_Tables));
			int tableCounter = 0;
			while(t = (CWLTable*)tables()){
				cout<<"Table["<<tableCounter++<<']'<<endl;
				cout<<"========"<<(tableCounter > 10?"=":"")<<(tableCounter > 100?"=":"")<<endl;
				cout<<*t;
				cout<<"Press any key to continue..."<<endl;
				GETCH();
			}
			}
			break;
		case(6):
			if(!myDoc.m_Scripts){
				cout<<"No Parsing of scripts requested !"<<'\n';
				break;
			}
			cout<<"SCRIPTS: (Total- "<<(myDoc.m_Scripts)->entries()<<" Scripts)"<<endl;
			if(!(myDoc.m_Scripts)->entries())
				break;
			cout<<"MENU - SCRIPTS"<<endl;
			cout<<"============="<<endl;
			cout<<"what would you like to do:"<<endl;
			cout<<"1) Print one Script - find script by Index\n";
			cout<<"2) Print all scripts in page\n";
			cin>>choice;
			switch(choice){
				case(1):
					while(c == 'y' || c == 'Y'){
						cout<<"Please enter index of Script: ";
						cin>>choice;
						if(choice > -1 && choice < (myDoc.m_Scripts)->entries()){
							cout<<"Script["<<choice<<']'<<endl;
							cout<<"========"<<(choice > 10?"=":"")<<(choice > 100?"=":"")<<endl;
							((CWLScript*)((myDoc.m_Scripts)->at(choice)))->printAll();
						}
						else
							cout<<"Index is greater than number of script objects in page !\n";
						cout<<"Would you like to select another Index (y/n)? ";
						cin>>c;
					}
					break;
				case(2):
					for(i = 0; i < (myDoc.m_Scripts)->entries(); i++){
						cout<<"Script["<<i<<']'<<endl;
						cout<<"========="<<(i > 10?"=":"")<<(i > 100?"=":"")<<endl;
						((CWLScript*)((myDoc.m_Scripts)->at(i)))->printAll();
						cout<<"Press any key to continue..."<<endl;
						GETCH();
					}
					break;
				default:
					break;
			}
			break;
		case(7):
			if(!myDoc.m_Xmls){
				cout<<"No Parsing of XML islands requested !"<<'\n';
				break;
			}
			cout<<"XMLS: (Total- "<<(myDoc.m_Xmls)->entries()<<" Xmls)"<<endl;
			if(!(myDoc.m_Xmls)->entries())
				break;
			cout<<"MENU - XMLS"<<endl;
			cout<<"============="<<endl;
			cout<<"what would you like to do:"<<endl;
			cout<<"1) Print one Xml Data Island - find xml by Index\n";
			cout<<"2) Print all Xml Data Island in page\n";
			cin>>choice;
			switch(choice){
				case(1):
					while(c == 'y' || c == 'Y'){
						cout<<"Please enter index of Xml: ";
						cin>>choice;
						if(choice > -1 && choice < (myDoc.m_Xmls)->entries()){
							cout<<"Xml["<<choice<<']'<<endl;
							cout<<"========"<<(choice > 10?"=":"")<<(choice > 100?"=":"")<<endl;
							((CWLXmlDocument*)((myDoc.m_Xmls)->at(choice)))->printAll();
						}
						else
							cout<<"Index is greater than number of xml objects in page !\n";
						cout<<"Would you like to select another Index (y/n)? ";
						cin>>c;
					}
					break;
				case(2):
					for(i = 0; i < (myDoc.m_Xmls)->entries(); i++){
						cout<<"Xml["<<i<<']'<<endl;
						cout<<"======"<<(i > 10?"=":"")<<(i > 100?"=":"")<<endl;
						((CWLXmlDocument*)((myDoc.m_Xmls)->at(i)))->printAll();
						cout<<"Press any key to continue..."<<endl;
						GETCH();
					}
					break;
				default:
					break;
			}
			break;

		case(8):
			if( myDoc.m_MetaTags->entries() )
				myDoc.m_MetaTags->printAll();
			break;

		case(9):
			if(!myDoc.m_HtmlPagePtr){
				cout<<"HTML source not saved !"<<'\n';
				break;
			}
			cout<<"HTML SOURCE: (LENGTH - "<< myDoc.m_HtmlPagePtr->length()<<" Bytes)"<<endl;
			cout<<myDoc.m_HtmlPagePtr->data()<<endl;
			break;

		case(10):
			if(!myDoc.m_AppletList){
				cout<<"No Parsing of applets requested !"<<'\n';
				break;
			}
			cout<<"APPLETS: (Total- "<<(myDoc.m_AppletList)->entries()<<" Applets)"<<endl;
			if(!(myDoc.m_AppletList)->entries())
				break;
			cout<<"MENU - APPLETS"<<endl;
			cout<<"============="<<endl;
			cout<<"what would you like to do:"<<endl;
			cout<<"1) Print one Applet - find applet by Index\n";
			cout<<"2) Print all applets in page\n";
			cin>>choice;
			switch(choice){
				case(1):
					while(c == 'y' || c == 'Y'){
						cout<<"Please enter index of Applet: ";
						cin>>choice;
						if(choice > -1 && choice < (myDoc.m_AppletList)->entries()){
							cout<<"Applet["<<choice<<']'<<endl;
							cout<<"========"<<(choice > 10?"=":"")<<(choice > 100?"=":"")<<endl;
							((CWLApplet*)((myDoc.m_AppletList)->at(choice)))->printAll();
						}
						else
							cout<<"Index is greater than number of applet objects in page !\n";
						cout<<"Would you like to select another Index (y/n)? ";
						cin>>c;
					}
					break;
				case(2):
					for(i = 0; i < (myDoc.m_AppletList)->entries(); i++){
						cout<<"Applet["<<i<<']'<<endl;
						cout<<"========="<<(i > 10?"=":"")<<(i > 100?"=":"")<<endl;
						((CWLApplet*)((myDoc.m_AppletList)->at(i)))->printAll();
						cout<<"Press any key to continue..."<<endl;
						GETCH();
					}
					break;
				default:
					break;
			}
			break;

		case(11):
			if(!myDoc.m_EmbedList){
				cout<<"No Parsing of embeds requested !"<<'\n';
				break;
			}
			cout<<"EMBEDS: (Total- "<<(myDoc.m_EmbedList)->entries()<<" Embeds)"<<endl;
			if(!(myDoc.m_EmbedList)->entries())
				break;
			cout<<"MENU - EMBEDS"<<endl;
			cout<<"============="<<endl;
			cout<<"what would you like to do:"<<endl;
			cout<<"1) Print one Embed - find embed by Index\n";
			cout<<"2) Print all embeds in page\n";
			cin>>choice;
			switch(choice){
				case(1):
					while(c == 'y' || c == 'Y'){
						cout<<"Please enter index of Embed: ";
						cin>>choice;
						if(choice > -1 && choice < (myDoc.m_EmbedList)->entries()){
							cout<<"Embed["<<choice<<']'<<endl;
							cout<<"========"<<(choice > 10?"=":"")<<(choice > 100?"=":"")<<endl;
							((CWLEmbed*)((myDoc.m_EmbedList)->at(choice)))->printAll();
						}
						else
							cout<<"Index is greater than number of embed objects in page !\n";
						cout<<"Would you like to select another Index (y/n)? ";
						cin>>c;
					}
					break;
				case(2):
					for(i = 0; i < (myDoc.m_EmbedList)->entries(); i++){
						cout<<"Embed["<<i<<']'<<endl;
						cout<<"========="<<(i > 10?"=":"")<<(i > 100?"=":"")<<endl;
						((CWLEmbed*)((myDoc.m_EmbedList)->at(i)))->printAll();
						cout<<"Press any key to continue..."<<endl;
						GETCH();
					}
					break;
				default:
					break;
			}
			break;

		case 12: //! Transaction Objects
			{
			CWLTransactionsObject*pCurTO;
			RVCString &source = *myDoc.m_HtmlPagePtr;
			cout<<"Transaction Objects: "<<endl;
			cout<<"Transaction Objects of The Document: "<<endl;
			for( pCurTO = myDoc.GetFirstTransactionObj(); 
				   pCurTO != NULL; 
				   pCurTO = myDoc.GetNextTransactionObj()) {
				cout << "OrigUrl: " << pCurTO->GetOriginalUrl() << endl;
				RVCString url = source(pCurTO->GetUrlOffset(), 50);
				cout << "Url : " << url << endl;
				cout<<"Press any key to continue..."<<endl;
				GETCH();
			}
			}
			/*if(!(myDoc.m_Frames)->entries())
				break;
			for(i= 0; i < (myDoc.m_Frames)->entries();i++)
			{
				pCurTO = GetFirstTransactionObj();
				CWLTransactionsObject
				cout<<"Press any key to continue..."<<endl;
				GETCH();
			}*/
			break;

		case(0):
			return 1;
		default:
			break;
		}

		cout<<"Would you like to continue(y/n)? ";
		cin>>c;
	}
	fclose(fp);
	return 0;
}
