/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// WLInsecureConnection.h: interface for the CWLInsecureConnection class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WLINSECURECONNECTION_H__89F52BC2_E2AE_44E5_9CE4_DDF9CF968785__INCLUDED_)
#define AFX_WLINSECURECONNECTION_H__89F52BC2_E2AE_44E5_9CE4_DDF9CF968785__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WLGenericConnection.h"

class CWLInsecureConnection : public CWLGenericConnection  
{
public:
	/* Constructor and destructor */
	CWLInsecureConnection( CWLHttpRequest* pHttpReq );
	CWLInsecureConnection( CWLGenericConnection* pConnection );

	virtual ~CWLInsecureConnection();

	/* Public methods */
public:
	virtual bool Init( CWLCommandManager* cm, CWLConnectionsPool* cp, int socketDescriptor, bool createNewSession = false, const char* certFileName = NULL );
	virtual int Connect();
	virtual int Send( const char* buffer, int length, int threadNum = 0 );
	virtual int Recv( char* buffer, int* buffsize, int flags, int* err_code, bool* closed, int threadNum = 0 );
	virtual void CloseConnection();
	virtual void CleanUp();

	/* Data members */
private:
#ifdef TRANSPORT_LAYER_TRACE
	FILE* m_File;
	static int m_FileNum;
#endif // TRANSPORT_LAYER_TRACE

};

#endif // !defined(AFX_WLINSECURECONNECTION_H__89F52BC2_E2AE_44E5_9CE4_DDF9CF968785__INCLUDED_)
