/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*****************************************************************************
    
    File : GetHostIP.h
    Declaration of class GetHostIP.
    For multi platform use, Unix, Windows, Linux.
    Getting all IP addresses from system, allocating memory, and saving
    them in a list. returning each address on demand.
    Author :  Yossi Nakash.
    Date   :  4.7.2000
    Dependencies : On windows: files MibAccess.h, MibAccess.cpp, and
                   libraries : Ws2_32.lib Snmpapi.lib
                   On Unix   : on compiling add -lnsl -lsocket (links)

*****************************************************************************/

#ifndef _GET_HOST_IP_H
#define _GET_HOST_IP_H

#ifndef __TV_UNIX__
#define ExportDll __declspec(dllexport)
#else
#define ExportDll
#endif

#define SIZE_OF_BUFFER 400000


class ExportDll GetHostIP
{
  public:
    GetHostIP();
    virtual ~GetHostIP();
    int GetIPAddress();
    int GetNum() {return m_nIPNum;}
    int GetHeadPosition() {return 0;}
    int GetTailPosition() {return m_nIPNum-1;}
    bool IsExist(int nPos){ return (nPos >= 0 && nPos < m_nIPNum) ;}
    struct in_addr* GetAt(int nPos);
    struct in_addr* GetNext(int &nPos);
    struct in_addr* GetPrev(int &nPos);
    char* GetAtStr(int nPos);
    char* GetNextStr(int &nPos);
    char* GetPrevStr(int &nPos);
	  int DeleteAddr(const char *pcAddr);
    int DeleteAddr(const struct in_addr& pAddr);
	  static char* AddrToStr(const struct in_addr& Addr);
	  static struct in_addr StrToAddr(const char* pcAddr);


  protected:
    void AddIPToList(const struct in_addr& IP);
    int m_nIPNum ;
    struct in_addr **m_pIPList;


};



#endif /* _GET_HOST_IP_H */
