/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*
 * File name : httpheaderhandler.h
 * Author    : Yossi Nakash
 * Created   : 3/14/01
 * ==========:
 * Abstract  : handles http headers.
 *
 * Version control stuff:
 * $Revision:: 1        $
 * $Author::            $
 */

#ifndef HTTPHEADERHANDLER_H
#define HTTPHEADERHANDLER_H

class CHLHeaderHandler {
public:
  CHLHeaderHandler();
  virtual ~CHLHeaderHandler();

public:
#ifndef __GNUC__
  // ATTENTION GNU compiler does not knwo how to handle static enum definitions
  // so we omit the static ONLT from GNU 
  static 
#endif __GNU__
    enum HttpHeaders{
      EN_HEADER_NONE,
      EN_HEADER_ACCEPT,
      EN_HEADER_ACCEPT_ENCODING,
      EN_HEADER_AUTHENTICATE,
      EN_HEADER_AUTHORIZATION,
      EN_HEADER_CONNECTION,
      EN_HEADER_CONTENT_LENGTH,
      EN_HEADER_CONTENT_TYPE,
      EN_HEADER_CONTENT_ENCODING,
      EN_HEADER_COOKIE,
      EN_HEADER_COOKIE_RESPONSE,
			EN_HEADER_DATE,
			EN_HEADER_ETAG,
			EN_HEADER_EXPIRES,
      EN_HEADER_HOST,
      EN_HEADER_IF_MODIFIED_SINCE,
			EN_HEADER_LAST_MODIFIED,
      EN_HEADER_LOCATION,
      EN_HEADER_PROXY_AUTHENTICATE,
      EN_HEADER_PROXY_AUTHORIZATION,
      EN_HEADER_PROXY_CONNECTION,
      EN_HEADER_REFERER,
      EN_HEADER_TRANSFER_CODING,
      EN_HEADER_TRANSFER_ENCODING,
      EN_HEADER_USER_AGENT,
      EN_TOKEN_BASIC,
      EN_TOKEN_CHUNKED,
      EN_TOKEN_CLOSE,
      EN_TOKEN_KEEP_ALIVE,
      EN_TOKEN_NTLM
  };

  static CHLHeaderHandler::HttpHeaders GetHeaderId(const char* p_pcHeader);

private:
  // avoid copy ctor & asignment operator
  CHLHeaderHandler( const CHLHeaderHandler& src );
  CHLHeaderHandler& operator=( const CHLHeaderHandler& src );

};

/*
EN_HEADER_ACCEPT								"accept"
EN_HEADER_AUTHENTICATE					"www-authenticate"
EN_HEADER_AUTHORIZATION				"authorization"
EN_HEADER_CONNECTION						"connection"
EN_HEADER_CONTENT_LENGTH				"content-length"
EN_HEADER_CONTENT_TYPE					"content-type"
EN_HEADER_COOKIE								"cookie"
EN_HEADER_HOST									"host"
EN_HEADER_IF_MODIFIED_SINCE		"if-modified-since"
EN_HEADER_LOCATION							"location"
EN_HEADER_PROXY_AUTHENTICATE   "proxy-authenticate"
EN_HEADER_PROXY_AUTHORIZATION  "proxy-authorization"
EN_HEADER_PROXY_CONNECTION			"proxy-connection"
EN_HEADER_REFERER              "referer"
EN_HEADER_TRANSFER_CODING      "transfer-coding"
EN_HEADER_TRANSFER_ENCODING    "transfer-encoding"
EN_HEADER_USER_AGENT						"user-agent"
*/

#endif // HTTPHEADERHANDLER_H
