/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <RVCString.h>

class CWLPrivate {
private:
	RVCString     m_TypeName;			          // type/class name of object
	void*         m_CPP_RealObject;	        // pointer to the real C++ object
	bool          m_IsJSCreatedObject;	    // delete  curr with destructor or not (for objects that are created on the fly)
	CWLDocument*  m_Parent;		              // pointer to the top frame (the document)

public:
	CWLPrivate(const char* objTypeName, void* objCPP_Ptr, CWLDocument* Parent, bool del = false);
	~CWLPrivate();

	const char*  name();
	void*        GetObj();
	CWLDocument* GetParent();
	bool				 IsObjectJSCreated();
};
