/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/******************************************************************\
 *	File name : wlsslcache.h
 *
 *	Author : Zion Menahem
 *
 *	Description : 
 *
 *	History : 
 *
 *	Modifications : 
 *		Who				When				What
 *		---				----				----
 *
\******************************************************************/

#ifndef _WLSSLCACHE_H_
#define _WLSSLCACHE_H_

/** include files **/
#include <hashdict.h>
#include "platform.h"

/** local definitions **/
typedef unsigned long ulong;
typedef unsigned char uchar;

typedef struct {
	ulong length;
	uchar* data;
} WLSSLBuffer;


/** default settings **/

/** external functions **/

/** external data **/

/** internal functions **/

/** public data **/

/** private data **/

/** public functions **/

/** private functions **/

/** classes definitions **/
class CWLSslConnection;
class CWLConnectionsPool;
class CWLSSLContext;

class CWLDBRef {
public:
	CWLConnectionsPool* cp;
	CWLSSLContext* ctx;

public:
	CWLDBRef() { cp = NULL; ctx = NULL; }
	CWLDBRef(CWLConnectionsPool* CP, CWLSSLContext* CTX) { cp = CP; ctx = CTX; }
	~CWLDBRef() {}
};


class DllExport WLSSLRecord : public RVCollectable {
private:
	ulong dataLength;
	uchar* dataBuffer;
public:
	WLSSLRecord() { dataLength = 0; dataBuffer = NULL; }
	WLSSLRecord(SSLBuffer& key);
	virtual ~WLSSLRecord();

	virtual int compareTo(const RVCollectable*) const;
	virtual bool isEqual(const RVCollectable*) const;
	virtual unsigned hash() const;
	ulong DataLength() { return dataLength; }
	uchar* DataBuffer() { return dataBuffer; }
};

#endif	// _WLSSLCACHE_H_
