
asmInitialize();



function asmInitialize()
{
	createJSReservedWordsTable();
	wlGlobals.TurnOffASM = turnOffAsm;
	wlGlobals.TurnOnASM = turnOnAsm;

  //Aviad - it is also hardcoded in HTTPLOAD
	wlGlobals.Parse = "Yes";
	wlGlobals.ParseLinks = true;
	wlGlobals.ParseForms = true;
	wlGlobals.ParseMetas = true;
	wlGlobals.GetFrames = true;
	wlGlobals.AsmOn = true;

	if( typeof wlGlobals.AsmDiagnostics != "undefined" && wlGlobals.AsmDiagnostics == true )
	{
		InfoMessage("Automatic State Management Diagnostics is turned ON");
		EvaluateScript("ASM_InitClient(); turnOnAsmVerbose();",WLBeforeInitClient);
	}
	else
		EvaluateScript("ASM_InitClient();",WLBeforeInitClient);
}


function ASM_InitClient()
{
	wlHttp.IdentifyObject = identifyObject;
	wlHttp.GetCurrentValue = getCurrentValue;
	// Function Added by Shahar - to support sending hidden fields from dom
	wlHttp.SetCurrentHiddenValues = SetCurrentHiddenValues;
}

function identifyObject_Verbose(url)
{
  if( ! wlGlobals.AsmOn )
    return url;

  InfoMessage("IdentifyObject is looking for the URL: "+url);
  ret = this.IdentifyObjectOrig(url);
  if( this.identifyObjectFlag )
    if( ret == url )
      InfoMessage("IdentifyObject found the exact URL.");
    else
      InfoMessage("IdentifyObject found: "+ret);
  else
    InfoMessage("IdentifyObject did not find the URL. The recorded URL will be used.")
  return ret;
}


function identifyObject(url)
{
  this.identifyObjectFlag = false;
  //TraceMsg("In identifyObject")
  if( ! wlGlobals.AsmOn )
    return url;
  
  if( typeof this.ExpectedText == "undefined" ||
      typeof this.ExpectedName == "undefined" ||
      typeof this.ExpectedID   == "undefined"  )
    return url;
  
  this.ActualObject = "";
  var matcher = new WLLink(url,this.ExpectedText,this.ExpectedName,this.ExpectedID);
  if ( typeof matcher == "undefined" )
    return url;
  // find the location
  if( typeof this.ExpectedLocation != "undefined" && this.ExpectedLocation != "" )
  {
    locArray = this.ExpectedLocation.split(":",2);
    if ( locArray[0] != "" )
      originFrame = wlHtml.GetFrameByLocation(locArray[0]);
    else
      originFrame = document;

    wlHttp.Referer = originFrame.location.href ;

    if( typeof originFrame == "undefined" ) // error in GetFrameByLocation
      return url;
    
    originLocation = Number(locArray[1]);
  }
  else if( typeof this.Type == "undefined" || this.Type != "META" )
    return url;  // temporary. Need to enumarate on all frames.
  
  if ( typeof this.Type != "undefined" )
    switch ( this.Type )
    {
      case "FORM" :
        if ( typeof originFrame.forms == "undefined" ||
             originFrame.forms.length == 0 )
          return url;
        
        res = originFrame.IdentifyForm(matcher,originLocation);
        break;
      case "A" :
      case "AREA" :
      case "MAP" :
        if ( typeof originFrame.links == "undefined" ||
             originFrame.links.length == 0 )
          return url;
        
        res = originFrame.IdentifyLink(matcher,originLocation);
        break;
        
      case "META" :
        originFrame = document;
	//TraceMsg("In META");
        if( typeof originFrame.wlMetas == "undefined" ||
            originFrame.wlMetas.length == 0 )
          return url;
        else
        {
          res = "";
          for(i = 0 ; i < originFrame.wlMetas.length ; i++) {
            //TraceMsg("i: " + i + originFrame.wlMetas[i].URL);				
            if( typeof originFrame.wlMetas[i].URL != "undefined" )
            {
              res = originFrame.wlMetas[i].URL;
              break;
            }
          }
          if( res == "" )
            return url;
        }
        break
        
        default :
          return url;
    }
  else
    return url;
  
  if( typeof res == "undefined" )
    return url;
  else
    this.ActualObject = res;

  this.identifyObjectFlag = true;
  this.ExpectedUrl = url;
  if( this.Type == "FORM" ) // a form
    return this.ActualObject.action.toString();
  else if( this.Type == "MAP" ) // a server-side Image Map
    return this.ActualObject.href.toString()+"?"+matcher.search;  // add the coordinates
  else
    return this.ActualObject.href.toString();
}

function getCurrentValue_Verbose(fieldName,defaultValue)
{
  if( !wlGlobals.AsmOn )
    return defaultValue;

  InfoMessage("GetCurrentValue for: "+fieldName+". Default value is: "+defaultValue);
  ret = this.GetCurrentValueOrig(fieldName,defaultValue);
  if ( this.getCurrentValueFlag )
    if ( ret == defaultValue )
      InfoMessage("GetCurrentValue for: "+fieldName+" returned the same value.");
    else
      InfoMessage("GetCurrentValue for: "+fieldName+" returned: "+ret);
  else
    InfoMessage("GetCurrentValue did not find "+fieldName+". The recorded value will be used.");
  return ret;
}


function getCurrentValue(fieldName,defaultValue)
{
  this.getCurrentValueFlag = false;
  if( !wlGlobals.AsmOn )
    return defaultValue;
  
  if( this.Type != "FORM" || typeof this.ActualObject == "undefined" || this.ActualObject == "" )
    return defaultValue;
  
  fieldObj = getField(this.ActualObject.elements,fieldName);
  if( typeof fieldObj == "undefined" )
    return defaultValue;
  
  // If the type of the field is not hidden then we just return it's default value given
  // else we continue to check for it's value
  if (fieldObj.type.toLowerCase() != "hidden")
    return defaultValue;

  this.getCurrentValueFlag = true;
  val = fieldObj.value
  if( val == "" ) {
      if (defaultValue == "")
        return "$WL$EMPTY$STRING$";
      else
        return defaultValue;
  } else
    return val;
}

// GetField check that we will not get to a reserved property of an element
// if the name of the field is equal to such ...
function getField(obj,fieldName)
{
  if( typeof JSReservedWordsTable[fieldName] != "undefined" )  // key is a reserved word
    return obj.wlGet(fieldName);
  else
    return obj[fieldName];
}

// Function Added by Shahar - to support sending hidden fields from dom
function SetCurrentHiddenValues(form) {

	if (typeof form != "undefined") {
		this.ActualObject = form
		if (typeof this.ActualObject.elements == "undefined") 
			return
	}
	else {
	
		if( !wlGlobals.AsmOn )
			return

		if( this.Type != "FORM" || typeof this.ActualObject == "undefined" || this.ActualObject == "" )
			return
	}
	
	var fieldName = ""
	var fieldValue = ""
  
	for (var i=0; i< this.ActualObject.elements.length; i++) {
			// If the type of the field is hidden then we send it
			if (this.ActualObject.elements[i].type.toLowerCase() == "hidden") {
				fieldKey = this.ActualObject.elements[i].name
				fieldValue = this.ActualObject.elements[i].value
//	      InfoMessage("wlSetCurrentHiddenValues (name=value): "+fieldKey+"="+fieldValue);
				if (typeof JSReservedWordsTable[fieldKey] != "undefined" ) {
					// if the key is a reserved word then we use the set key
					wlHttp.FormData.wlSet(fieldKey , fieldValue)
				}
				else {
					// else we set it in regular way
					wlHttp.FormData[fieldKey] = fieldValue
				}
			}
	}
}

function turnOnAsm()
{
  this.AsmOn = "Yes";
}

function turnOffAsm()
{
  this.AsmOn = "No";
}

function turnOnAsmVerbose()
{
  wlHttp.IdentifyObjectOrig = identifyObject;
  wlHttp.GetCurrentValueOrig = getCurrentValue;
  wlHttp.IdentifyObject = identifyObject_Verbose;
  wlHttp.GetCurrentValue = getCurrentValue_Verbose;
}

function turnOffAsmVerbose()
{
  wlHttp.IdentifyObject = identifyObject;
  wlHttp.GetCurrentValue = getCurrentValue;
}



//*******************************
//   MULTIPART OBJ
//*******************************


// This function defines the MultipartObj Object.
// This object may be used for manipulating data of post requests with Content type of
// "multipart/form-data".
//
// INPUT Parameters:
//   piTemplateFile       (Mandatory) - The name and full path of a multipart datafile that was created by the AAT. 
//				                        This file will be used as a template file. 
//   Attachment files,... (Optional)  - A list of TEXT attachment file names that may be used by the different clients.
//
// Example of creating an instance of the object:
//   wlGlobals.MyMultipart = new MultipartObj ( TemplateFileName, AttachmentFile1, AttachmentFile2) 
//
// METHODS (of this object):
//   UpdateMultipartFields - This method should ne called just before the post command. The method creates a data
//						  buffer that will be sent with the post request. 
//						  INPUT parameters: 
//							HttpObj (Mandatory)- 
//											The wlHttp object of the post request. This method will assign
// 	 								    the correct values for the wlHttp.Data["Type"] and wlHttp.Data["Value"] properties. 
//							FieldType, Fieldname, FieldNewValue - 
//											Triplets of FieldType("File" of "Field"), Field name and Field's new value
//										  For each triplet in the list the method will replace the old value of the field
//											with the new value.
//
// 							Example of using this method:
//													wlGlobals.MyMultipart.UpdateMultipartFields  (wlHttp, 
//																				  "File", "AttachedFile2","attach1.txt",
//																				  "File", "AttachedFile1", "attach2.txt",
//														  					  "Field", "MyHiddenField", "AAAAA")
//													wlHttp.Post (...)
//
// NOTICES:
//   1. The creation of this object must be done only in the InitAgenda function.
//   2. The attachment files may only be text files.
// 
//
function MultipartObj (piTemplateFile) {
  // checks if a string contains only spaces
  function IsEmptyString(piString) {
    
    if (/[^\s]+/.test(piString)) 
      return (false);
    else
      return (true);
    
  }
  
  
  
  // Writes a line to an output buffer that will be used to create the data string for
  // the post request.
  function WriteOutput (piStr ) {
    OutBuff = OutBuff + piStr + "\r\n";
  }
  
	function FindBoundaryLine (ObjPtr) {
	  var MyArr = new Array();
    var re = new RegExp ("\\s*([-\\w]*)\\s*", "gi");
    
    MyArr = re.exec(ObjPtr.FilesArr[ObjPtr.Template]);
    return MyArr[1];
	}
  // Reads the entire file into a string variable.
  //
  // INPUT:
  //   piFileName - The name of the input file.
  // 
  //function ReadFile(piFileName) {
  //  var RetVal = "";
  //  var fileDOM ;
  //  
  //  if (typeof ThreadNum == "undefined") {			
  //    var InpArr = new Array();
  //    InpArr = GetLine(piFileName);
  //    while (InpArr.RoundNum == 1) {
  //      if (InpArr.LineNum > 1 ) 
  //        RetVal += "\r\n" ;
  //      RetVal += InpArr[0] ;
  //      InpArr = GetLine(piFileName);
  //    }	 
  //  }
  //  else {
  //    //TraceMsg("read file with createDom: " + piFileName)
  //    var fileDOM = CreateDOM(piFileName);
  //    RetVal = fileDOM.document.wlSource;
      //TraceMsg("FileLength: " + RetVal.length)	 
  //  }
    //TraceMsg ("File Content:"+RetVal)
  //  return RetVal;
  //  
  //}
  
  // Reads the next line from an input file. 
  // Returns null when the RoundNum increases by one.
  // 
  // INPUT:
  //   piFileName         - The name of the input file.
  //   piIgnoreEmptyLines - Indicates whether to ignore empty lines.
  // 
  function ReadNextLine(piFileName,piIgnoreEmptyLines) {
    var InpArr = new Array();
    var TempStr;
    
    //Returns the last record that was read by the previous round. 
    //This record is actually the first record of the current round. 
    if (LastTemplateRec != null) 
      if (!piIgnoreEmptyLines || !IsEmptyString(LastTemplateRec)) {
        TempStr = LastTemplateRec;
        LastTemplateRec = null;
        return TempStr;
      }
    
    InpArr = GetLine(piFileName);
    if (piIgnoreEmptyLines) {
      //skip empty lines
      while ((InpArr.RoundNum == CurrentRound) && (IsEmptyString(InpArr[0]))) {
        InpArr = GetLine(piFileName);
      }
    }
    
    if (InpArr.RoundNum > CurrentRound) {
      CurrentRound++;
      //Save the current record for the next round.
      LastTemplateRec = InpArr[0];
      return (null); 
    }
    else
      return (InpArr[0]);
  }    
  
  // Reads till the end of the current section in the multipart file.
  // Returns null when the RoundNum increases by one.
  // 
  // INPUT:
  //   piFileName  - The name of the input file.
  //   piBoundary  - The boundary string that separates the multipart sections.
  //   piWrite     - Indicates whether to write the input lines to the output buffer.
  // 
  function ReadToNextSection (piFileName, piBoundary, piWrite) {
    var SourceLine = new Array();
    
    SourceLine = ReadNextLine(piFileName, false);
    while ((SourceLine != piBoundary) && (SourceLine != null)) {
      if (piWrite) WriteOutput (SourceLine ) 
                   SourceLine = ReadNextLine(piFileName, false);
    } 
    if (SourceLine != null) WriteOutput (SourceLine ) //write the boundary line
                            
                            return SourceLine;
  }
  
  
  //Checks whether the input line is of a file section in a multipart file.
  function IsFileSection (piLine) {
    var re = new RegExp ("filename\\s*=\\s*\"([^\"]*)\"", "gi");
    
    return (re.test(piLine));
    
  }
  
  // Replaces values in a string.
  //
  // INPUT:
  //  piStr             - The input string.
  //  piStartRegPattern - A regular expression pattern to identify the beginning of 
  //					    the string to replace.
  //  piEndRegPattern   - A regular expression pattern to identify the end of 
  //					    the string to replace.
  //  piNewValue        - The new value.
  function ReplaceValue (piStr, piStartRegPattern, piEndRegPattern, piNewValue) {
    var re = new RegExp (piStartRegPattern +"([\\W\\w]*?)"+  piEndRegPattern, "gi");
    var MyArr = new Array();
    var OldValue;
    var StartInd;
    var NextInd;
    var retVal;
    
    //TraceMsg("==========Replace Value ===============")
    MyArr = re.exec(piStr);
    OldValue = MyArr[1];
    
    StartInd = piStr.indexOf(OldValue) ;
    
    NextInd = StartInd + OldValue.length;
    
    RetVal = piStr.substr(0,StartInd) + piNewValue + piStr.substr(NextInd,piStr.length - NextInd);
    //TraceMsg ("Replaced String for file name: " + RetVal )
    return ( RetVal );
    
  }
  function ReplaceFieldValue (piStr, piFieldName, ObjPtr, piNewValue) {
    var EndField = "\r\n" + ObjPtr.Boundary;
    var StartFieldRe = new RegExp ("name\\s*=\\s*\"" + piFieldName  + "\"\\s*[\\r\\n]{2}");
    var StartInd;
    var NextInd;
    var retVal;
    var FieldInd;
    
    //TraceMsg("==========Replace Field Value ===============")
    FieldInd = piStr.search (StartFieldRe);
    //TraceMsg ("Field name pos: " + piStr.substr(FieldInd) )
    
    StartInd = piStr.indexOf("\r\n", FieldInd) + 4 ; //skip 2 sets of cr+lf
    //TraceMsg ("Field value pos: " + piStr.substr(StartInd) )
    
    //TraceMsg ("end Field value: " + EndField )
    NextInd = piStr.indexOf(EndField, StartInd) ; 
    //TraceMsg ("end Field value pos: " + piStr.substr(NextInd) )
    
    RetVal = piStr.substr(0,StartInd) + piNewValue + piStr.substr(NextInd,piStr.length - NextInd);
    //TraceMsg ("Replaced String for Field value: " + RetVal )
    return ( RetVal );
    
  }
  
  function ReplaceFileValue (piStr, piFileFieldName, ObjPtr, piFileName) {
    var EndFieldStr = "\r\n" + ObjPtr.Boundary; 
    var StartFieldRe = new RegExp ("name\\s*=\\s*\"" + piFileFieldName  + "\"\\s*;\\s*filename\\s*=\\s*\"", "gi");
    var StartFileNameInd;
    var EndFileNameInd;
    var StartValInd;
    var EndValInd;
    var retVal;
    var StartFieldInd;
    
    //TraceMsg("==========Replace File Value ===============")
    //TraceMsg("piFileName:" + piFileName)
    //TraceMsg("FileValue:" + ObjPtr.FilesArr[piFileName])
    
    MyArr = StartFieldRe.exec(piStr);
    StartFileNameInd = StartFieldRe.lastIndex;
    EndFileNameInd = piStr.indexOf("\"", StartFileNameInd);
    //TraceMsg ("start File name pos: " + piStr.substr(StartFileNameInd) )
    //TraceMsg ("end File name pos: " + piStr.substr(EndFileNameInd) )
    
    StartFieldInd = MyArr.index;
    //TraceMsg ("File name pos: " + piStr.substr(StartFieldInd) )
    
    //Skip to next line
    StartValInd = piStr.indexOf("\r\n", StartFieldInd) + 2 ;
    //Skip 2 lines
    StartValInd = piStr.indexOf("\r\n", StartValInd) + 4 ;
    //TraceMsg ("File value pos: " + piStr.substr(StartValInd) )
    
    //TraceMsg ("end Field str: " + EndFieldStr )
    EndValInd = piStr.indexOf(EndFieldStr, StartValInd) ; 
    //TraceMsg ("end Field value pos: " + piStr.substr(EndValInd) )
    
    RetVal = piStr.substr(0,StartFileNameInd) + piFileName +
    piStr.substr(EndFileNameInd, StartValInd - EndFileNameInd) + 
    ObjPtr.FilesArr[piFileName] + piStr.substr(EndValInd,piStr.length - EndValInd);
    //TraceMsg ("Replace New String length: " + RetVal.length )
    //TraceMsg ("Replace New String: " + RetVal )
    return ( RetVal );
    
  }
  
  //   This method should ne called just before the post command. The method creates a data
  //	 buffer that will be sent with the post request. 
  //
  //	 INPUT parameters: 
  //	  HttpObj (Mandatory) - The wlHttp object of the post request. This method will assign
  //	 							   the correct values for the wlHttp.Data["Type"] and
  //								   wlHttp.Data["Value"] properties. 
  //		piAttachFile (Mandatory) - The name of the attachment file to be used. This name must 
  //								   be one of the names that were passed when the object was created.
  //		name, Value  (Optional)  - Pairs of parameter name and parameter value in the multipart
  //								   file. For each parameter in the list the method will replace 
  //								   the old value with the new value.
  //
  //		Example of using this method:
  //				wlGlobals.MyMultipart.UpdateMultipartFields 
  //						     (wlHttp, wlLocals.AttachmentFile,"param1", "NewValue", "param2", "NewValue")
  //				wlHttp.Post (...)
  //
  function UpdateMultipartFields (HttpObj) {
    var CurrTemplate = this.FilesArr[this.Template];
    for ( i = 1 ; i < arguments.length ; i += 3 ) {
      if (UpdateMultipartFields.arguments[i] == "Field")
        CurrTemplate = ReplaceFieldValue(CurrTemplate, UpdateMultipartFields.arguments[i+1] , this , UpdateMultipartFields.arguments[i+2]);		
      else if (UpdateMultipartFields.arguments[i] == "File")
        CurrTemplate = ReplaceFileValue(CurrTemplate, UpdateMultipartFields.arguments[i+1] , this, UpdateMultipartFields.arguments[i+2]);		
    }
    //TraceMsg ("CurrTemplate.length: " + CurrTemplate.length)
    HttpObj.DataFile["Type"] = null;
    HttpObj.DataFile["Filename"] = null;
    HttpObj.Data["Type"] = "multipart/form-data; boundary=" + 
    this.Boundary.substr(2,this.Boundary.length - 2 ); //Remove first '--'
    HttpObj.Data["Value"] = CurrTemplate;
    //TraceMsg ("HttpObj.Data[\"Value\"].length: " + HttpObj.Data["Value"].length)
  }
  
  
  //*************************************************
  //     MultipartObj constractor body
  //*************************************************

  this.Template = piTemplateFile;
  this.FilesArr = new Array();
  this.Boundary = null;
  this.UpdateMultipartFields = UpdateMultipartFields;
  
  //var OutBuff = ""
  var SourceLine = "";
  var OutLine = "";
  var FileRec = new Array();
  var CurrentRound = 1;
  var LastTemplateRec = null;
  
  //load the template file and the files that can be used for attachments to memory
  //SourceLine = ReadNextLine(this.Template, true); //Get the BoundaryLine the first line that is not blank
  //this.Boundary = SourceLine;
  
  this.FilesArr[this.Template] = ReadFile(this.Template);
	this.Boundary = FindBoundaryLine (this)
  //TraceMsg ("Template File: " + this.FilesArr[this.Template] ) 
  
  for ( i = 1 ; i < arguments.length ; i ++ ) {
    this.FilesArr[MultipartObj.arguments[i]] = escape(ReadFile(MultipartObj.arguments[i]));
    //TraceMsg ("Attachment File: " + this.FilesArr[MultipartObj.arguments[i]] ) 
  }

}

//Special utility for tracing (for users)
function wlTraceMsg(strMsg )
{
  var aryLine = strMsg.split( "\n" );
  if (aryLine.length > 1 ) InfoMessage ("============= Start section =================");
  for( var I = 0; I < aryLine.length; ++I ) {
    InfoMessage( aryLine[I]  );
  }
  if (aryLine.length > 1 ) InfoMessage ("============= End section ===================");
}

//Debug routine for tracing
function TraceMsg(strMsg )
{
  return;
  InfoMessage (strMsg);
  return;
  var aryLine = strMsg.split( "\n" );
  if (aryLine.length > 1 ) InfoMessage ("============= Start section =================");
  for( var I = 0; I < aryLine.length; ++I )
  {
    InfoMessage( aryLine[I]  );
  }
  if (aryLine.length > 1 ) InfoMessage ("============= End section ===================");
}



function createJSReservedWordsTable()
{
  JSReservedWordsTable = new Array;
  JSReservedWordsTable["abstract"] = true;
  JSReservedWordsTable["boolean"] = true;
  JSReservedWordsTable["break"] = true;
  JSReservedWordsTable["byte"] = true;
  JSReservedWordsTable["case"] = true;
  JSReservedWordsTable["catch"] = true;
  JSReservedWordsTable["char"] = true;
  JSReservedWordsTable["class"] = true;
  JSReservedWordsTable["const"] = true;
  JSReservedWordsTable["continue"] = true;
  JSReservedWordsTable["debugger"] = true;
  JSReservedWordsTable["default"] = true;
  JSReservedWordsTable["delete"] = true;
  JSReservedWordsTable["do"] = true;
  JSReservedWordsTable["double"] = true;
  JSReservedWordsTable["else"] = true;
  JSReservedWordsTable["enum"] = true;
  JSReservedWordsTable["export"] = true;
  JSReservedWordsTable["extends"] = true;
  JSReservedWordsTable["false"] = true;
  JSReservedWordsTable["final"] = true;
  JSReservedWordsTable["finally"] = true;
  JSReservedWordsTable["float"] = true;
  JSReservedWordsTable["for"] = true;
  JSReservedWordsTable["function"] = true;
  JSReservedWordsTable["goto"] = true;
  JSReservedWordsTable["if"] = true;
  JSReservedWordsTable["implements"] = true;
  JSReservedWordsTable["import"] = true;
  JSReservedWordsTable["in"] = true;
  JSReservedWordsTable["instanceof"] = true;
  JSReservedWordsTable["int"] = true;
  JSReservedWordsTable["interface"] = true;
  JSReservedWordsTable["long"] = true;
  JSReservedWordsTable["native"] = true;
  JSReservedWordsTable["new"] = true;
  JSReservedWordsTable["null"] = true;
  JSReservedWordsTable["package"] = true;
  JSReservedWordsTable["private"] = true;
  JSReservedWordsTable["protected"] = true;
  JSReservedWordsTable["public"] = true;
  JSReservedWordsTable["return"] = true;
  JSReservedWordsTable["short"] = true;
  JSReservedWordsTable["static"] = true;
  JSReservedWordsTable["super"] = true;
  JSReservedWordsTable["switch"] = true;
  JSReservedWordsTable["synchronized"] = true;
  JSReservedWordsTable["this"] = true;
  JSReservedWordsTable["throw"] = true;
  JSReservedWordsTable["throws"] = true;
  JSReservedWordsTable["transient"] = true;
  JSReservedWordsTable["true"] = true;
  JSReservedWordsTable["try"] = true;
  JSReservedWordsTable["typeof"] = true;
  JSReservedWordsTable["var"] = true;
  JSReservedWordsTable["void"] = true;
  JSReservedWordsTable["volatile"] = true;
  JSReservedWordsTable["while"] = true;
  JSReservedWordsTable["with"] = true;

}
