/*
  This file should be placed in the Include directory.
  The wlDefaultInclude.js file that is also found in the Include directory includes this file. The
  wlDefaultInclude file is included by Webload.ini that is found in the bin/bin_d directory.
  During run time, this file will be executed before any line in the agenda.
*/

InitObjects();

function InitObjects()
{
  FTest = new Object;
  FTest.Identification = new Object;
  FTest.Verification = new Object;
  FTest.Action = new Object;
}


 function ReportFrameError(FTest)
 {
  var testName;
  if(FTest.Name == undefined)
    testName = "Test Case";
  else
    testName = FTest.Name;
  var frameTestCaseReporter = new MyVerificationReporter("Test Case",testName+" failed");
  AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"The wanted frame could not be found",frameTestCaseReporter);
  frameTestCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
  frameTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
  frameTestCaseReporter.Report(wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID],window,testName+" Failed");
 }

 function ReportIdentificationError(FTest,expectedFrame,actualFrame)
 {
  var index;
  var url;
  var testName;
  if(FTest.Name == undefined)
    testName = "Test Case";
   else
    testName = FTest.Name;
  var testCaseReporter = new MyVerificationReporter("Test Case",testName+" failed");
  if(FTest.Identification.Ordinal == undefined)
    index = -1;
  else
    index = FTest.Identification.Ordinal;
  if(FTest.Identification.Url == undefined)
    url = "";
  else
    url = FTest.Identification.Url;

  var testType = FTest.Type;
  if(testType == LINK_TYPE)
  	AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,url,index,-1,"Link can not be identified",testCaseReporter);
 else if(testType == IMAGE_TYPE)
 	AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,url,index,-1,"Image can not be identified",testCaseReporter);
 else if(testType == FORM_TYPE)
 	AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",index,-1,"Form can not be identified",testCaseReporter);
 //add here new types such as AREA, META


 testCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
  testCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
  //the location doesn't exist for the main window, only for children frames
  if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
    testCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
  if(actualFrame.location != window.location)
  testCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
  testCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
 }


 function ReportLinkPresence(FTest,expectedFrame,actualFrame,foundLink)
 {
  var index;
  var url;
  var testName;
  if(FTest.Name == undefined)
    testName = "Test Case";
   else
    testName = FTest.Name;
  var testCaseReporter = new MyVerificationReporter("Test Case",testName+" failed");

  index = foundLink.wlSourceIndex;
  url = foundLink.wlOrigUrl;
  AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,url,index,index,"Link was identified",testCaseReporter);
  testCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
  testCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
  //the location doesn't exist for the main window, only for children frames
  if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
    testCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
  if(actualFrame.location != window.location)
  testCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
  testCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
 }

  function ReportImgPresence(FTest,expectedFrame,actualFrame,foundImg)
   {
   	var index;
   	var url;
   	var testCaseReporter = new MyVerificationReporter("Test Case","Test Case failed");

   	index = foundImg.wlSourceIndex;
   	url = foundImg.wlOrigUrl;
   	AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,url,index,index,"Img was identified",testCaseReporter);
   	testCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
   	testCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
   	//the location doesn't exist for the main window, only for children frames
   	if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
   		testCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
   	if(actualFrame.location != window.location)
   		testCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
   	testCaseReporter.Report(expectedFrame,actualFrame,"Test Case Failed");
  }

 function ReportFormPresence(FTest,expectedFrame,actualFrame,foundForm)
 {
   	var index;
   	var url;
   	var testCaseReporter = new MyVerificationReporter("Test Case","Test Case failed");

   	index = foundForm.wlSourceIndex;
   	AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",index,index,"Form was identified",testCaseReporter);
   	testCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
   	testCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
   	//the location doesn't exist for the main window, only for children frames
   	if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
   		testCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
   	if(actualFrame.location != window.location)
   		testCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
   	testCaseReporter.Report(expectedFrame,actualFrame,"Test Case Failed");
 }


 function ReportLinkAbsence(FTest,expectedFrame,actualFrame)
  {
    var index;
    var url;
    var testName;
  if(FTest.Name == undefined)
    testName = "Test Case";
  else
    testName = FTest.Name;
    var testCaseReporter = new MyVerificationReporter("Test Case",testName+" Succeeded");
    if(FTest.Identification.Ordinal == undefined)
      index = -1;
    else
      index = FTest.Identification.Ordinal;
    if(FTest.Identification.Url == undefined)
      url = "";
    else
      url = FTest.Identification.Url;
    AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,url,index,-1,"Link was not identified",testCaseReporter);
    testCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
    testCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
    //the location doesn't exist for the main window, only for children frames
    if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
      testCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
    if(actualFrame.location != window.location)
    testCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
    testCaseReporter.Report(expectedFrame,actualFrame,testName+" Succeeded");
 }

 function ReportImgAbsence(FTest,expectedFrame,actualFrame)
    {
    	var index;
    	var url;
    	var testCaseReporter = new MyVerificationReporter("Test Case","Test Case Succeeded");
    	if(FTest.Identification.Ordinal == undefined)
    		index = -1;
    	else
    		index = FTest.Identification.Ordinal;
    	if(FTest.Identification.ImgSrc == undefined)
    		url = "";
    	else
    		url = FTest.Identification.ImgSrc;
    	AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,url,index,-1,"Img was not identified",testCaseReporter);
    	testCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
    	testCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
    	//the location doesn't exist for the main window, only for children frames
    	if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
    		testCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
    	if(actualFrame.location != window.location)
    		testCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
    	testCaseReporter.Report(expectedFrame,actualFrame,"Test Case Succeeded");
  }

  function ReportFormAbsence(FTest,expectedFrame,actualFrame)
  {
    	var index;
    	var url;
    	var testCaseReporter = new MyVerificationReporter("Test Case","Test Case Succeeded");
    	if(FTest.Identification.Ordinal == undefined)
    		index = -1;
    	else
    		index = FTest.Identification.Ordinal;
   		AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",index,-1,"Form was not identified",testCaseReporter);
    	testCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
    	testCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
    	//the location doesn't exist for the main window, only for children frames
    	if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
    		testCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
    	if(actualFrame.location != window.location)
    		testCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
    	testCaseReporter.Report(expectedFrame,actualFrame,"Test Case Succeeded");
  }

 function ReportFrameAbsence(FTest)
 {
  var testName;
  if(FTest.Name == undefined)
    testName = "Test Case";
   else
    testName = FTest.Name;
  var frameTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Succeeded");
  AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"The wanted frame could not be found",frameTestCaseReporter);
  frameTestCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
  frameTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
  frameTestCaseReporter.Report(wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID],window,testName+" Succeeded");
 }

/*------------------------------------------------------------------------------------------------
The function search recursively through all the children frames of "frame" till a match is found,
accordingly to the properties of "matcher".
------------------------------------------------------------------------------------------------*/
function CheckFrames(frame,matcher,expectedIndex)
{
  var res = frame.document.IdentifyFrame(matcher,expectedIndex);
  if(res == undefined)
  {
    if(frame.document.frames.length > 0)
    {
      for(i=0;i<frame.document.frames.length;i++)
      {
        res = CheckFrames(frame.document.frames[i],matcher,expectedIndex);  //recursive call
        if(res != undefined)
          return res;
      }
    }
  }
  return res;
}

/*------------------------------------------------------------------------------------------------
The function checks if the current "frame" matches to the prperties of "matcher". If not, the
children frames will be checked by "CheckFrames".
------------------------------------------------------------------------------------------------*/
function FindFrame(frame,matcher,expectedIndex)
{
  var frameName = frame.name;
  if(frameName == "NO_FRAME_NAME")
    frameName = "";
  var frameMatcher1 = new WLLink(frame.location,"",frameName,"");

  var res = matcher.UrlCompare(frameMatcher1); //if true we have url matching
  if(res >= 0 )
  {
    return frame;
  }
  else
  {
    return CheckFrames(frame,matcher,expectedIndex);
  }
}




function IdentifyFrames(FTest)
{
  var framePath;
  var expectedFrame;
  var actualFrame;
  var actualFrameSearch = false;
  var expectedFrameSearch = false;
  var res;
  var expFrameMatcher;
  var actFrameMatcher;
  var frameMatcher;
  var frameName;
  var checkAbsence = false;
  var reportOnSuccess = false;
  var defaultIdentification = false;


  //if the page doesn't contain frames
  if(FTest.Identification.FramePath == undefined && FTest.Identification.FrameName == undefined && FTest.Identification.Location == undefined)
  {
    res = new Object;
    res.actFrame = window;
    res.expFrame = wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID];
    return res;
  }

  if(FTest.Identification.DefaultIdentification)
    defaultIdentification = true;

  if(FTest.Verification.Absence)
    checkAbsence = true;

  if(FTest.Action.ReportOnSuccess)
    reportOnSuccess = true;

  if(FTest.Identification.FramePath != undefined)
  {
    //the actual frame

    if(FTest.Identification.FramePath == "")
      framePath = "window";

    else
      framePath = actualFrame = "window."+FTest.Identification.FramePath;
    actualFrame = eval(framePath);
    if(actualFrame == undefined)
    {
      if(!defaultIdentification)
      {
        if(!checkAbsence)
        {
          ReportFrameError(FTest);
          InitObjects();
          return undefined;
        }
        else
        {
          if(reportOnSuccess)
            ReportFrameAbsence(FTest);
          return undefined;
        }
      }
      else  //we'll have to search for the right frame
      {
        actualFrameSearch = true;
      }
    }
    else
    {
      if(FTest.Identification.FrameName != undefined)
      {
        if(actualFrame.name == "NO_FRAME_NAME")
          frameName = "";
        else
          frameName = actualFrame.name;
        if(FTest.Identification.FrameName != frameName)
          if(!defaultIdentification)
          {
            if(!checkAbsence)
            {
              ReportFrameError(FTest);
              InitObjects();
              return undefined;
            }
            else
            {
              if(reportOnSuccess)
                ReportFrameAbsence(FTest);
              return undefined;
            }
          }
          else  //we'll have to search for the right frame
          {
            actualFrameSearch = true;
          }
      }
      if(FTest.Identification.FrameLocation != undefined)
      {
        expFrameMatcher = new WLLink(FTest.Identification.FrameLocation,"","","");
        actFrameMatcher = new WLLink(actualFrame.location,"","","")
        res = actFrameMatcher.UrlCompare(expFrameMatcher);
        if(res < 0) //url doesn't match
          if(!defaultIdentification)
          {
            if(!checkAbsence)
            {
              ReportFrameError(FTest);
              InitObjects();
              return undefined;
            }
            else
            {
              if(reportOnSuccess)
                ReportFrameAbsence(FTest);
              return undefined;
            }
          }
          else  //we'll have to search for the right frame
          {
            actualFrameSearch = true;
          }
      }
    }

    //the expected frame
    if(FTest.Identification.FramePath == "")
      framePath = "wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID]";
    else
      framePath = "wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID]."+FTest.Identification.FramePath;
    expectedFrame = eval(framePath);
    if(expectedFrame == undefined )
    {
      expectedFrameSearch = true;
    }
    else
    {
      if(FTest.Identification.FrameName != undefined)
      {
        if(expectedFrame.name == "NO_FRAME_NAME")
          frameName = "";
        else
          frameName = expectedFrame.name;
        if(FTest.Identification.FrameName != frameName)
        {
          expectedFrameSearch = true;
        }
      }
      if(FTest.Identification.FrameLocation != undefined)
      {
        actFrameMatcher = new WLLink(FTest.Identification.FrameLocation,"","","");
        expFrameMatcher = new WLLink(expectedFrame.location,"","","")
        res = expFrameMatcher.UrlCompare(actFrameMatcher);
        if(!res) //url doesn't match
        {
          expectedFrameSearch = true;
        }
      }
    }
  }

  if(FTest.Identification.FramePath == undefined || expectedFrameSearch || actualFrameSearch)
  {
    var frameLocation;

    if(FTest.Identification.FrameName != undefined)
      frameName = FTest.Identification.FrameName;
    else
      frameName = "";
    if(FTest.Identification.FrameLocation != undefined)
      frameLocation = FTest.Identification.FrameLocation;
    else
      frameLocation = "";
    frameMatcher = new WLLink(frameLocation,"",frameName,"");
    //finding the expected frame
    if(FTest.Identification.FramePath == undefined || expectedFrameSearch)
    {
      expectedFrame = FindFrame(wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID],frameMatcher,0);
      if(expectedFrame == undefined)
      {
        if(!checkAbsence)
        {
          ReportFrameError(FTest);
          InitObjects();
          return undefined;
        }
        else
        {
          if(reportOnSuccess)
          {
            ReportFrameAbsence(FTest);
          }
          return undefined;
        }
      }
      if(FTest.Identification.FrameName != undefined && !defaultIdentification)
      {
        if(expectedFrame.name == "NO_FRAME_NAME")
          frameName = "";
        else
          frameName = expectedFrame.name;
        if(FTest.Identification.FrameName != frameName)
        {
          if(!checkAbsence)
          {
            ReportFrameError(FTest);
            InitObjects();
            return undefined;
          }
          else
          {
            if(reportOnSuccess)
              ReportFrameAbsence(FTest);
            return undefined;
          }
        }
      }
      if(FTest.Identification.FrameLocation != undefined && !defaultIdentification)
      {
        actFrameMatcher = new WLLink(FTest.Identification.FrameLocation,"","","");
        expFrameMatcher = new WLLink(expectedFrame.location,"","","")
        res = expFrameMatcher.UrlCompare(actFrameMatcher);
        if(res < 0) //url doesn't match
        {
          if(!checkAbsence)
          {
            ReportFrameError(FTest);
            InitObjects();
            return undefined;
          }
          else
          {
            if(reportOnSuccess)
              ReportFrameAbsence(FTest);
            return undefined;
          }
        }
      }
    }
    //finding the actual frame
    if(FTest.Identification.FramePath == undefined || actualFrameSearch)
    {
      actualFrame = FindFrame(window,frameMatcher,0);
      if(actualFrame == undefined)
      {
        if(!checkAbsence)
        {
          ReportFrameError(FTest);
          InitObjects();
          return undefined;
        }
        else
        {
          if(reportOnSuccess)
            ReportFrameAbsence(FTest);
          return undefined;
        }
      }
      if(FTest.Identification.FrameName != undefined && !defaultIdentification)
      {
        if(actualFrame.name == "NO_FRAME_NAME")
          frameName = "";
        else
          frameName = actualFrame.name;
        if(FTest.Identification.FrameName != frameName)
        {
          if(!checkAbsence)
          {
            ReportFrameError(FTest);
            InitObjects();
            return undefined;
          }
          else
          {
            if(reportOnSuccess)
              ReportFrameAbsence(FTest);
            return undefined;
          }
        }
      }
      if(FTest.Identification.FrameLocation != undefined && !defaultIdentification)
      {
        expFrameMatcher = new WLLink(FTest.Identification.FrameLocation,"","","");
        actFrameMatcher = new WLLink(actualFrame.location,"","","")
        res = actFrameMatcher.UrlCompare(expFrameMatcher);
        if(!res) //url doesn't match
        {
          if(!checkAbsence)
          {
            ReportFrameError(FTest);
            InitObjects();
            return undefined;
          }
          else
          {
            if(reportOnSuccess)
              ReportFrameAbsence(FTest);
            return undefined;
          }
        }
      }
    }
  }
  res = new Object;
  res.expFrame = expectedFrame;
  res.actFrame = actualFrame;
  return res;
}

function GetImageHtml(origString)
{
  var reg = /\<\s*IMG[^\>\<]*\>/i; //a < then any no. of blanks then IMG then anything except <  and > and finally >.
  var array = reg.exec(origString);
  if(array)
    return array[0];
  else
    return undefined;
}

function GetImageName(origString)
{
  var reg = /NAME\s*=\s*"(\S*)"/i;
  var array = reg.exec(origString);
  if(array)
    return array[1];
  else
    return undefined;

}


function GetImageSrc(origString)
{
  var reg = /SRC\s*=\s*"(\S*)"/i;
  var array = reg.exec(origString);
  if(array)
    return array[1];
  else
    return undefined;

}
/*---------------------------------------------------------------------------------------------------------
The LinkTestCase function first finds the correct expected and actual frames, and then searches for
the wanted link in the actual frame. You might want to do the search for frames separeted from the
test case, if you can recognize that two wanted objects are in the same frame, and thus save the search
for the appropriate frame. The "linkOrigUrl" must be transfered to the viewer only for links and images.
If you are taking the url from IE, it should be simple the "href", so this parameter is redundant. If you
are using Webload's DOM, then the value for this parameter will be taken from "document.links[i].wlOrigUrl"
Is the frame's name is "NO_FRAME_NAME", you should put into "frameName" an emptyString "". If you don't
know the index of the frame in the collection of frames, or the index of the wanted link in the collection
of the links, you should give to "frameIndex" and "linkIndex" the value of 0.
For oblects different from link:
forms - "IdentifyForm" instead of "IdentifyLink",CMP_FORMS_BY_URL instead of
CMP_LINKS_BY_URL, FORM_TYPE instead of LINK_TYPE.
images - "IdentifyImage" instead of "IdentifyLink",CMP_IMAGES_BY_URL instead of
CMP_LINKS_BY_URL, IMAGE_TYPE instead of LINK_TYPE.
tables - There is no ASM identification for tables. You can look at "IsTableMatching" in wlFuncTest.js
The matching is done by the id property. If the index doesn't match, then the id musn't be empty.
CMP_TABLE_STRUCTURE instead of CMP_LINKS_BY_URL, TABLE_TYPE instead of LINK_TYPE.
titles - There is no ASM identification for titles.CMP_TITLE instead of CMP_LINKS_BY_URL, TITLE_TYPE instead
of LINK_TYPE.
For any extra information you can look at wlFuncTest.js
----------------------------------------------------------------------------------------------------------*/
//function LinkTestCase(frameUrl,frameName,frameIndex,linkUrl,linkOrigUrl,linkText,linkName,linkId,linkIndex)
function LinkTestCase(FTest)
{
  var defaultIdentification = false;
  FTest.Type = LINK_TYPE;

  if(!wlGlobals.Verification)
  {
    //InfoMessage("Test case will not be performed")
    return;
  }

  if(wlLocals.instrumentation == false)
    return;

  if(FTest.Identification.DefaultIdentification)
  {

    //maybe not needed!

    defaultIdentification = true;
    if(FTest.Identification.FrameName == undefined)
      FTest.Identification.FrameName = "";
    if(FTest.Identification.FrameLocation == undefined)
      FTest.Identification.FrameLocation = "";
    //if(FTest.Identification.FramePath == undefined)
    //  FTest.Identification.FramePath = "";
    if(FTest.Identification.Ordinal  == undefined)
      FTest.Identification.Ordinal = 0;
    if(FTest.Identification.Id == undefined)
      FTest.Identification.Id = "";
    if(FTest.Identification.Name == undefined)
      FTest.Identification.Name = "";
    if(FTest.Identification.Url == undefined)
      FTest.Identification.Url = "";
    if(FTest.Identification.Text == undefined)
      FTest.Identification.Text = "";
    if(FTest.Identification.ImageName == undefined)
      FTest.Identification.ImageName = "";
    if(FTest.Identification.ImageSrc == undefined)
      FTest.Identification.ImageSrc = "";
  }

  var once = false;
  if(FTest.Verification.Once)
    once = true;

  if((ThreadNum == 0 && RoundNum == 1) || !once)
  {
    var actualFrameSearch = false;
    var expectedFrameSearch = false;
    var actualFrame;
    var expectedFrame;
    var res;
    var frameMatcher;
    var frameName;
    var frameWarning = false;
    var linkMatcher;
    var expFrameMatcher;
    var actFrameMatcher;
    var foundLink = undefined;
    var index = false;
    var linkTestCaseReporter;
    var bestResult = -1;
    var bestScore = 100;  //biger that any possible score
    var error = false; //test passed successfully
    var framePath;
    var checkAbsence = false;
    var reportOnSuccess = false;
    var imageName = undefined;
    var imageSrc = undefined;
    var imgString = undefined;


    if(FTest.Verification.Absence)
      checkAbsence = true;

    if(FTest.Action.ReportOnSuccess)
      reportOnSuccess = true;


    res = IdentifyFrames(FTest);
    if(res == undefined)
      return;
    expectedFrame = res.expFrame;
    actualFrame = res.actFrame;

    if(actualFrame.document.GetIdentLocation() != expectedFrame.document.GetIdentLocation())
      frameWarning = true;


    if(defaultIdentification)
    {
      linkMatcher = new WLLink(FTest.Identification.Url,FTest.Identification.Text,FTest.Identification.Name,FTest.Identification.Id);
      foundLink = actualFrame.document.IdentifyLink(linkMatcher,FTest.Identification.Ordinal);
      if(foundLink == undefined)
      {
        if(!checkAbsence)
        {
          ReportIdentificationError(FTest,expectedFrame,actualFrame);
          InitObjects();
          return;
        }
        else
        {
          if(reportOnSuccess)
            ReportLinkAbsence(FTest,expectedFrame,actualFrame);
          return;
        }
      }
    }
    else
    {
      /*we have manual identification
      If the index was one of the identifying properties, we'll check if the
      other properties of the link found at the specified index match. If they do we found
      the wanted link, if not we report error.
      If the url was one of the identifying properties, we'll go through the whole collection,
      searching for the best url match between the links that match all the other properties.
      If the identification by url wasn't requested, we'll stop as soon as we'll find a link
      that matches all the specified properties.*/



      for(var i=0;i<actualFrame.document.links.length;i++)
      {
        if(FTest.Identification.Ordinal != undefined)
          if(FTest.Identification.Ordinal >= 0 && FTest.Identification.Ordinal < actualFrame.document.links.length)
          {
            i = FTest.Identification.Ordinal;
            index = true;
          }
          else
            break;
        if(FTest.Identification.Name != undefined)
        {
          if(actualFrame.document.links[i].name != FTest.Identification.Name)
          {
            if(index)
              break;
            else
              continue;
          }
        }
        if(FTest.Identification.Id != undefined)
          if(actualFrame.document.links[i].id != FTest.Identification.Id)
            if(index)
              break;
            else
              continue;
        if(FTest.Identification.Text != undefined)
          if(actualFrame.document.links[i].innerText != FTest.Identification.Text)
            if(index)
              break;
            else
              continue;
        if(FTest.Identification.ImageName != undefined)
        {
          imgString = GetImageHtml(actualFrame.document.links[i].innerHTML);
          if(imgString != undefined)
            imageName = GetImageName(imgString);
          if((imageName == undefined && FTest.Identification.ImageName != "")|| (imageName != FTest.Identification.ImageName))
            if(index)
              break;
            else
              continue;
        }
        if(FTest.Identification.ImageSrc != undefined)
        {
          imgString = GetImageHtml(actualFrame.document.links[i].innerHTML);
          if(imgString != undefined)
            imageSrc = GetImageSrc(imgString);
          if((imageSrc == undefined && FTest.Identification.ImageSrc)|| (imageSrc != FTest.Identification.ImageSrc))
            if(index)
              break;
            else
              continue;
        }
        if(FTest.Identification.Url != undefined)
        {

          linkMatcher1 = new WLLink(FTest.Identification.Url,"","","");
          linkMatcher2 = new WLLink(actualFrame.document.links[i].href,"","","");
          res = linkMatcher1.UrlCompare(linkMatcher2); //if true we have url matching
          if(res < 1) //no matching
            if(index)
              break;
            else
              continue;
          else
          {
            if(res < bestScore && res > -1)
            {
              bestResult = i;
              bestScore = res;
            }
            if(index || res == 1) //in case we're checking by index or we have perfect match
              break;
          }
        }
        else //all properties matched and the url isn't used for identification
        {
          foundLink = actualFrame.document.links[i];
          break;
        }
        //image name
        //image src
      }
    }
    if(foundLink == undefined && (bestResult == -1))
    {
      if(!checkAbsence)
      {
        ReportIdentificationError(FTest,expectedFrame,actualFrame);
        InitObjects();
        return;
      }
      else
      {
        if(reportOnSuccess)
          ReportLinkAbsence(FTest,expectedFrame,actualFrame);
        return;
      }
    }
    else if(bestResult > -1)
    {
      foundLink = actualFrame.document.links[bestResult];
    }

    if(checkAbsence)
    {
      if(foundLink != undefined)
        ReportLinkPresence(FTest,expectedFrame,actualFrame,foundLink);
      else
        ReportLinkAbsence(FTest,expectedFrame,actualFrame);
      return;
    }

  //the verification part

  //initializing the reporter
  var testName;
   if(FTest.Name == undefined)
    testName = "Test Case";
   else
    testName = FTest.Name;
  linkTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Failed");
  linkTestCaseReporter.maxSeverity = FTest.Action.VerificationSeverity;
  linkTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
  if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
    linkTestCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
  if(actualFrame.location != window.location)
    linkTestCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
  if(frameWarning)
    AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"Warning: The expected frame was found at a different location than the actual one.",linkTestCaseReporter);



  if(FTest.Verification.Ordinal != undefined)
    if(FTest.Verification.Ordinal != foundLink.wlSourceIndex)
    {
      AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,FTest.Verification.Ordinal,foundLink.wlSourceIndex,"The found link's ordinal position is "+foundLink.wlSourceIndex+" and not "+FTest.Verification.Ordinal,linkTestCaseReporter);
      error = true;
      if(FTest.Action.StopOnFailure)
      {
        linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
        InitObjects();
        return;
      }
    }
  if(FTest.Verification.Name != undefined)
    if(FTest.Verification.Name != foundLink.name)
    {
      AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,foundLink.wlSourceIndex,foundLink.wlSourceIndex,"The found link's name is \""+foundLink.name+"\" and not \""+FTest.Verification.Name+"\"",linkTestCaseReporter);
      error = true;
      if(FTest.Action.StopOnFailure)
      {
        linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
        InitObjects();
        return;
      }
    }
  if(FTest.Verification.Id != undefined)
    if(FTest.Verification.Id != foundLink.id)
    {
      AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,foundLink.wlSourceIndex,foundLink.wlSourceIndex,"The found link's id is \""+foundLink.id+"\" and not \""+FTest.Verification.Id+"\"",linkTestCaseReporter);
      error = true;
      if(FTest.Action.StopOnFailure)
      {
        linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
        InitObjects();
        return;
      }
    }
  if(FTest.Verification.Text != undefined)
    if(FTest.Verification.Text != foundLink.innerText)
    {
      AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,foundLink.wlSourceIndex,foundLink.wlSourceIndex,"The found link's text is \""+foundLink.innerText+"\" and not \""+FTest.Verification.Text+"\"",linkTestCaseReporter);
      error = true;
      if(FTest.Action.StopOnFailure)
      {
        linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
        InitObjects();
        return;
      }
    }
  if(FTest.Verification.Target != undefined)
    if(FTest.Verification.Target != foundLink.target)
    {
      AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,foundLink.wlSourceIndex,foundLink.wlSourceIndex,"The found link's target is \""+foundLink.target+"\" and not \""+FTest.Verification.Target+"\"",linkTestCaseReporter);
      error = true;
      if(FTest.Action.StopOnFailure)
      {
        linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
        InitObjects();
        return;
      }
    }
  if(FTest.Verification.ImageName != undefined)
  {
    imgString = GetImageHtml(foundLink.innerHTML);
    if(imgString != undefined)
      imageName = GetImageName(imgString);
    if((imageName == undefined && FTest.Verification.ImageName != "")|| (imageName != FTest.Verification.ImageName))
    {
      AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,foundLink.wlSourceIndex,foundLink.wlSourceIndex,"The found link's inner image's name is \""+imageName+"\" and not \""+FTest.Verification.ImageName+"\"",linkTestCaseReporter);
      error = true;
      if(FTest.Action.StopOnFailure)
      {
        linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
        InitObjects();
        return;
      }
    }
  }
  if(FTest.Verification.ImageSrc != undefined)
    {
      imgString = GetImageHtml(foundLink.innerHTML);
      if(imgString != undefined)
        imageSrc = GetImageSrc(imgString);
      if((imageSrc == undefined && FTest.Verification.ImageSrc != "")|| (imageSrc != FTest.Verification.ImageSrc))
      {
        AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,foundLink.wlSourceIndex,foundLink.wlSourceIndex,"The found link's inner image's source is \""+imageSrc+"\" and not \""+FTest.Verification.ImageSrc+"\"",linkTestCaseReporter);
        error = true;
        if(FTest.Action.StopOnFailure)
        {
          linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
          InitObjects();
          return;
        }
      }
  }
  if(FTest.Verification.Integrity)
  {
    var headers = wlHttp.Head(foundLink.href);
    if(headers != undefined)
    {
      var statusLine = headers["Status line"].value;
      if(statusLine != undefined)
      {
        var reg = /HTTP\S*\s*(\S*)/i;
        var statusNr = reg.exec(statusLine);
      }
    }
    if(statusNr == undefined || statusNr[1] != "200")
    {
        var status;
        if(statusNr == undefined)
          status = undefined;
        else
          status = statusNr[1];
        AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,foundLink.wlSourceIndex,foundLink.wlSourceIndex,"The found link's return status is \""+status+"\"",linkTestCaseReporter);
        error = true;
        if(FTest.Action.StopOnFailure)
        {
          linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
          InitObjects();
          return;
        }
    }
  }
  if(FTest.Verification.Url != undefined)
  {
    linkMatcher1 = new WLLink(FTest.Verification.Url,"","","");
    linkMatcher2 = new WLLink(foundLink.href);
    res = linkMatcher1.UrlCompare(linkMatcher2); //if true we have url matching
    if(res < 1) //no matching
    {
      AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,foundLink.wlSourceIndex,foundLink.wlSourceIndex,"The found link's url is \""+foundLink.href+"\" and not \""+FTest.Verification.Url+"\"",linkTestCaseReporter);
      error = true;
      if(FTest.Action.StopOnFailure)
      {
        linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
        InitObjects();
        return;
      }
    }
  }
  if(!error) //the test passed without errors
  {
    if(frameWarning)
    {
      linkTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Warning");
      AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"Warning: The expected frame was found at a different location than the actual one.",linkTestCaseReporter);
    }
    else if (FTest.Action.ReportOnSuccess)
      linkTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Succeeded");
    if(frameWarning || FTest.Action.ReportOnSuccess)
    {
      AddErrToReporter(LINK_TYPE,CMP_LINKS_BY_URL,foundLink.wlOrigUrl,foundLink.wlSourceIndex,foundLink.wlSourceIndex,"The link test case succeeded.",linkTestCaseReporter);
      linkTestCaseReporter.maxSeverity = WLSuccess; //notification
      linkTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
      if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
        linkTestCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
      if(actualFrame.location != window.location)
        linkTestCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
      if(frameWarning)
      {
        linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Warning");
      }
      else
      {
        linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Succeeded");
      }
    }
  }
  else
  {
    linkTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
  }

  }//the "(ThreadNum == 0 && RoundNum == 1)" if
  InitObjects();
}


function TableCompareTestCase(tcObj,table,frame)
{
  if(!wlGlobals.Verification)
  {
    //InfoMessage("Test case will not be performed")
    return;
  }

  if(wlLocals.instrumentation == false)
  return;

  var once = false;
  if(tcObj.Once)
    once = true;

  if((ThreadNum == 0 && RoundNum == 1) || !once)
  {
    tcObj.Compare(table,frame);
    InitObjects();
  }
}


function TextTestCase(FTest)
{
  var defaultIdentification = false;

  if(!wlGlobals.Verification)
  {
    //InfoMessage("Test case will not be performed")
    return;
  }

  if(wlLocals.instrumentation == false)
    return;

  if(FTest.Identification.DefaultIdentification)
  {

    //maybe not needed!

    defaultIdentification = true;
    if(FTest.Identification.FrameName == undefined)
      FTest.Identification.FrameName = "";
    if(FTest.Identification.FrameLocation == undefined)
      FTest.Identification.FrameLocation = "";
    //if(FTest.Identification.FramePath == undefined)
    //  FTest.Identification.FramePath = "";
    if(FTest.Identification.Text == undefined)
      FTest.Identification.Text = "";
    if(FTest.Identification.PrecedingText == undefined)
      FTest.Identification.PrecedingTextText = "";
    if(FTest.Identification.FollowingText == undefined)
      FTest.Identification.FollowingText = "";
    if(FTest.Identification.IgnoreWhiteSpaces == undefined)
      FTest.Identification.IgnoreWhiteSpaces = true;
    if(FTest.Identification.CaseSensitive == undefined)
      FTest.Identification.CaseSensitive = true;

  }

  var once = false;
  if(FTest.Verification.Once)
    once = true;

  if((ThreadNum == 0 && RoundNum == 1) || !once)
  {
    var actualFrameSearch = false;
    var expectedFrameSearch = false;
    var actualFrame;
    var expectedFrame;
    var res;
    var frameMatcher;
    var frameName;
    var frameWarning = false;
    var linkMatcher;
    var expFrameMatcher;
    var actFrameMatcher;
    var foundLink = undefined;
    var index = false;
    var linkTestCaseReporter;
    var bestResult = -1;
    var bestScore = 100;  //biger that any possible score
    var error = false; //test passed successfully
    var framePath;
    var checkAbsence = false;
    var reportOnSuccess = false;
    var imageName = undefined;
    var imageSrc = undefined;
    var imgString = undefined;


    if(FTest.Verification.Absence || FTest.Verification.Occurrences == 0)
      checkAbsence = true;

    if(FTest.Action.ReportOnSuccess)
      reportOnSuccess = true;


    res = IdentifyFrames(FTest);
    if(res == undefined)
      return;
    expectedFrame = res.expFrame;
    actualFrame = res.actFrame;

    if(actualFrame.document.GetIdentLocation() != expectedFrame.document.GetIdentLocation())
      frameWarning = true;

    if(FTest.Identification.Text == undefined || FTest.Identification.Text =="")
    {
    	ReportTextIdentificationError(FTest,expectedFrame,actualFrame,frameWarning);
			InitObjects();
      return;
    }

    var precedingText = "";
    var followingText = "";
    var text = "";
    var resArray,resArray2;
    var source;
    var caseSensitive = false;
    var occurrences;


    if(FTest.Identification.PrecedingText != undefined)
    	precedingText = FTest.Identification.PrecedingText;
  	if(FTest.Identification.FollowingText != undefined)
    	followingText = FTest.Identification.FollowingText;
    if(FTest.Identification.Text != undefined)
    	text = FTest.Identification.Text;
    source = actualFrame.document.wlSource;
    if(FTest.Identification.IgnoreWhiteSpaces)  //delete all white spaces
    {
    	precedingText = precedingText.replace(/[\s]+/mg,"");
		followingText = followingText.replace(/[\s]+/mg,"");
		text = text.replace(/[\s]+/mg,"");
    	source = source.replace(/[\s]+/mg,"");
    }
    if(FTest.Identification.CaseSensitive)
    {
    	caseSensitive = true;
    	reg = new RegExp(precedingText+".*"+text+".*"+followingText,"gm");
    }
    else
    	reg = new RegExp(precedingText+".*"+text+".*"+followingText,"gim"); //ignore case

    resArray = source.match(reg);
    if(resArray) //the text was found at least once
    {
    	if(FTest.Verification.Occurrences == 0)
    	{
    		ReportTextWrongNumberOfOccurrences(FTest,expectedFrame,actualFrame,-1,frameWarning);
    	}
    	else
    	{
    		if(caseSensitive)
    			regText = new RegExp(text,"gm");
    		else
					regText = new RegExp(text,"gim");
				resArray2 = resArray[0].match(regText);
				occurrences = resArray2.length;
				if(FTest.Verification.Occurrences != occurrences)
				{
					ReportTextWrongNumberOfOccurrences(FTest,expectedFrame,actualFrame,occurrences,frameWarning);
				}
				else if(FTest.Action.ReportOnSuccess)
				{
					ReportTextSuccess(FTest,expectedFrame,actualFrame,frameWarning);
				}
			}
    }
    else //the text wasn't found
    {
    	if(FTest.Verification.Occurrences == 0)
    	{
    		if(FTest.Action.ReportOnSuccess)
    		{
					ReportTextSuccess(FTest,expectedFrame,actualFrame);
				}
			}
			else
			{
				ReportTextWrongNumberOfOccurrences(FTest,expectedFrame,actualFrame,0,frameWarning);
			}
    }

    InitObjects();
  }
}


function ReportTextWrongNumberOfOccurrences(FTest,expectedFrame,actualFrame,actualOccurrences,frameWarning)
{

	//initializing the reporter
	  var testName;
	  var message;
	   if(FTest.Name == undefined)
	    testName = "Test Case";
	   else
	    testName = FTest.Name;
	  textTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Failed");
	  textTestCaseReporter.maxSeverity = FTest.Action.VerificationSeverity;
	  textTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
	  if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
	    textTestCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
	  if(actualFrame.location != window.location)
	    textTestCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
	  if(frameWarning)
    	AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"Warning: The expected frame was found at a different location than the actual one.",textTestCaseReporter);
    if(actualOccurrences == -1) //the text was found
    	message = "The text was found.";
    else if (actualOccurrences == 0) //the text wasn't found
    	message = "The text was not found.";
    else
    	message = "The text was found "+actualOccurrences+" times instead of "+FTest.Verification.Occurrences;
    AddErrToReporter(TITLE_TYPE,CMP_TITLE,"",-1,-1,message,textTestCaseReporter);
    textTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
}


function ReportTextSuccess(FTest,expectedFrame,actualFrame,frameWarning)
{
	var testName;
	var message;
	if(FTest.Name == undefined)
		testName = "Test Case";
	else
	  testName = FTest.Name;
	if(frameWarning)
	{
		textTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Warning");
		AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"Warning: The expected frame was found at a different location than the actual one.",linkTestCaseReporter);
	}
	else
		textTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Succeeded");

	AddErrToReporter(TITLE_TYPE,CMP_TITLE,"",-1,-1,"The text test case succeeded.",textTestCaseReporter);
	textTestCaseReporter.maxSeverity = WLSuccess; //notification
	textTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
	if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
		textTestCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
	if(actualFrame.location != window.location)
		textTestCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
	if(frameWarning)
	{
		textTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Warning");
	}
	else
	{
		textTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Succeeded");
	}
}

function ReportTextIdentificationError(FTest,expectedFrame,actualFrame,frameWarning)
{
	//initializing the reporter
	var testName;
	var message;
	 if(FTest.Name == undefined)
		testName = "Test Case";
	 else
		testName = FTest.Name;
	textTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Failed");
	textTestCaseReporter.maxSeverity = FTest.Action.IdentificationSeverity;
	textTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
	if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
		textTestCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
	if(actualFrame.location != window.location)
		textTestCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
	if(frameWarning)
		AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"Warning: The expected frame was found at a different location than the actual one.",textTestCaseReporter);
	message = "Text cannot be identified.";
	AddErrToReporter(TITLE_TYPE,CMP_TITLE,"",-1,-1,message,textTestCaseReporter);
  textTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
}

function ImgTestCase(FTest)

{
	var defaultIdentification = false;
	FTest.Type = IMAGE_TYPE;

	if(!wlGlobals.Verification)
	{
			//InfoMessage("Test case will not be performed")
		return;
	}

	if(wlLocals.instrumentation == false)
			return;

	if(FTest.Identification.DefaultIdentification )
	{
			//maybe not needed!
		defaultIdentification = true;
		if(FTest.Identification.FrameName == undefined)
				FTest.Identification.FrameName = "";
		if(FTest.Identification.FrameLocation == undefined)
				FTest.Identification.FrameLocation = "";
			//if(FTest.Identification.FramePath == undefined)
			//	FTest.Identification.FramePath = "";
		if(FTest.Identification.Ordinal  == undefined)
				FTest.Identification.Ordinal = -0;

	}

		var once = false;
		if(FTest.Verification.Once )
			once = true;

		if((ThreadNum == 0 && RoundNum == 1) || !once)
		{
			var actualFrameSearch = false;
			var expectedFrameSearch = false;
			var actualFrame;
			var expectedFrame;
			var res;
			var frameMatcher;
			var frameName;
			var frameWarning = false;
			var nImgIdentified = 0;
			var expFrameMatcher;
			var actFrameMatcher;
			var foundImg = undefined;
			var index = false;
			var imgTestCaseReporter;
			var bestResult = -1;
			var bestScore = 100;  //biger that any possible score
			var error = false; //test passed successfully
			var framePath;
			var checkAbsence = false;
			var reportOnSuccess = false;
			var actName;
			var actId;
			var nIdentParam = 0;
			var actSrc;
			var actAlt;
			var actTitle;


			if(FTest.Verification.Absence)
				checkAbsence = true;

			if(FTest.Action.ReportOnSuccess)
				reportOnSuccess = true;


			res = IdentifyFrames(FTest);
			if(res == undefined)
				return;
			expectedFrame = res.expFrame;
			actualFrame = res.actFrame;

			if(actualFrame.document.GetIdentLocation() != expectedFrame.document.GetIdentLocation())
				frameWarning = true;



		if(defaultIdentification)//we will try to use def asm match, if Src and Ordinal defined or match 3 properties, if known
		{
			if (FTest.Identification.ImgSrc != undefined &&
				FTest.Identification.Ordinal != undefined )
			{
				imgMatcher = new WLLink(FTest.Identification.ImgSrc,"",FTest.Identification.Name,FTest.Identification.Id);
				foundImg = actualFrame.document.IdentifyImage(imgMatcher,FTest.Identification.Ordinal);

			}
			else
			{
				nImg = actualFrame.document.images.length;
				for (loop = 0; loop <nImg; loop++)
				{
					curImg = actualFrame.document.images[loop];
					actName = curImg.name;
					actId = curImg.id;
					actSrc = curImg.src;
					actAlt = curImg.alt;
					actTitle = curImg.title;

					if (FTest.Identification.Ordinal != -1)
					{
						nIdentParam++;
						if (loop == FTest.Identification.Ordinal)
							nImgIdentified++;
					}
					if (FTest.Identification.Name != undefined)
					{
						nIdentParam++;
						if (actName == FTest.Identification.Name)
							nImgIdentified++;
					}
					if (FTest.Identification.Id != undefined)
					{
						nIdentParam++;
						if (actId == FTest.Identification.Id)
							nImgIdentified++;
					}
					if (FTest.Identification.ImgSrc != undefined)
					{
						nIdentParam++;
						if (actSrc == FTest.Identification.ImgSrc)
							nImgIdentified++;
					}
					if (FTest.Identification.Alt != undefined)
					{
						nIdentParam++;
						if (actAlt == FTest.Identification.Alt)
							nImgIdentified++;
					}
					if (FTest.Identification.Title != undefined)
					{
						nIdentParam++;
						if (actTitle == FTest.Identification.Title)
							nImgIdentified++;
					}
					if((nIdentParam >= 3 && nImgIdentified == 3) ||
						(nIdentParam > 0 && nImgIdentified == nIdentParam) )
					{
						foundImg = curImg;
						break;
					}
				}
			}

			if(foundImg == undefined)
  			{
				if(!checkAbsence)
				{
					ReportIdentificationError(FTest,expectedFrame,actualFrame);
					InitObjects();
					return;
				}
				else
				{
					if(reportOnSuccess)
						ReportImgAbsence(FTest,expectedFrame,actualFrame);
					return;
				}
  			}
		}

		else
		{
			for(var i=0;i<actualFrame.document.images.length;i++)
			{
				if(FTest.Identification.Ordinal != undefined)
				{
					if(FTest.Identification.Ordinal >= 0 && FTest.Identification.Ordinal < actualFrame.document.images.length)
					{
						i = FTest.Identification.Ordinal;
						index = true;
					}
					else
						break;
				}
				if(FTest.Identification.Name != undefined)
				{
					if(actualFrame.document.images[i].name != FTest.Identification.Name)
					{
						if(index)
							break;
						else
							continue;
					}
				}
				if(FTest.Identification.Id != undefined)
				{
					if(actualFrame.document.images[i].id != FTest.Identification.Id)
					{
						if(index)
							break;
						else
							continue;
					}
				}
				if(FTest.Identification.ImgSrc != undefined)
				{
					if(actualFrame.document.images[i].src != FTest.Identification.ImgSrc)
						if(index)
							break;
						else
							continue;
				}
				if(FTest.Identification.Alt != undefined)
				{
					if(actualFrame.document.images[i].alt != FTest.Identification.Alt)
						if(index)
							break;
						else
							continue;
				}
				if(FTest.Identification.Title != undefined)
				{
					if(actualFrame.document.images[i].title != FTest.Identification.Title)
						if(index)
							break;
						else
							continue;
				}

				 //if we here then all properties matched

				foundImg = actualFrame.document.images[i];
				break;
			}

			if(foundImg == undefined )
			{
				if(!checkAbsence)
				{
					ReportIdentificationError(FTest,expectedFrame,actualFrame);
					InitObjects();
					return;
				}
				else
				{
					if(reportOnSuccess)
						ReportImgAbsence(FTest,expectedFrame,actualFrame);
					return;
				}
			}

			if(checkAbsence)
			{
				if(foundImg != undefined)
					ReportImgPresence(FTest,expectedFrame,actualFrame,foundImg);
				else
					ReportImgAbsence(FTest,expectedFrame,actualFrame);
				return;
			}
		}
	//verification








	//initializing the reporter




























	var testName;
   if(FTest.Name == undefined)
    testName = "Test Case";
   else
    testName = FTest.Name;
	imgTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Failed");
	imgTestCaseReporter.maxSeverity = FTest.Action.VerificationSeverity;
	imgTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;









	if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
		imgTestCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
	if(actualFrame.location != window.location)
		imgTestCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
	if(frameWarning)
		AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"Warning: The expected frame was found at a different location than the actual one.",linkTestCaseReporter);


	if(FTest.Verification.Ordinal != undefined)
		if(FTest.Verification.Ordinal != foundImg.wlSourceIndex)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,FTest.Verification.Ordinal,foundImg.wlSourceIndex,"The found image ordinal position is "+foundImg.wlSourceIndex+" and not "+FTest.Verification.Ordinal,imgTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Name != undefined)
		if(FTest.Verification.Name != foundImg.name)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The found image name is \""+foundImg.name+"\" and not \""+FTest.Verification.Name+"\"",imgTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Id != undefined)
		if(FTest.Verification.Id != foundImg.id)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The found image id is \""+foundImg.id+"\" and not \""+FTest.Verification.Id+"\"",imgTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.ImageSrc != undefined)
		if(FTest.Verification.ImageSrc != foundImg.src)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The found image source is \""+foundImg.src+"\" and not \""+FTest.Verification.ImageSrc+"\"",imgTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Alt != undefined)
		if(FTest.Verification.Alt != foundImg.alt)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The found image Alt is \""+foundImg.alt+"\" and not \""+FTest.Verification.Alt+"\"",imgTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Title != undefined)
		if(FTest.Verification.Title != foundImg.title)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The found image title is \""+foundImg.title+"\" and not \""+FTest.Verification.Title+"\"",imgTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Usermap != undefined)
		if(FTest.Verification.Usermap != foundImg.usermap)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The found image usermap is \""+foundImg.usermap+"\" and not \""+FTest.Verification.Usermap+"\"",imgTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Height != undefined)
		if(FTest.Verification.Height != foundImg.height)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The found image height is \""+foundImg.height+"\" and not \""+FTest.Verification.Height+"\"",imgTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Width != undefined)
		if(FTest.Verification.Width != foundImg.width)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The found image width is \""+foundImg.width+"\" and not \""+FTest.Verification.Width+"\"",imgTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Checksize || FTest.Verification.Integrity)
	{
			/*if(FTest.Verification.Filesize != foundImg.FileSize)
			{
				AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The size of file corresponding to the found image  is \""+foundImg.FileSize+"\" and not \""+FTest.Verification.FileSize+"\"",imgTestCaseReporter);
				error = true;
				if(FTest.Action.StopOnFailure)
				{
					imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
					InitObjects();
					return;
				} */
		}
	if(FTest.Verification.Integrity)
	{
			/*if(FTest.Verification.Checksum != foundImg.CheckSum)
			{
				AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The file corresponding to the found image  is different from the expected image file",imgTestCaseReporter);
				error = true;
				if(FTest.Action.StopOnFailure)
				{
					imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
					InitObjects();
					return;
				} */
		}

	if(!error) //the test passed without errors
	{
		if(frameWarning)
		{
			imgTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Warning");
			AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"Warning: The expected frame was found at a different location than the actual one.",imgTestCaseReporter);
		}
		else if (FTest.Action.ReportOnSuccess)
			imgTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Succeeded");
		if(frameWarning || FTest.Action.ReportOnSuccess)
		{
			AddErrToReporter(IMAGE_TYPE,CMP_IMAGES_BY_URL,foundImg.wlOrigUrl,foundImg.wlSourceIndex,foundImg.wlSourceIndex,"The img test case succeeded.",imgTestCaseReporter);
			imgTestCaseReporter.maxSeverity = WLSuccess; //notification
			imgTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
			if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
				 imgTestCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
			if(actualFrame.location != window.location)
				  imgTestCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
			if(frameWarning)
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Warning");
			}
			else
			{
				imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Succeeded");
			}
		}
	}
	else
	{
		imgTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
	}

  }//the "(ThreadNum == 0 && RoundNum == 1)" if
  InitObjects();
}

///////////////////////
function FormTestCase(FTest)
{
	var defaultIdentification = false;
	FTest.Type = FORM_TYPE;

	if(!wlGlobals.Verification)
	{
			//InfoMessage("Test case will not be performed")
		return;
	}

	if(wlLocals.instrumentation == false)
			return;

	if(FTest.Identification.DefaultIdentification )
	{
			//maybe not needed!
		defaultIdentification = true;
		if(FTest.Identification.FrameName == undefined)
				FTest.Identification.FrameName = "";
		if(FTest.Identification.FrameLocation == undefined)
				FTest.Identification.FrameLocation = "";
			//if(FTest.Identification.FramePath == undefined)
			//	FTest.Identification.FramePath = "";
		if(FTest.Identification.Ordinal  == undefined)
				FTest.Identification.Ordinal = 0;

	}

		var once = false;
		if(FTest.Verification.Once )
			once = true;

		if((ThreadNum == 0 && RoundNum == 1) || !once)
		{
			var actualFrameSearch = false;
			var expectedFrameSearch = false;
			var actualFrame;
			var expectedFrame;
			var res;
			var frameMatcher;
			var frameName;
			var frameWarning = false;
			var expFrameMatcher;
			var actFrameMatcher;
			var foundForm = undefined;
			var index = false;
			var imgTestCaseReporter;
			var bestResult = -1;
			var bestScore = 100;  //biger that any possible score
			var error = false; //test passed successfully
			var framePath;
			var checkAbsence = false;
			var reportOnSuccess = false;
			var actName;
			var actId;

			if(FTest.Verification.Absence)
				checkAbsence = true;

			if(FTest.Action.ReportOnSuccess)
				reportOnSuccess = true;


			res = IdentifyFrames(FTest);
			if(res == undefined)
				return;
			expectedFrame = res.expFrame;
			actualFrame = res.actFrame;

			if(actualFrame.document.GetIdentLocation() != expectedFrame.document.GetIdentLocation())
				frameWarning = true;


		if(defaultIdentification)//we will try to use def asm match, if Src and Ordinal defined or match 3 properties, if known
		{

			formMatcher = new WLLink(FTest.Identification.Action,"",FTest.Identification.Name,FTest.Identification.Id);
			foundForm = actualFrame.document.IdentifyForm(formMatcher,FTest.Identification.Ordinal);

			if(foundForm == undefined)
  			{
				if(!checkAbsence)
				{
					ReportIdentificationError(FTest,expectedFrame,actualFrame);
					InitObjects();
					return;
				}
				else
				{
					if(reportOnSuccess)
						ReportFormAbsence(FTest,expectedFrame,actualFrame);
					return;
				}
  			}
		}

		else
		{
			for(var i=0;i<actualFrame.document.forms.length;i++)
			{
				if(FTest.Identification.Ordinal != undefined)
				{
					if(FTest.Identification.Ordinal >= 0 && FTest.Identification.Ordinal < actualFrame.document.forms.length)
					{
						i = FTest.Identification.Ordinal;
						index = true;
					}
					else
						break;
				}
				if(FTest.Identification.Name != undefined)
				{
					if(actualFrame.document.forms[i].name != FTest.Identification.Name)
					{
						if(index)
							break;
						else
							continue;
					}
				}
				if(FTest.Identification.Id != undefined)
				{
					if(actualFrame.document.forms[i].id != FTest.Identification.Id)
					{
						if(index)
							break;
						else
							continue;
					}
				}
				if(FTest.Identification.Action != undefined)
				{
					linkMatcher1 = new WLLink(FTest.Identification.Action,"","","");
					linkMatcher2 = new WLLink(actualFrame.document.forms[i].action,"","","");
					res = linkMatcher1.UrlCompare(linkMatcher2); //if true we have url matching
					if(res < 1) //no matching
						if(index)
							break;
						else
							continue;
					else
					{
						if(res < bestScore && res > -1)
						{
							bestResult = i;
							bestScore = res;
						}
						if(index || res == 1) //in case we're checking by index or we have perfect match
							break;
					}
				}
				else //all properties matched and the url isn't used for identification
				{
					foundForm = actualFrame.document.forms[i];
					break;
				}
			}
		}

		if(foundForm == undefined && (bestResult == -1))
		{
			if(!checkAbsence)
			{
				ReportIdentificationError(FTest,expectedFrame,actualFrame);
				InitObjects();
				return;
			}
			else
			{
				if(reportOnSuccess)
						ReportFormAbsence(FTest,expectedFrame,actualFrame);
				return;
			}
		}
		else if(bestResult > -1)
			foundForm = actualFrame.document.forms[bestResult];

		if(checkAbsence)
		{
			if(foundForm != undefined)
				ReportFormPresence(FTest,expectedFrame,actualFrame,foundForm);
			else
				ReportFormAbsence(FTest,expectedFrame,actualFrame);
			return;
		}

	//verification
	//initializing the reporter
	var testName;
   if(FTest.Name == undefined)
    testName = "Test Case";
   else
    testName = FTest.Name;
	formTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Failed");
	formTestCaseReporter.maxSeverity = FTest.Action.VerificationSeverity;
	formTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;

	if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
		formTestCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
	if(actualFrame.location != window.location)
		formTestCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
	if(frameWarning)
		AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"Warning: The expected frame was found at a different location than the actual one.",linkTestCaseReporter);

	if(FTest.Verification.Ordinal != undefined)
		if(FTest.Verification.Ordinal != foundForm.wlSourceIndex)
		{
			AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",FTest.Verification.Ordinal,foundForm.wlSourceIndex,"The found form ordinal position is "+foundForm.wlSourceIndex+" and not "+FTest.Verification.Ordinal,formTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Name != undefined)
		if(FTest.Verification.Name != foundForm.name)
		{
			AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",foundForm.wlSourceIndex,foundForm.wlSourceIndex,"The found form name is \""+foundForm.name+"\" and not \""+FTest.Verification.Name+"\"",formTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Id != undefined)
		if(FTest.Verification.Id != foundForm.id)
		{
			AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",foundForm.wlSourceIndex,foundForm.wlSourceIndex,"The found form id is \""+foundForm.id+"\" and not \""+FTest.Verification.Id+"\"",formTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Action != undefined)
		if(FTest.Verification.Action != foundForm.action)
		{
			AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",foundForm.wlSourceIndex,foundForm.wlSourceIndex,"The found form action is \""+foundForm.action +"\" and not \""+FTest.Verification.Action+"\"",formTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Encoding != undefined)
		if(FTest.Verification.Encoding != foundForm.encoding)
		{
			AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",foundForm.wlSourceIndex,foundForm.wlSourceIndex,"The found form encoding is \""+foundForm.encoding+"\" and not \""+FTest.Verification.Encoding+"\"",formTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Method != undefined)
		if(FTest.Verification.Method != foundForm.method)
		{
			AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",foundForm.wlSourceIndex,foundForm.wlSourceIndex,"The found form method is \""+foundForm.method+"\" and not \""+FTest.Verification.Method+"\"",formTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}
	if(FTest.Verification.Target != undefined)
		if(FTest.Verification.Target != foundForm.target)
		{
			AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",foundForm.wlSourceIndex,foundForm.wlSourceIndex,"The found form target is \""+foundForm.target+"\" and not \""+FTest.Verification.Target+"\"",formTestCaseReporter);
			error = true;
			if(FTest.Action.StopOnFailure)
			{
				formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
				InitObjects();
				return;
			}
		}

	if(!error) //the test passed without errors
	{
		if(frameWarning)
		{
			formTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Warning");
			AddErrToReporter(FRAME_TYPE,CMP_FRAMES_BY_URL,"",-1,-1,"Warning: The expected frame was found at a different location than the actual one.",formTestCaseReporter);
		}
		else if (FTest.Action.ReportOnSuccess)
			formTestCaseReporter = new MyVerificationReporter("Test Case",testName+" Succeeded");
		if(frameWarning || FTest.Action.ReportOnSuccess)
		{
			AddErrToReporter(FORM_TYPE,CMP_FORMS_BY_URL,"",foundForm.wlSourceIndex,foundForm.wlSourceIndex,"The form test case succeeded.",formTestCaseReporter);
			formTestCaseReporter.maxSeverity = WLSuccess; //notification
			formTestCaseReporter.reporter.ExpectedItemId = wlHttp.ExpectedDOMID;
			if(expectedFrame.location != wlGlobals.ExpectedDOMs[wlHttp.ExpectedDOMID].location)
				formTestCaseReporter.reporter.Location1 = expectedFrame.document.GetIdentLocation();
			if(actualFrame.location != window.location)
				formTestCaseReporter.reporter.Location2 = actualFrame.document.GetIdentLocation();
			if(frameWarning)
			{
				formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Warning");
			}
			else
			{
				formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Succeeded");
			}
		}
	}
	else
	{
		formTestCaseReporter.Report(expectedFrame,actualFrame,testName+" Failed");
	}

  }//the "(ThreadNum == 0 && RoundNum == 1)" if
  InitObjects();
}

