/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#include "httpembedderreport.h"

#include "httpcallback.h"

#include "platform.h"
#include "tvtables.h"
#include "tracedll.h"
#include "wlerrorlib.h"


void cHttpEmbedderReportInfoPageStartDownload:: fApply(
    tSCActionReporterReturn& eRet,
    iLoadSingleClient& pPBC,
    iReportThreadState* threadState)
  {
      eRet = dynamic_cast<iHttpProbingClientGeneral&>(pPBC).pageStartDownload(*threadState, m_pUrlData, m_lExpectedDomId, m_lActiveDomId);
  }



void cHttpEmbedderReportInfoPageAbortDownload::fApply(
    tSCActionReporterReturn& eRet,
    iLoadSingleClient& pPBC,
    iReportThreadState* threadState)
  {
      eRet = dynamic_cast<iHttpProbingClientGeneral&>(pPBC).pageAbortDownload(*threadState, m_pUrlData);
  }



void cHttpEmbedderReportInfoPageEndDownload::fApply(
    tSCActionReporterReturn& eRet,
    iLoadSingleClient& pPBC,
    iReportThreadState* threadState)
  {
      eRet = dynamic_cast<iHttpProbingClientGeneral&>(pPBC).pageEndDownload(*threadState, m_pUrlData);
  }



void cHttpEmbedderReportInfoObjectStartDownload::fApply(
    tSCActionReporterReturn& eRet,
    iLoadSingleClient& pPBC,
    iReportThreadState* threadState)
  {
      eRet = dynamic_cast<iHttpProbingClientGeneral&>(pPBC).objectStartDownload(*threadState, m_pUrlData);
  }



void cHttpEmbedderReportInfoObjectAbortDownload::fApply(
    tSCActionReporterReturn& eRet,
    iLoadSingleClient& pPBC,
    iReportThreadState* threadState)
  {
      eRet = dynamic_cast<iHttpProbingClientGeneral&>(pPBC).objectAbortDownload(*threadState, m_pUrlDataEx);
  }



void cHttpEmbedderReportInfoObjectEndDownload::fApply(
    tSCActionReporterReturn& eRet,
    iLoadSingleClient& pPBC,
    iReportThreadState* threadState)
  {
      eRet = dynamic_cast<iHttpProbingClientGeneral&>(pPBC).objectEndDownload(*threadState, m_pData);
  }


void cHttpEmbedderReportInfoUseCachedObject::fApply(
    tSCActionReporterReturn& eRet,
    iLoadSingleClient& pPBC,
    iReportThreadState* threadState)
  {
      eRet = dynamic_cast<iHttpProbingClientGeneral&>(pPBC).UseCachedObject(*threadState, m_pUrlDataEx);
  }