/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef HEADER_CHttpProbingClientUITest
#define HEADER_CHttpProbingClientUITest

#ifdef __TV_WINDOWS__
#define OUTPUT_FILENAME "c:\\output.txt"
#else
#define OUTPUT_FILENAME "output.txt"
#endif

#include "BPLoadUI.h"

class CHttpProbingClientUITest: public ILoadProbingClientUITest {
public:
  enum FilterFlags{FILTER_NONE, FILTER_ALL, FILTER_HTTP, FILTER_NO_HTTP, FILTER_BRUTAL};

public:
	explicit CHttpProbingClientUITest( cSingleClientProcess&, int nRoundsToDo=0, int nFlagFilter=0);
	virtual ~CHttpProbingClientUITest();

	void Session(	iSingleClientMachineThread&, const char* InitializationScript, iAgendaFile& File, const char* AgendaName, int ThreadNum, unsigned long RoundNum );

  tSCActionReporterReturn pageStartDownload(iReportThreadState& threadState, CUrlData* pUrlData, long lExpectedDomId, long &lActiveDomId);
  tSCActionReporterReturn pageAbortDownload(iReportThreadState& threadState, CUrlData* pUrlData);
  tSCActionReporterReturn pageEndDownload(iReportThreadState& threadState, CUrlData* pUrlData);
  tSCActionReporterReturn objectStartDownload(iReportThreadState& threadState, CUrlData* pUrlData);
  tSCActionReporterReturn objectAbortDownload(iReportThreadState& threadState, CUrlDataEx* pUrlDataEx);
  tSCActionReporterReturn objectEndDownload(iReportThreadState& threadState, CallbackData* pData);
  tSCActionReporterReturn UseCachedObject(iReportThreadState& threadState, CUrlDataEx* pUrlDataEx);
	
		virtual void fRecordEvent(long eventID,
			  										long topInstanceID,
			  										long instanceID,
														WLLogMessage::Severity severity,
														const char* eventName,
														double time,
														long lineNumber,
														const char* fileName,
														const char* description, 
														const char* extraDataType,
														const char* extraData);

	virtual void fBeginTransaction(long instanceID, 
																 const char* transactionName, 
																 const char* transactionType);

	virtual void fEndTransaction(long topInstanceID, 
															 long instanceID, 
															 long parentID, 
															 unsigned long roundNum,
															 const char* reason,
															 const char* transactionName,
															 double time, 
															 WLLogMessage::Severity severity,
															 const char* transactionType, 
															 const char* extraData);

  bool fInvokeDMHook( bool rIsFunction, tInvocationDMHookType, iDMThreadState* ) {return true;}
  void fReportDMHook(tInterruptionControl&, bool& oIsHookPosition, tStepping, iDMThreadState&){}
  void ResetOutputFile();

protected:
  int m_nFlagFilter;
};



#endif