/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <stdio.h>
#include <stdlib.h>
#include <RVCString.h>
#include "platform.h"
#include "tvtables.h"
#include "tvenv.h"
#include "wlerrorlib.h"
#include "loadengineglobals.h"

#include "tracedll.h"

static int count=1;

int WLHttpInit(bool bCallback);
int WLHttpTerminate();

void main(int argc, char *argv[])
{
#ifdef __TV_UNIX__
	char thisFileName[MAX_PATH];
	if ( !TVEInit(TVPGetPathDirectory( (const char *)realpath(argv[0],thisFileName ))))
	{
		TVPFatalErrorLog("tvenv.dll: Init Terminated with error: (%s)",TVEError());
		exit(-1);
	}
#endif
  CTraceMsg::Init ("HttpTest") ; 

	WLHttpInit(false); 

	WLLoadSingleTestMain(argv[1]); 
	TVSTerminate();
	WLERRTerminate();

	WLHttpTerminate();

#ifndef __TV_UNIX__
	ExitProcess(0);
#else
	exit(0);
#endif
//  return 1;
} 
