/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
//#define _CRTDBG_MAP_ALLOC
#ifdef __TV_WINDOWS__
#endif // __TV_WINDOWS__
#include "bphttpui.h"
#include "tracedll.h"
#include "loadengineinifileproperties.h"
#include "loadengineglobals.h"
//#include <stdio.h>


#ifdef __TV_UNIX__
#include "tvenv.h"
#include <pthread.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#endif


bool BeforeSession( int& SessionsToDo, int& RoundsToDo, int& nFlagFilter) 
{
	if( SessionsToDo == 0 ) 
  {
		printf( "Enter num of Sessions, 0 to exit :" );
		scanf( "%d", &SessionsToDo );
    if (SessionsToDo<=0)
      return false ;
  }
  if ( RoundsToDo == 0 )
  {
    printf("Enter num of Round :");
    scanf("%d", &RoundsToDo );
    printf("Enter filter flag :");
    scanf("%d", &nFlagFilter);
  }
	
	return( SessionsToDo-- > 0 );
}


//void main(int argc, char *argv[])
int main(int argc, char *argv[])
{
#ifdef __TV_UNIX__
  TVEnvContainerClass tvpc;
  char thisFileName[MAX_PATH];
  memset(thisFileName,0,sizeof(thisFileName));
  (void)realpath(argv[0],thisFileName);
  const char* pathDir = tvpc.TVPGetPathDirectory(thisFileName);
  if( !TVEInit(pathDir))
  {
    TVPFatalErrorLog("httpcallbacktest: Init Terminated with error: (%s)",TVEError());
    exit(-1);
  }
  // create signal handler
  tvpc.reset();
  const char *SignalMask = tvpc.TVEGetEnv(ENV_SIGNAL_MASK);
  TVPSignalHandler *hnd = new TVPSignalHandler(SignalMask?SignalMask:"");

#endif // __TV_UNIX__

  int SessionsToDo = 0;
  int RoundsToDo = 0 ;
  bool bExit = false ;
  char cFileName[1024]="";
  int  nFlagFilter=0;
  RVCString sInitAgenda("");

  CTraceMsg::Init ("HttpCallbackTest");

  if (argc <= 1)
  {
    printf("The arguments are: <path File.js> <int Sessions> <int Rounds> <close after(def. = 0)> <FilterFlag(def. = 0)>\n");
    printf("You have to enter file's name in the arguments, or Q to quit:\n");
    while (!cFileName[0])
    {
      scanf("%s",cFileName);
      if (strlen(cFileName)==1 && (cFileName[0]=='Q'||cFileName[0]=='q'))
    exit(0);
  }
  }

  if (argc >= 3)
  {
    SessionsToDo = atoi(argv[2]);
    RoundsToDo = atoi(argv[3]);
  }
  
    if (argc > 4)
      bExit = atoi(argv[4]) > 0;

  if (argc > 5)
    nFlagFilter = atoi(argv[5]);

  if (argc > 6)
  {
    const char* pcInitAgenda = argv[6];
    sInitAgenda.append(pcInitAgenda);
  }
  {
    // @@Chaim - really annoying fix to get protocol_httpcallbacktest to work
    SetExtraProtocol(WLE_ADDPROTOCOL_HTTP);
 	  cSingleClientProcess SingleClientProcessObject;
	  SingleClientProcessObject.fInit();
    SetExtraProtocol(WLE_ADDPROTOCOL_HTTP);

		cSingleClientMachineThread MThread;
		MThread.fInit(THREAD_TYPE_VC);

    while (BeforeSession(SessionsToDo, RoundsToDo, nFlagFilter)) 
    {
      printf("\n\n\tNew session : \n");

      // session
      CScriptFile* pFile;
      if (cFileName[0])
        pFile = new CScriptFile(cFileName);
      else
        pFile = new CScriptFile(argv[1]);


#ifdef __TV_UNIX__
    if(getenv("WL_EXTERNAL_MONITORCHARSET"))
    {
        SetMonitorCharSet(atoi(getenv("WL_EXTERNAL_MONITORCHARSET")));
    }
      printf("Monitor Charset: %u \n", GetMonitorCharSet());
#endif

      CHttpProbingClientUITest HPC( SingleClientProcessObject, RoundsToDo, nFlagFilter);

      CTraceMsg::Init("ProbingClientTest");
      HPC.ResetOutputFile();

      HPC.Session( MThread, sInitAgenda.data(), *pFile, "ProbingClientTest", 0, 1 );	 
      delete pFile;

      if (bExit)
        break;
    }

		MThread.fFinal();
    SingleClientProcessObject.fTerminate();
  }
  
  return 0;
}

