//************************
// DB general functions
//************************

function ConnectionDetails ()
{
	this.DBType = "MDB"
	this.MDBFileName = ""
	this.ServerName = ""
	this.DatabaseName = ""
	this.UserName = ""
	this.Password = ""
}
function DBConnect (ConnectionDetails)
{
	var Conn1;
	Conn1= new ActiveXObject("ADODB.Connection")
	switch (ConnectionDetails.DBType)
	{   
		case "MDB" :
			//Open connection to MDB database using OLEDB
			Conn1.Open("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + ConnectionDetails.MDBFileName + ";Persist Security Info=False")
			break;   
		case "SQLServer":
		    var ConnStr = "Provider=sqloledb;" +  
					   "Data Source=" + ConnectionDetails.ServerName + ";" +
					   "Initial Catalog=" + ConnectionDetails.DatabaseName + ";" +
					   "User Id=" + ConnectionDetails.UserName + ";" +
					   "Password=" + ConnectionDetails.Password;
			Conn1.Open (ConnStr);
			break;
		case "Oracle":
            var ConnStr = "Provider=OraOLEDB.Oracle;" +  
					   "Data Source=" + ConnectionDetails.DatabaseName + ";" +
					   "User Id=" + ConnectionDetails.UserName + ";" +
					   "Password=" + ConnectionDetails.Password;
			Conn1.Open (ConnStr);
			break;
		default : 
			SevereErrorMessage ("UnSupported Database type");
	}
	return Conn1;
}

//************************
//DBUtils functions
//************************
function DBGetLineInitAgenda(ConnDetails, SQL, TempFile, TempFileDelimiter, MaxRecs, SliceSize) 
{
	var GLCon;
	var GLRS;
	

	wlSystemGlobal.Add("DBGLCounter",1,  WLCurrentAgenda)
	DBGLStartSlice = (wlSystemGlobal.Get("DBGLCounter", WLCurrentAgenda)-1) * SliceSize 

	//Open connection to database using OLEDB
	GLCon = DBConnect (ConnDetails)

	//Open RecordSet and get the data
	GLRS = new ActiveXObject("ADODB.Recordset");
	GLRS.Open(SQL, GLCon, 0);
	//Openthe temp file
	var TempFileName = GetWLTempPath() + "\\" + TempFile;
	//var TempFileName = "C:\\" + TempFile;
	GLTempFileObj = new wlOutputFile(TempFileName);
	GLTempFileObj.Open();

	var rec;
	var count = 0;
	//Skip records to start of slice
	while ((!GLRS.EOF) && (count < MaxRecs) && (count < DBGLStartSlice))
	{
		GLRS.MoveNext();
		count++;
	}
	//Get the slice records
	while ((!GLRS.EOF) && (count < MaxRecs) && (count < DBGLStartSlice+SliceSize))
	{
		rec = "";
		for ( i = 0; i < GLRS.Fields.Count - 1; i++)
		{
		  rec = rec + GLRS.Fields.Item(i).Value + TempFileDelimiter
		}
		rec = rec + GLRS.Fields.Item(GLRS.Fields.Count-1).Value;
		GLTempFileObj.Writeln(rec);
		GLRS.MoveNext();
		count++;
	}
	//Close connection to MDB database using OLEDB
	GLCon.Close()
	//Close temp file
	GLTempFileObj.Close();
	Open (TempFileName);
	
	return TempFileName;
}

function DBGetLineTerminateAgenda()
{
	//remove temporary file
	//GLTempFileObj.Remove()
	delete GLTempFileObj;
}

//************************
//DBLoad functions
//************************

function DBLoadInitAgenda(InpFile) 
{
	var LocalInpFile
	LocalInpFile = CopyFile(InpFile)			
	Open (LocalInpFile);
	return LocalInpFile;
}
function DBLoadInitClient(ConnectionDetails)
{
	return DBConnect(ConnectionDetails);
}

function DBLoad_VerificationFunction(e)
{
	SetFailureReason(e.GetMessage())
	return e.GetSeverity()
}
function DBLoadMain(Connection, InpFile, InpFileDelimiter) 
{
	//Get next command from the input file
	//Input file record should be formatted as follows:
	//  Transaction Name#Command to execute
	strArr = GetLine(InpFile, InpFileDelimiter)		
	//Wrap the command execution with a transaction (the name of the transaction is also taken from the file)
	if (strArr.length == 3) 
	{
		COMExceptionsOn() 
		try {
			BeginTransaction(strArr[1])
			//Execute command
			Connection.Execute (strArr[2])
			//Close transaction
			EndTransaction(strArr[1],WLSuccess,false)
		}
		catch (e)
		{
			EndTransaction(strArr[1],DBLoad_VerificationFunction(e),false)
		}
		COMExceptionsOff() 
	}
}
function DBLoadTerminateClient(Connection)
{
	//Close connection to database using OLEDB
	Connection.Close()
}
function DBLoadTerminateAgenda(ConnectionDetails, ResetCommand)
{
	var Conn1
	
	//Close (InpFile);
	if (ResetCommand != "") 
	{
		Conn1 = DBConnect (ConnectionDetails)
		Conn1.Execute (ResetCommand)
		Conn1.Close()
	}
}

