//////////////////////////////////////////////////////////////////////////////////
// IdeParamLib.js
//	
// Contain all functions defined for IDE parameterization internal variables.
//
//////////////////////////////////////////////////////////////////////////////////

function CurrentIPAddress()
{
	return wlHttp.GetIPAddress();
}

function RandomNumber()
{
	return wlRand.Num();
}

function TodaysDate()
{
	return GetDateValue("TodaysDate");
}

function TodaysDay()
{
	return GetDateValue("TodaysDay");
}

function TodaysMonth()
{
	return GetDateValue("TodaysMonth");
}

function ThisYear()
{
	return GetDateValue("ThisYear");
}

function Hours()
{
	return GetDateValue("Hours");
}

function Minutes()
{
	return GetDateValue("Minutes");
}

function Seconds()
{
	return GetDateValue("Seconds");
}

function Milliseconds()
{
	return GetDateValue("Milliseconds");
}

function Time()
{
	return GetDateValue("Time");
}

function GMTDate()
{
	return GetDateValue("GMTDate");
}

function LocalDate()
{
	return GetDateValue("LocalDate");
}

function GetDateValue(sType)
{
	var retValue;
	var curDate = new Date();

	switch(sType)
	{
		case "TodaysDate":
			retValue = curDate.getDate();
			break;

		case "TodaysDay":
			retValue = curDate.getDay() + 1;
			break;

		case "TodaysMonth":
			retValue = curDate.getMonth() + 1;
			break;

		case "ThisYear":
			retValue = curDate.getFullYear();
			break;

		case "Hours":
			retValue = curDate.getHours();
			break;

		case "Minutes":
			retValue = curDate.getMinutes();
			break;

		case "Seconds":
			retValue = curDate.getSeconds();
			break;

		case "Milliseconds":
			retValue = curDate.getMilliseconds();
			break;

		case "Time":
			retValue = curDate.getTime();
			break;

		case "GMTDate":
			retValue = curDate.toGMTString();
			break;

		case "LocalDate":
			retValue = curDate.toString();
			break;

		default:
			break;
	}
	delete curDate;
	return retValue;
}
