/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// ProtocolAutoDiscovery.h: interface for the CProtocolAutoDiscovery class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROTOCOLAUTODISCOVERY_H__A3E6C62B_1BB9_43BF_8829_25954FA82EC6__INCLUDED_)
#define AFX_PROTOCOLAUTODISCOVERY_H__A3E6C62B_1BB9_43BF_8829_25954FA82EC6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "tvenv.h"
#include <RVCString.h>

#define USE_MSXML
#ifdef USE_MSXML
#include "crvxmldocument.h"
#include "crvxmlelement.h"
#else
#include "rvxmldocument.h"
#include "rvxmlelement.h"
#endif // USE_MSXML


class CProtocolAutoDiscovery  : public CFindFileFunctor
{
public:
	CProtocolAutoDiscovery();
	virtual ~CProtocolAutoDiscovery();

	virtual bool handleFile( const char* filePath );
	const char* getLastError();
	bool discoverPath( const char* path, const char* spec, bool lookInSubDirs,
						RVCString** pProtocols, RVCString** pProtocolNames, int* index, int arraySize );

protected:
	bool getDllInfo( CRVXMLElement* pDllNode, RVCString& DllName, RVCString& DllDisplayName, RVCString& DllVersion, RVCString& DllVendor );

protected:
	RVCString m_LastErrorDescription;
	RVCString** m_pProtocols;
	RVCString** m_pProtocolNames;
	int* m_pIndex;
	int m_ArraySize;
};

#endif // !defined(AFX_PROTOCOLAUTODISCOVERY_H__A3E6C62B_1BB9_43BF_8829_25954FA82EC6__INCLUDED_)
