/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// VariableProperties.h: interface for the CGlobalVariableProperties class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_VARIABLEPROPERTIES_H__)
#define _VARIABLEPROPERTIES_H__

#include "platform.h"

#include <collint.h>
#include <stdlib.h>


#define GLOBALS_BOOL    'B'
#define GLOBALS_NUMBER  'N'
#define GLOBALS_STRING  'S'

typedef int    GlobalsBool;
typedef double GlobalsDouble;
typedef char*  GlobalsString;


class DllExport CGlobalVariableProperties: public RVCollectable
{
private:
	char    varType[2];
	char    *varValue;

private:
	inline void CreateValue(const char* value);

public:
	CGlobalVariableProperties(void);
	CGlobalVariableProperties(const char *type, const char *value);
	virtual ~CGlobalVariableProperties(void);

	void SetValue(GlobalsBool newBoolValue);
	void SetValue(double newNumberValue);
	void SetValue(const char* newStringValue);

	bool GetBoolValue(GlobalsBool& getBoolValue);
	bool GetNumberValue(double& getNumberValue);
	bool GetStringValue(char*& getStringValue);

	bool IsBoolType(void);
	bool IsNumberType(void);
	bool IsStringType(void);

	const char* GetUnformatedCharValue(void) const { return varValue; }
	const char* GetType(void) const                { return varType;  }
};

#endif // !defined(AFX_VARIABLEPROPERTIES_H__A5DD65F3_4B93_11D4_8807_0004AC15A422__INCLUDED_)

