/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __RVCSJSCOMPILERINTERVENTION_H
#define __RVCSJSCOMPILERINTERVENTION_H

#include "rvjsgeneral.h"
#include <RVCString.h>

// These are the Spidermonkey compiler error codes. They are defined in a MSG file,
// so we have to duplicate them here
#define JSMSG_PAREN_BEFORE_FORMAL 69
#define JSMSG_UNTERM_CLASS 55

typedef enum CompileErrorType {
  CompileErrorUnfixable,
  CompileErrorVBStyleFunctionDefine,
  CompileErrorInvalidRegExpreAllowedByIE
} CompileErrorType;




JSBool fsReferenceErrorCallback (JSContext *cx, const char *name);

JSBool fsCompileErrorCallback (JSContext *cx, uintN errorNumber, const char *linebuf,
                                    const char *filename, uintN currentLine);

CompileErrorType fsGetCurrentCompileErrorType(JSContext *cx);

bool fsFixCompileError(JSContext *cx, CompileErrorType pCompileErrorType, RVCString& pSource);

JSBool fsExtraWhiteSpaceCallback (JSContext* cx, int32 c);

JSBool fsReservedKeywordsCallback (JSContext* cx);


#endif //__RVCSJSCOMPILERINTERVENTION_H

