/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// @@Merged
#ifndef _wljsexception_h_
#define _wljsexception_h_


#include "loadreportinfo.h"
#include <collint.h>
#include <ordered.h>
/*
 *  WL JS Exception object class interface.
 */

bool AddJSExceptionClass(JSContext *cx, JSObject *obj);

extern JSObject* NewJSExceptionObject(JSContext *cx, WLLogMessage::Severity severity, const char* message, bool HasTime, double time );

extern JSClass* GetJsExceptionClass();


class CExceptionError : public RVCollectableInt
{

private:
	WLLogMessage::Severity mSeverity;
	RVCString              mMessage;
	bool                   mHasTime;
	double                 mTime;

public:
  CExceptionError(iReportInfo &Info);
  CExceptionError::CExceptionError(WLLogMessage::Severity	severity, const char* msg, bool HasTime, double time);

  WLLogMessage::Severity	GetSeverity() {return mSeverity;}
	const char*	      			GetMessage()  {return mMessage;}
	bool                    HasTime()      {return mHasTime;}
  double                  GetTime()     {return mTime;} 

};

class CJSExceptionPrivate
{

public:
	CJSExceptionPrivate::CJSExceptionPrivate(WLLogMessage::Severity	severity, const char* msg, bool HasTime, double time);
  ~CJSExceptionPrivate();
//	:
//		m_Severity( severity ),
//		m_Message(msg),
//		m_FileName(""),
//		m_LineNum(-1)
//		{}

	WLLogMessage::Severity	GetSeverity()     {return m_Severity;}
	const char*	      			GetMessage()      {return m_Message;}
  bool                    HasTime()          {return m_HasTime;}
  double                  GetTime()         {return m_Time;} 
	iReportThreadState& GetReportThreadState() {return m_ReportThreadState;}
  RVOrdered&              GetExceptionList(){return m_ExceptionList;}
  int                     GetSevereIndex()  {return m_SevereIndex;}

  void                    SetException(iReportInfo &Info);
  
  
private:

	WLLogMessage::Severity	m_Severity;
	RVCString				        m_Message;
	bool                    m_HasTime;
	double                  m_Time;
	coReportThreadState m_ReportThreadState;
	RVOrdered               m_ExceptionList;
  int                     m_SevereIndex;
};

#endif

