/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WLLEProtocolEmbed_H
#define __WLLEProtocolEmbed_H

#include "rvjsembed.h"
#include "platform.h"

class DllExport iLEProtocolJSEmbedContext;


//####### The declaration of the class iLEProtocolJSEmbedContext  #########

class iLEProtocolJSEmbedContext {
friend class cLEProtocolJSClientMachineThread;
public:
	explicit iLEProtocolJSEmbedContext();
	virtual ~iLEProtocolJSEmbedContext();

	iSession& fGetSession();
	void fReport( iReportInfo& );

	virtual bool IsJSActive() = 0;

	void fHardReportCommit( iReportInfo&);

	bool fIsJSGC();
	JSContext* fCurrentJSContext();

  virtual iLEJSEmbedContext& GetInternalLEJSEmbedContext() = 0;

};

#endif

