/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// JarsAutoDiscovery.cpp: implementation of the CJarsAutoDiscovery class.
//
//////////////////////////////////////////////////////////////////////

#include "JarsAutoDiscovery.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CJarsAutoDiscovery::CJarsAutoDiscovery()
: m_paClassPathVar( NULL )
, m_pSeparator( NULL )
{

}


CJarsAutoDiscovery::~CJarsAutoDiscovery()
{

}


bool CJarsAutoDiscovery::handleFile( const char* filePath )
{
	m_paClassPathVar->operator +=( filePath );
	m_paClassPathVar->operator +=( m_pSeparator );

	return true;
}


bool CJarsAutoDiscovery::discoverPath( const char* path, const char* spec, bool lookInSubDirs,
										RVCString& aClassPathVar, const char* separator )
{
	m_paClassPathVar = &aClassPathVar;
	m_pSeparator = separator;

	if( NULL == m_paClassPathVar || NULL == m_pSeparator )
		return true;

	bool res =  FindFile( path, spec, lookInSubDirs, this );

	m_paClassPathVar = NULL;
	m_pSeparator = NULL;

	return res;
}
