/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <iostream.h>
#include <RVCString.h>

#include "rvjsapi.h"

JSBool
proto_resolve_stub(JSContext *cx, JSObject *obj, jsval id) {
  jsval v;
  JSObject *func;
  const char* name;
  JSBool ok;

  //JS_BeginRequest(cx);

  if (!JSVAL_IS_STRING(id)) return JS_FALSE; 
  name = JS_GetStringBytes(JSVAL_TO_STRING(id));
  if (!name) return JS_FALSE; 
  //cout << "Proto resolve stub: called with - " << name <<  " Thread " << JS_GetContextThread(cx) << endl;
  
  JSObject* proto = JS_GetPrototype(cx,obj);
  if (!proto) return JS_FALSE;


  // cloning WL functions

  ok = JS_LookupProperty(cx,proto,name,&v);
  if (!ok) return JS_FALSE;

  if (!JSVAL_IS_VOID(v)) {
    if (JS_TypeOfValue(cx,v) == JSTYPE_FUNCTION) {
      //cout << "Proto resolve stub: resolving function - " << name << endl;

      func = JS_CloneFunctionObject(cx, JSVAL_TO_OBJECT(v), obj);
      if (!func) return JS_FALSE;

      ok = JS_DefineProperty(cx,obj, name ,OBJECT_TO_JSVAL(func), JS_PropertyStub, JS_PropertyStub, JSPROP_ENUMERATE | JSPROP_PERMANENT);
      if (!ok) return JS_FALSE;
    }
  }

  //JS_EndRequest(cx);
  return JS_TRUE;
}

