/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <iostream>
#include <RVCString.h>
#include "associativearray.h"

#include "loadgenerator.h"

static char buf[1024];

static long getint(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
	return atol(buf);
}

static char* getstr(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
  return buf;
}

CAssociativeArray* LGStandAlone(CLoadGenerator* lg)
{
  CAssociativeArray* retArray = new CAssociativeArray;

  //Set messages on by default
  lg->SetSendLogMessage(true);
  cout << "Messages on"  << endl;

  int choice = 0;
	while (1) {
		switch (choice)
      {
      case 0:
				cout << endl
						 << "1. Start" << endl
						 << "2. Pause" << endl
						 << "3. Go" << endl
						 << "4. Throttle" << endl
						 << "5. UnThrottle" << endl
						 << "6. Messages On/Off" << endl
						 << "7. Up and Down." << endl
						 //<< ". " << endl
						 << "99. Exit" << endl;
				break;

			case 1: 
			{
        //RVCString cmd = getstr("Eval: ");
        long n = getint("Enter num running: ");
        retArray->AddCouple("$STARTAGENDA", 1L);
        retArray->AddCouple("$AGENDANAME", "TestAgenda");
				retArray->AddCouple("$AGENDAPATH", "TestAgendaPath");
        retArray->AddCouple("$AGENDAACTUALRUNNING", n);
			}
			return retArray;

			case 2: 
			{
        retArray->AddCouple("$PAUSELOADER", 1L);
			}
			return retArray;

			case 3: 
			{
        retArray->AddCouple("$GOLOADER", 1L);
			}
			return retArray;

			case 4: 
			{
        long n = getint("Enter num running: ");
        retArray->AddCouple("$THROTTLEAGENDA", 1L);
        retArray->AddCouple("$AGENDANAME", "TestAgenda");
				retArray->AddCouple("$AGENDAPATH", "TestAgendaPath");
        retArray->AddCouple("$THROTTLENUMRUNNING", n);
			}
			return retArray;

			case 5: 
			{
        retArray->AddCouple("$AGENDANAME", "TestAgenda");
				retArray->AddCouple("$AGENDAPATH", "TestAgendaPath");
        retArray->AddCouple("$UNTHROTTLEAGENDA", 1L);
			}
			return retArray;

      case 6: 
			{
        lg->SetSendLogMessage(!lg->IsSendLogMessage());
        cout << "Messages " << (lg->IsSendLogMessage()?"On":"off") << endl;
			}
			break;

			case 7: 
			{
        int minThreads = getint("Enter num threads to start: ");
        int maxThreads = getint("Enter num threads to end: ");
        int interval = getint("Enter num threads to jump:");
        int iterations = getint("Enter num iterations: ");
        int sleepTime = getint("Enter Sleep Time(sec): ");

        int numThreads;
        for (int i = 1; i<=iterations; i++) {
          for (numThreads = minThreads; numThreads<=maxThreads; numThreads+=interval) {
            lg->StartThreadsManager("TestAgenda", numThreads);
            ::rvSleep(sleepTime*1000);
          }
          for (numThreads-=interval; numThreads>=minThreads; numThreads-=interval) {
            lg->StartThreadsManager("TestAgenda", numThreads);
            ::rvSleep(sleepTime*1000);
          }
        }
			}
			break;

			case 99: 
			{
        retArray->AddCouple("$EXIT", 1L);
        //ExitProcess(1);
			}
			return retArray;

      default:
        cout << "Illegal option" << endl << endl;
        break;
      } // end switch

    choice = getint("Please enter selection: [0]");
  } // end while
}

