/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "loadjspropertyobj.h"
#include "loadenginevariablesdata.h"
/////////////////////////////////////////////////////////////////////////////////////////
//
//						The implementation of the class CPropertyObjectPrivateData
//
/////////////////////////////////////////////////////////////////////////////////////////

CPropertyObjectPrivateData::CPropertyObjectPrivateData(RVCString& name, CLEVariablesData* pVariablesData)
	: m_Name( name ), m_pVariablesData( pVariablesData ){
}






// property object 
static JSClass wlPropertyObject_class = {
	"WLGlobalsPropertyClass",
	JSCLASS_HAS_PRIVATE,
  JS_PropertyStub,	// add Property
  JS_PropertyStub,	// del Property
  CLEVariablesData::JsGetPropertyObj,	// get Property
  CLEVariablesData::JsSetPropertyObj,	// set Propery
	JS_EnumerateStub,
	JS_ResolveStub,
	JS_ConvertStub,
  PropertyObjectFinalize
}; 

JSObject* NewPropertyObject( JSContext* cx, RVCString& propName, CLEVariablesData* pVariablesData) {
	JSObject  *propertyObj = JS_NewObject(cx, &wlPropertyObject_class, NULL, NULL);
	JS_SetPrivate(cx, propertyObj, new CPropertyObjectPrivateData( propName, pVariablesData ) );
	return propertyObj;
}


void PropertyObjectFinalize(JSContext *cx, JSObject *obj)
{
  CPropertyObjectPrivateData* pPropertyObjectPrivateData = (CPropertyObjectPrivateData*)JS_GetPrivate(cx, obj);
	if ( pPropertyObjectPrivateData ) {
		delete(pPropertyObjectPrivateData);
	}
}

JSClass* GetPropertyObjectJSClass() {
	return &wlPropertyObject_class;
}

