/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#include "rvjsapi.h"
#include "loadjsdefs.h"
#include "loadreportinfo.h"
#include "loadexceptions.h"
#include "wlerrorlib.h"
#include <errno.h>


// System shell class
JSClass systemShellClass = 
{
    WLJSNAME_SYSTEM_SHELL_CLASS, 0,
    JS_PropertyStub,  JS_PropertyStub,JS_PropertyStub, JS_PropertyStub,
    JS_EnumerateStub, JS_ResolveStub, JS_ConvertStub,  JS_FinalizeStub
};

/********************** Define system methods **************************/

// Run external commands
JSBool system_system(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval* rval)
{
    JSString* str;
    uintN i;
	RVCString command("");

    for(i=0; i < argc; i++)
	{
        str = JS_ValueToString(cx, argv[i]);
		if(str) 
		{
			command += JS_GetStringBytes(str);
			command += " ";
		} 
		else 
		{
			return LoadReport(cx, WLLogMessage::Fatal, "Parameters must be strings." );
		}
	}

	bool fFailure = ( system(command.data()) == -1);
	if (fFailure)
	{
		return LoadReport(cx, WLLogMessage::Fatal, strerror(errno));
	}

    return JS_TRUE;
}

static JSFunctionSpec systemShellMethods[] = 
{
		{WLJSNAME_SYSTEM_SHELL_SYSTEM,  system_system,  0, 0},
		{0}
};

// -------------------- Functions exposed to the outside -------------------- 

JSObject* AddSystemShellObject(JSContext *cx, JSObject* obj)
{
	if (!JS_InitClass(cx, obj, NULL, &systemShellClass, NULL, 0, NULL, systemShellMethods, NULL, NULL))
		return NULL;

	JSObject* wlSystemShell = 
		JS_DefineObject(cx, obj, WLJSNAME_SYSTEM_SHELL_OBJECT, &systemShellClass, NULL, JSPROP_PERMANENT | JSPROP_READONLY | JSPROP_ENUMERATE );

    return wlSystemShell; //maybe null
}

