/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

public class cRVProtocolTest extends Object
{
	private JavaThreadWrapper mRVContext;
	
	public cRVProtocolTest( JavaThreadWrapper rRVContext )
	{
		mRVContext = rRVContext;
	}
	
	public int fX0( int rX0 )
	{
		return rX0;
	}
	
	public double fGetCurrentTime()
	{
		double rtn = (double)System.currentTimeMillis() / (double)(1000);
		return rtn;
	}
	
	
	public void fSetTimer(String rName)
	{
		mRVContext.SetTimer( rName );
	}

	public void fSendTimer(String rName)
	{
		mRVContext.SendTimer( rName );
	}

	public void fSendCounter(String rName)
	{
		mRVContext.SendCounter( rName );
	}

	public void fSendMeasurement( String rName, double rValue )
	{
		mRVContext.SendMeasurement( rName, rValue );
	}



	public void fBeginTransactionEx( String rName, double rTime )
	{
		mRVContext.BeginTransactionEx( rName, rTime );
	}

	public void fEndTransactionEx(
		String rName, 
		int rSeverity, 
		boolean rIsSave,
		double rTime, 
		boolean rIsSendTimers, 
		boolean rIsLog)
	{
		mRVContext.EndTransactionEx( rName, rSeverity, rIsSave, rTime, rIsSendTimers, rIsLog );
	}

	public void fSetFailureReasonEx(
		String rReason, 
		String rDescription, 
		double rTime, 
		boolean rIsEvent )
	{
		mRVContext.SetFailureReasonEx( rReason, rDescription, rTime, rIsEvent );
	}

	public void fReportEventEx(
		String rReason, 
		String rDescription, 
		double rTime, 
		int rVerification,
		String rExtraDataType, 
		String rExtraData, 
		boolean rIsLog )
	{
		mRVContext.ReportEventEx( rReason, rDescription, rTime, rVerification, rExtraDataType, rExtraData, rIsLog );
	}

	public void fEndTransactionFailureEx(
		String rName, 
		double rTime, 
		int rSeverity,
		String rReason, 
		boolean rIsSendTimers, 
		boolean rIsLog, 
		boolean rIsFailureEvent)
	{
		mRVContext.EndTransactionFailureEx(rName, rTime, rSeverity, rReason, rIsSendTimers, rIsLog, rIsFailureEvent);
	}


	public String fGetCurrentTransaction()
	{
		return mRVContext.GetCurrentTransaction();
	}

	public int fGetTransactionDepth()
	{
		return mRVContext.GetTransactionDepth();
	}




//##########################	messages functions  ################################

	public void fInfoMessage( String rMessage )
	{
		mRVContext.InfoMessage( rMessage );
	}

	public void fWarningMessage( String rMessage )
	{
		mRVContext.WarningMessage( rMessage );
	}

	public void fErrorMessage( String rMessage )
	{
		mRVContext.ErrorMessage( rMessage );
	}

	public void fSevereErrorMessage( String rMessage )
	{
		mRVContext.SevereErrorMessage( rMessage );
	}


//######################  other Engine functions  ################################

	public void fSleep(int rTime)
	{
		mRVContext.Sleep( rTime );
	}

	public boolean fIsAbort()
	{
		return mRVContext.IsAbort();
	}
}



