/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#include "headersui.h"


namespace nHeadersUi {

using namespace nJsd;
using namespace nPCUi;


cHeadersUi::cHeadersUi(cSingleClientProcess& rProcess)
:
	iLoadSAFHeaders(rProcess)
{}

cHeadersUi::~cHeadersUi() {
	//fFinal(); // this happens in the wrong thread.
	}


iAgendaFile* cHeadersUi::fGetFile(
	bool& IsNew,
	iEmbedderCallContext& EC,
	const char* Name ) 
{
	cScriptFile& File = *(new cScriptFile( Name ));
	mFiles.push_back( std::auto_ptr<cScriptFile>(&File) );
	IsNew = true;
	return &File;
}





void cHeadersUi::fReporter(
	iReportInfo& rInfo_ ) 
{

	if( iLoadReportInfo* aInfo = dynamic_cast<iLoadReportInfo*>(&rInfo_) ) {
		std::string X0 = fsReportFormat( aInfo->fGetSeverity(), aInfo->fGetMessage() );
		printf( "exec rep: %s\n", X0.data() );
	} else {
		WlAssert(0);
	}
}




void cHeadersUi::fCopyFile(
	iEmbedderCallContext& EC, 
	const char* Source, 
	const char* Target) {
	
	if( Source ) {
		char bytes[1000];
		sprintf( bytes, "CopyFile( %s, %s )\n", Source, Target );
		EC.fReport( cLoadReportInfoAgenda( WLLogMessage::Note, bytes ) );
		}
	else {
		EC.fReport( cLoadReportInfoAgenda( WLLogMessage::Warning, "no source file" ) );
		}
	}






	} // namespace
