/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __jstestpr_h
#define __jstestpr_h

//
// Functions for debug and printing
void JSTestPR_IncNumRounds(int threadId);
void JSTestPR_Output(const char* format, ...);

//
// Sleep function (in milliseconds)
void JSTestPR_Sleep(int milisec);

//
// creating , counting and stopping threads.
typedef void (JSTestPR_ThreadFuncType)(int id, JSContext* cx);
int JSTestPR_CreateThreads(JSTestPR_ThreadFuncType* threadFunc, JSRuntime* rt, JSContext* parent_cx, int nThreads);
void JSTestPR_ThreadStarted();
void JSTestPR_ThreadDone();
void JSTestPR_WaitForNThreads(int nThreads);

//
// GC thread.
typedef void (JSTestPR_GCFuncType)();
int JSTestPR_CreateGcThread(JSTestPR_GCFuncType* gcFunc);

bool JSTestPR_IsTerminate();
void JSTestPR_TerminateAll();

#endif //__jstestpr_h

