/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "platform.h"
#include "tvtables.h"
#ifdef __TV_UNIX__
#include "tvenv.h"
#endif
#include "tracedll.h"
#include "wlerrorlib.h"
#include "loadengineglobals.h"
#include "loadgeneratorscript.h"

static int count=1;

/*class TestThreadInstanceScript : public CLoadThreadInstanceScript {
private:
  int id;
public:
  TestThreadInstanceScript(CLoadThreadsManagerScript* managerScript, CLoadThreadInstance *threadInstance) :
    CLoadThreadInstanceScript(managerScript, threadInstance)
  {
    id=count++;
  }
  ~TestThreadInstanceScript() {}
};
*/
//
// HTTP Loaduar functions:
/*CLoadThreadInstanceScript* JSNewTestThread(CLoadThreadInstance *threadInstance)
{
  //WlTraceMsg("JSNewWebThread: new instance()");
	TestThreadInstanceScript* hp = new TestThreadInstanceScript(threadInstance);
  //WlTraceMsg("instance[%x] created", hp);
  return (CLoadThreadInstanceScript*)hp;
}
*/
/*
bool WLInitTestGeneratorShell(CWLJSShell*)
{
  WlTraceMsg("INSIDE WLInitTestGeneratorShell");
  return true;
}
*/
bool WLInitTestGeneratorScript(JSContext* cx, JSObject* global, JSObject* GeneralGlobal )
{
  WlTraceMsg("INSIDE WLInitTestGeneratorScript");
  return true;
}

bool WLInitTestGeneratorThread(JSContext* cx, JSObject* obj, CLEVariablesData* pVariablesData)
{
  //WlTraceMsg("INSIDE WLInitTestGeneratorThread");
  return true;
}




int main(int argc, char *argv[]){
	CTraceMsg::Init("LoadEngineTest");//to enable to use the Trace.exe
  //CoInitialize(NULL);
  //initialize Environment
#ifdef __TV_UNIX__
  char thisFileName[WL_MAX_PATH];
  TVEnvContainerClass tvpc;
  if( !TVEInit(tvpc.TVPGetPathDirectory( (const char *)realpath(argv[0],thisFileName ))))
  {
    TVPFatalErrorLog("tvenv.dll: Init Terminated with error: (%s)",TVEError());
    return FALSE;
  }
#endif

  //WlTraceMsg("Starting LoadEngineTest:main(%s,%s,%s,%s)",argv[1], argv[2]);
//  RegisterWLENewThreadInstanceScriptFunc(JSNewTestThread);
//  RegisterWLInitGeneratorShell(WLInitTestGeneratorShell);
//  RegisterWLInitGeneratorScript(WLInitTestGeneratorScript);
//  RegisterWLInitGeneratorThread(WLInitTestGeneratorThread);


  WlTraceMsg("Starting LoadGeneratorMain");

  int argc2 = argc;
	char** argv2 = argv;

  // Support of new parameters for command line activation, copied from httpload.cpp
  const char *tmp;
  bool  StandAlone = false;

	char argvData[10][100];
	char* argvp[10];

  // Check if first parameter is a .js file name
  if (argc > 1 && (tmp = (const char*)strrchr(argv[1], '.')) && !stricmp(tmp, ".js")){
    // Stand alone mode has no fixed number of parameters and we can only we're in it
    // if the the 1st parameter is a file name for a js script. So remember it now for later
    StandAlone = true;
  }
	else if(argc==2) {
    StandAlone = false;
		argv2 = argvp;

		argc2 = 0;
		argvp[0] = argv[0];

		FILE* InputFile = fopen( argv[1], "r" );
		WlAssert(InputFile);
		while( !feof(InputFile) ) {
			int status = fscanf( InputFile, "%s", argvData[argc2] );
			if( (status!=0) && (status!=EOF) ) {
				argvp[argc2+1] = argvData[argc2];
				++argc2;
				}
			}
		++argc2;
		}
	else {
		argc2 = argc;
		argv2 = argv;
		}


  if (StandAlone){
    LoadGeneratorTest(argc2, argv2, WLE_ADDPROTOCOL_HTTP);
  }
  // If we're not in Stand Alone mode, go back to the old way of deciding what the mode is
  else if (argc2==5)
    LoadGeneratorMain(argc2, argv2, WLE_ADDPROTOCOL_HTTP);
  else if (argc2==3)
    LoadGeneratorSlave(argc2, argv2, WLE_ADDPROTOCOL_HTTP);
  else
#ifndef __TV_UNIX__
    MessageBox(0, "Illegal number of Parameters", "Load Generator", MB_OK);
#else
	printf("Illegal number of Parameters\n");
#endif





  TVSTerminate();
  WLERRTerminate();
  //exit(0);
  return 0;
}



