/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __RV_HTML_DIET_AttributeObject__
#define __RV_HTML_DIET_AttributeObject__

#include "platform.h"
#include <RVCString.h>
#include <collectable.h>

class DllExport CRVHTMLDietAttributeObject : public RVCollectable
{
  
public:
  CRVHTMLDietAttributeObject();
  ~CRVHTMLDietAttributeObject();
  CRVHTMLDietAttributeObject(RVCString& p_sName, RVCString& p_sValue, RVCString& p_sOriginalValue ,int p_nOffset);
  
  const char* GetAttributeValue();
  void SetAttributeValue(RVCString& p_sOriginalAttributeValue);
  const char* GetOriginalAttributeValue();
  void SetOriginalAttributeValue(RVCString& p_sOriginalAttributeValue);
  int GetAttributeOffset();
  void SetAttributeOffset(int p_nOffset);
  void SetAttributeName(RVCString& p_sName);
  const char* GetAttributeName();

private:
    int       m_nOffset;
    RVCString m_sValue;
    RVCString m_sOriginalValue;
    RVCString m_sName;
};

#endif
