/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
//////////////////////////////////////////////////////////////////////
//
// CRVXMLDocument.h: interface for the CRVXMLDocument class.
//
//////////////////////////////////////////////////////////////////////
/*!
*
* \brief
RadView XML Wrapper
*
* \author	Sergei Lvov
* \date		1/04/01
*
*/
#ifndef CRVXMLDOCUMENT_H
#define CRVXMLDOCUMENT_H
#include <RVCString.h>

#include <tvslist.h>
#include <gt_portable.h>
#include "crvxmlelement.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

using namespace MSXML;





enum XMLParserType
{
	MSXMLParser
};

class DllExport CRVXMLDocument
{
public:
	CRVXMLDocument(XMLParserType p_eXMLParser, RVCString p_sRootElementName = "root");
	CRVXMLDocument(IXMLDOMDocumentPtr p_IXMLDOMDocument, RVCString p_sRootElementName = "root");
	virtual ~CRVXMLDocument();

	bool load(RVCString p_sURL,CWLErrorInfo& p_ErrorInfo);
	bool loadXML(RVCString p_sXML, CWLErrorInfo& p_ErrorInfo);
	//Galtech
	//bool loadXML(wchar_t* p_sXML, CWLErrorInfo& p_ErrorInfo);
	bool loadXML(gt_wchar_t* p_sXML, CWLErrorInfo& p_ErrorInfo);
	bool save(RVCString p_sURL,CWLErrorInfo& p_ErrorInfo);
	RVCString get_xml(CWLErrorInfo& p_ErrorInfo);
	CRVXMLElement get_documentElement(CWLErrorInfo& p_ErrorInfo);
	RVTValSlistDictionary<RVCString, RVCString> get_parseError(CWLErrorInfo& p_ErrorInfo);
	IXMLDOMDocumentPtr get_IXMLDOMDocument(CWLErrorInfo& p_ErrorInfo);
private:
	IXMLDOMDocumentPtr m_pDocument;
	CRVXMLElement m_RootElement;

};



#endif
