/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// FileAutoDiscovery.h: interface for the CFileAutoDiscovery class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILEAUTODISCOVERY_H__E51A17CE_7733_4695_9575_EA100C97C2D7__INCLUDED_)
#define AFX_FILEAUTODISCOVERY_H__E51A17CE_7733_4695_9575_EA100C97C2D7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "tvenv.h"
#include <RVCString.h>

#define USE_MSXML
#ifdef USE_MSXML
#include "crvxmldocument.h"
#include "crvxmlelement.h"
#else
#include "rvxmldocument.h"
#include "rvxmlelement.h"
#endif // USE_MSXML

class CFileAutoDiscovery  : public CFindFileFunctor
{
public:
	CFileAutoDiscovery();
	virtual ~CFileAutoDiscovery();

	virtual bool handleFile( const char* filePath );
	const char* getLastError();
	bool discoverPath( const char* path, const char* spec, bool lookInSubDirs = false );
	bool getDllInfo( CRVXMLElement* pDllNode, RVCString& DllName, RVCString& DllDisplayName, RVCString& DllVersion, RVCString& DllVendor );

protected:
	RVCString m_LastErrorDescription;
};

#endif // !defined(AFX_FILEAUTODISCOVERY_H__E51A17CE_7733_4695_9575_EA100C97C2D7__INCLUDED_)
