
#include "rvjsdebug.h"
#include "jsd.h"



JSD_PUBLIC_API(JSBool)
RVJSD_IsValueFunction(JSDContext* jsdc, JSDThreadState* threadstate, JSDValue* jsdval)
{
    JSD_ASSERT_VALID_CONTEXT(jsdc);
    JSD_ASSERT_VALID_VALUE(jsdval);
    return jsd_IsValueFunction(jsdc, threadstate->context, jsdval);
}

JSD_PUBLIC_API(JSBool)
RVJSD_IsValueNative(JSDContext* jsdc, JSDThreadState* threadstate, JSDValue* jsdval)
{
    JSD_ASSERT_VALID_CONTEXT(jsdc);
    JSD_ASSERT_VALID_VALUE(jsdval);
    return jsd_IsValueNative(jsdc, threadstate->context, jsdval);
}


JSD_PUBLIC_API(JSString*)
RVJSD_GetValueString(JSDContext* jsdc, JSDThreadState* threadstate, JSDValue* jsdval)
{
    JSD_ASSERT_VALID_CONTEXT(jsdc);
    JSD_ASSERT_VALID_VALUE(jsdval);
    return jsd_GetValueString(jsdc, threadstate->context, jsdval);
}

JSD_PUBLIC_API(const char*)
RVJSD_GetValueFunctionName(JSDContext* jsdc, JSDThreadState* threadstate, JSDValue* jsdval)
{
    JSD_ASSERT_VALID_CONTEXT(jsdc);
    JSD_ASSERT_VALID_VALUE(jsdval);
    return jsd_GetValueFunctionName(jsdc, threadstate->context, jsdval);
}

JSD_PUBLIC_API(uintN)
RVJSD_GetCountOfProperties(JSDContext* jsdc, JSDThreadState* threadstate, JSDValue* jsdval)
{
    JSD_ASSERT_VALID_CONTEXT(jsdc);
    JSD_ASSERT_VALID_VALUE(jsdval);
    return jsd_GetCountOfProperties(jsdc, threadstate->context, jsdval);
}

JSD_PUBLIC_API(JSDProperty*)
RVJSD_IterateProperties(JSDContext* jsdc, JSDThreadState* threadstate, JSDValue* jsdval, JSDProperty **iterp)
{
    JSD_ASSERT_VALID_CONTEXT(jsdc);
    JSD_ASSERT_VALID_VALUE(jsdval);
    JS_ASSERT(iterp);
    return jsd_IterateProperties(jsdc, threadstate->context, jsdval, iterp);
}

JSD_PUBLIC_API(JSDProperty*)
RVJSD_GetValueProperty(JSDContext* jsdc, JSDThreadState* threadstate, JSDValue* jsdval, JSString* name)
{
    JSD_ASSERT_VALID_CONTEXT(jsdc);
    JSD_ASSERT_VALID_VALUE(jsdval);
    JS_ASSERT(name);
    return jsd_GetValueProperty(jsdc, threadstate->context, jsdval, name);
}

JSD_PUBLIC_API(JSDValue*)
RVJSD_GetValueConstructor(JSDContext* jsdc, JSDThreadState* threadstate, JSDValue* jsdval)
{
    JSD_ASSERT_VALID_CONTEXT(jsdc);
    JSD_ASSERT_VALID_VALUE(jsdval);
    return jsd_GetValueConstructor(jsdc, threadstate->context, jsdval);
}


JSD_PUBLIC_API( JSContext* )
RVJSD_GetJSContext( JSDThreadState* threadstate )
{
	return threadstate->context;
}


