/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// EASTestTalkServer.h: interface for the EASTestTalkServer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EASTESTTALKSERVER_H__7770B944_740B_11D4_8831_0004AC15A422__INCLUDED_)
#define AFX_EASTESTTALKSERVER_H__7770B944_740B_11D4_8831_0004AC15A422__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef __TV_UNIX__
#include <sys/types.h>
#endif

#include "platform.h"

class CEASTestTalkServer;


class DllExport EASTestTalkServer
{
public:
	EASTestTalkServer();
	virtual ~EASTestTalkServer();

	// Default serverPort is taken from webload.ini
	// Key = UDP_SERVER_PORT
	virtual int  Init(/*[IN]*/u_short serverPort = 0);

	// Starts the receiving thread and loop
	virtual int  Start(void);

	// Stops the receiving loop and thread
	virtual void Stop(void);

	// Send ping to initialize a remote client
	int  InitPing(/*[IN]*/const char* replyHost,
								/*[IN]*/long        replyPort,
								/*[IN]*/const char* toHost,
								/*[IN]*/long        duration);

	// This method is invoked each time a new pong arrives.
	virtual void OnPong(/*[OUT - on method invocation]*/const char* hostName);

	inline const char* GetServerName(void);

private:
	CEASTestTalkServer* m_Self;
};

#endif // !defined(AFX_EASTESTTALKSERVER_H__7770B944_740B_11D4_8831_0004AC15A422__INCLUDED_)

