/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __TestTalkListenSockets_H__
#define __TestTalkListenSockets_H__

#include "tvpsync.h"
#include "testtalkclass.h"
#include "streamsocket.h"

class CTestTalkListenerSocket
{
public:
	RVThread            m_ListenThread;

protected:
  RVCriticalSection   m_Touch;
	StreamSocket        m_StreamSocket;
	bool                m_Terminate;
  u_short             m_Port;

  CTestTalkClass     *m_TestTalkMain;

public:
	CTestTalkListenerSocket(CTestTalkClass *ttMain);
	virtual ~CTestTalkListenerSocket();
  
  bool Activate();
  void Terminate();
  void ListenProc();

  void SetPort(u_short port) { m_Port = port; }
  virtual void NewSocketAccepted(SOCKET s) = 0;
};


class CTestTalkNetListener : public CTestTalkListenerSocket
{
public:
  CTestTalkNetListener(CTestTalkClass *ttMain);
  virtual ~CTestTalkNetListener();

  virtual void NewSocketAccepted(SOCKET s);
};

class CTestTalkClientListener : public CTestTalkListenerSocket
{
public:
  CTestTalkClientListener(CTestTalkClass *ttMain);
  virtual ~CTestTalkClientListener();

  virtual void NewSocketAccepted(SOCKET s);
};


#endif // __TestTalkListenSockets_H__

