/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <stdio.h>
#include "platform.h"
//#include <windows.h>
#include <RVCString.h>
#include "tvenv.h"

#include "testtalkserviceconfig.h"
#include "runtesttalk.h"

static PROCESS_INFORMATION g_ProcessInfo;

int RunTestTalk()
{
	int status = true;
  STARTUPINFO si;
  //PROCESS_INFORMATION g_ProcessInfo;
  memset(&si,0,sizeof(si));
  si.cb=sizeof(si);

	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx (&osvi);

	// OS is Windows NT or Windows 2000
	if ( osvi.dwPlatformId == VER_PLATFORM_WIN32_NT ) 
        {
		TestTalkServiceConfig sc;

		if ( sc.ResolveTestTalkServiceName() && sc.IsInstalled() )
                {
			sc.Start();
		}
		else 
                {
			TVEnvContainerClass tvpc;
			RVCString testtalkExe = tvpc.TVERuntimeResolve("#(TV_BIN)\\testtalk.exe"); 
			status = CreateProcess( testtalkExe.data(), NULL, NULL, NULL ,FALSE, DETACHED_PROCESS, NULL, NULL, &si, &g_ProcessInfo );
		}
	}
	else 
        {
		// OS is Windows 95 or Windows 98
		if ( osvi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS ) 
                {
			TVEnvContainerClass tvpc;
			RVCString testtalkExe = tvpc.TVERuntimeResolve("#(TV_BIN)\\testtalk.exe"); 
			status = CreateProcess( testtalkExe.data(), NULL, NULL, NULL ,FALSE, DETACHED_PROCESS, NULL, NULL, &si, &g_ProcessInfo );
		}
	}

  if ( !status ) 
  {
    char err[100];
    sprintf(err,"Error Occurred while running TestTalk (code: %d)\n please contact Tech support.", GetLastError());
    MessageBox(NULL, err, "Monitor Error", MB_OK);
    return false;
  }

  return true;
}



int IsTestTalkProcessRunning()
{

  return 0;
}

void TerminateTestTalk()
{
	HANDLE hProcess = OpenProcess( PROCESS_TERMINATE, false, g_ProcessInfo.dwProcessId );
	if ( hProcess )
		TerminateProcess( hProcess, 0 );
}
