/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// Local Variables:
// mode: c++
// End:
//
#ifndef __TV_TYPEDMSG_H
#define __TV_TYPEDMSG_H

#include <memory.h>
#include <malloc.h>
#include "tvdebug.h"

class TypedMessageObject
{
public:      // public data memebers
  short    type;
  short    subtype;
  void*    MsgBuf;
  int      len;
public:     // public memeber functions
  TypedMessageObject(void *b, int l, short t, short s_t) :
    type(t), subtype(s_t), len(l), MsgBuf(NULL)
  {
    EnterProcedure("TypedMessageObject::TypedMessageObject");
    if (len > 0)
      {
        assert(b != NULL);
        MsgBuf = (void *)malloc(len);
        assert( MsgBuf != NULL);
        memcpy(MsgBuf, b, len);
      }
  }

  virtual ~TypedMessageObject()
  {
    EnterProcedure("TypedMessageObject::~TypedMessageObject");
    if (MsgBuf)
      free((char *)MsgBuf);
  }

  //virtual void printOn( ostream& os) const
  //{
  //  os << "Message: Type(" << type << ") SubType(" << subtype << ") Length: " << len << "\n";
  //}
};


#endif

