/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifdef __TV_WINDOWS__
//#include "stdafx.h"
#endif
#include <malloc.h>
#include <stdio.h>
#include <string.h>
#include "packmsg.h"


HPACKDATA PCKAlloc(unsigned int lenToAlloc);
void* PCKGetData(HPACKDATA hData);
Bool PCKFreeData(HPACKDATA hData);

Pack::Pack(HPACKDATA hData) : hPackedMsg(hData)
{
  // get the Pack from data handler.
  void* pPackedMsg = PCKGetData(hPackedMsg);
  if (!pPackedMsg) {
    hPackedMsg=NULL;
    return;
  }
  char str[100];
  int i;
  void* pack = pPackedMsg;
  char* tmp = (char*)pack;

  totalLen = 0;
  sscanf((const char*)pack,"%s ",str);
  tmp += strlen(str) + 1;
  totalLen += strlen(str) + 1;
  pack = (void*) tmp;
  sscanf(str,"%d",&numOfPack);
  for (i=0; i<numOfPack; i++) {
    sscanf((const char*) pack,"%s ",str);
    tmp = (char*) pack;
    tmp += strlen(str) + 1;
    totalLen += strlen(str) + 1;
    pack = (void*) tmp;
    sscanf(str,"%d",&fieldsLen[i]);
    totalLen += fieldsLen[i];
  }
  for (i=0; i<numOfPack; i++) {
    fields[i] = pack;
    tmp = (char*) pack;
    tmp += fieldsLen[i];
    pack = (void*) tmp;
  }
}

Pack::Pack(void* first,int firstLen, ...) : hPackedMsg(NULL)
{
  assert(first && firstLen);
  int i;
  //
  // initialize fields & fieldsLen.
  fields[0] = first;
  numOfPack = 1;
  int totalSize = (fieldsLen[0] = firstLen);
  for (i = 1; i < MAXFIELDS; i++) {
    fields[i] = NULL;
    fieldsLen[i] = 0;
  }
  fields[MAXFIELDS] = NULL;
  totalLen = 0;

  //
  // get the parameters in list.
  va_list ap;
  va_start(ap, firstLen);
  for (i=1; (fields[i] = va_arg(ap,void*)) != NULL; i++) {
    numOfPack++;
    // if fails it means too many parameters to constructor.
    assert(i < MAXFIELDS);
    // keep the field-len & sum the total.
    totalSize += (fieldsLen[i] = va_arg(ap,int));
  }
  totalLen = totalSize;

  va_end(ap);
  //
  // store the fields in the Pack data.
  if (hPackedMsg != NULL)
    (void)PCKFreeData(hPackedMsg);

  hPackedMsg = PCKAlloc(totalSize + INITIAL_LEN);
  void* pPackedMsg = PCKGetData(hPackedMsg);

  // Used for debug purposes.
  void* upBound = (char*) pPackedMsg + totalSize + INITIAL_LEN;

  // get all fields into the memory.
  char str[100];
  char* tmp;
  void* pack = pPackedMsg;

  sprintf(str,"%d ",numOfPack);
  strcpy((char*)pack,str);
  tmp = (char*) pack;
  tmp += strlen(str);
  totalLen += strlen(str);
  pack = (void*) tmp;
  for (i=0; i<numOfPack; i++) {
    sprintf(str,"%d ",fieldsLen[i]);
    memcpy(pack, str,strlen(str));
    tmp = (char*) pack;
    tmp += strlen(str);
    totalLen += strlen(str);
    pack = (void*) tmp;
    assert(pack <= upBound);
  }

  for (i=0; i<numOfPack; i++) {
    memcpy(pack, fields[i],fieldsLen[i]);
    fields[i] = pack;  // point with fields[i] to the packed buffer.
    tmp = (char*) pack;
    tmp += fieldsLen[i];
    pack = (void*) tmp;
    assert(pack <= upBound);
  }
}

int Pack::thePackedMsgLen() const
{
  return totalLen;
}

HPACKDATA PCKAlloc(unsigned int lenToAlloc)
{
  assert(lenToAlloc > 0);
  HPACKDATA hPack = (HPACKDATA) malloc(lenToAlloc);
  return hPack;
}

void* PCKGetData(HPACKDATA hData)
{
  return (void*) hData;
}

Bool PCKFreeData(HPACKDATA hData)
{
  assert(hData);
  free((char*) hData);
  return True;
}

