/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* Copyright  1993-1995, Radview Software LTD. All Rights Reserved. */
#include <stdio.h>
#include <malloc.h>
#include <string.h>

#include <fstream.h>
#include <stdarg.h>

#include <RVCString.h>

#include <assert.h>
#include <ctype.h>

#include "platform.h"

#ifdef __TV_WINDOWS__
#include <direct.h>
#include <dos.h>
#include <sys/timeb.h>
#endif
#ifdef __TV_UNIX__
#include <alloca.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <RVCTokenizer.h>
#include <unistd.h>
#include <signal.h>
#include <sys/resource.h>
#endif

#include <time.h>
#include <thr.h>

#ifdef __TV_WINDOWS__

#define DESKTOP_ALL (DESKTOP_READOBJECTS | DESKTOP_CREATEWINDOW | \
DESKTOP_CREATEMENU | DESKTOP_HOOKCONTROL | DESKTOP_JOURNALRECORD | \
DESKTOP_JOURNALPLAYBACK | DESKTOP_ENUMERATE | DESKTOP_WRITEOBJECTS | \
DESKTOP_SWITCHDESKTOP | STANDARD_RIGHTS_REQUIRED)

#define WINSTA_ALL (WINSTA_ENUMDESKTOPS | WINSTA_READATTRIBUTES | \
WINSTA_ACCESSCLIPBOARD | WINSTA_CREATEDESKTOP | WINSTA_WRITEATTRIBUTES | \
WINSTA_ACCESSGLOBALATOMS | WINSTA_EXITWINDOWS | WINSTA_ENUMERATE | \
WINSTA_READSCREEN | STANDARD_RIGHTS_REQUIRED)

#define GENERIC_ACCESS (GENERIC_READ | GENERIC_WRITE | GENERIC_EXECUTE | \
GENERIC_ALL)

BOOL AddAceToWindowStation(HWINSTA hwinsta, PSID psid);

BOOL AddAceToDesktop(HDESK hdesk, PSID psid);


#include <WINBASE.H>
/************************* LIBMAIN *********************************/
/*  DLL standart main                                              */
/*******************************************************************/
/*
  BOOL FAR PASCAL LibMain(
    HANDLE hLibInstance,
    WORD   wDataSeg,
    WORD   cbHeapSize,
    LPSTR  lpszCmdLine)
    {
      (void) hLibInstance;
      (void) wDataSeg;
      (void) cbHeapSize;
      (void) lpszCmdLine;

      UnlockData (0);
      return TRUE;
    }
*/
#endif

const char* WINAPI TVPStrlwr(char* str)
{
#ifdef __TV_WINDOWS__
    #ifdef WIN32
  char *p = __STRLWR(str);
    #else
  char *p = _fstrlwr(str);
    #endif
  return p;
#endif
#ifdef __TV_UNIX__
  char* p = str;
  char* d = str;
  while(*d++ = tolower(*p++));

  return (const char*)str;
#endif 
}

const char* WINAPI TVPStrupr(char *str)
{
#ifdef __TV_WINDOWS__
  return __STRUPR(str);
#endif
#ifdef __TV_UNIX__
  char* p = str;
  char* d = str;
  while(*d++ = toupper(*p++));

  return (const char*)str;
#endif 
}

int WINAPI TVPExecApplication(const char* szCmdLine, const char* szParams)
{
  int status;
  
#ifdef __TV_WINDOWS__
	STARTUPINFO si;
  PROCESS_INFORMATION pi;

  memset(&si,0,sizeof(si));
  si.cb=sizeof(si);
  RVCString Command = "\"";
  Command += szCmdLine;
  Command += "\"";
  Command += " ";
  Command += szParams;

  status = CreateProcess(NULL, (char*)(const char*)Command, NULL, NULL ,FALSE, DETACHED_PROCESS, NULL, NULL, &si, &pi);
  
  return (status? TRUE : FALSE);

#endif
  
#ifdef __TV_UNIX__
  RVCString Command = szCmdLine;
  Command += " ";
  Command += szParams;
  Command += " &";
  system(Command);
  return 1;
#endif
}

BOOL GetLogonSID (HANDLE hToken, PSID *ppsid) 
{
   BOOL bSuccess = FALSE;
   DWORD dwIndex;
   DWORD dwLength = 0;
   PTOKEN_GROUPS ptg = NULL;

// Verify the parameter passed in is not NULL.
    if (NULL == ppsid)
        goto Cleanup;

// Get required buffer size and allocate the TOKEN_GROUPS buffer.

   if (!GetTokenInformation(
         hToken,         // handle to the access token
         TokenGroups,    // get information about the token's groups 
         (LPVOID) ptg,   // pointer to TOKEN_GROUPS buffer
         0,              // size of buffer
         &dwLength       // receives required buffer size
      )) 
   {
      if (GetLastError() != ERROR_INSUFFICIENT_BUFFER) 
         goto Cleanup;

      ptg = (PTOKEN_GROUPS)HeapAlloc(GetProcessHeap(),
         HEAP_ZERO_MEMORY, dwLength);

      if (ptg == NULL)
         goto Cleanup;
   }

// Get the token group information from the access token.

   if (!GetTokenInformation(
         hToken,         // handle to the access token
         TokenGroups,    // get information about the token's groups 
         (LPVOID) ptg,   // pointer to TOKEN_GROUPS buffer
         dwLength,       // size of buffer
         &dwLength       // receives required buffer size
         )) 
   {
      goto Cleanup;
   }

// Loop through the groups to find the logon SID.

   for (dwIndex = 0; dwIndex < ptg->GroupCount; dwIndex++) 
      if ((ptg->Groups[dwIndex].Attributes & SE_GROUP_LOGON_ID)
             ==  SE_GROUP_LOGON_ID) 
      {
      // Found the logon SID; make a copy of it.

         dwLength = GetLengthSid(ptg->Groups[dwIndex].Sid);
         *ppsid = (PSID) HeapAlloc(GetProcessHeap(),
                     HEAP_ZERO_MEMORY, dwLength);
         if (*ppsid == NULL)
             goto Cleanup;
         if (!CopySid(dwLength, *ppsid, ptg->Groups[dwIndex].Sid)) 
         {
             HeapFree(GetProcessHeap(), 0, (LPVOID)*ppsid);
             goto Cleanup;
         }
         break;
      }

   bSuccess = TRUE;

Cleanup: 

// Free the buffer for the token groups.

   if (ptg != NULL)
      HeapFree(GetProcessHeap(), 0, (LPVOID)ptg);

   return bSuccess;
}

BOOL AddAceToWindowStation(HWINSTA hwinsta, PSID psid)
{
   ACCESS_ALLOWED_ACE   *pace;
   ACL_SIZE_INFORMATION aclSizeInfo;
   BOOL                 bDaclExist;
   BOOL                 bDaclPresent;
   BOOL                 bSuccess = FALSE;
   DWORD                dwNewAclSize;
   DWORD                dwSidSize = 0;
   DWORD                dwSdSizeNeeded;
   PACL                 pacl;
   PACL                 pNewAcl;
   PSECURITY_DESCRIPTOR psd = NULL;
   PSECURITY_DESCRIPTOR psdNew = NULL;
   PVOID                pTempAce;
   SECURITY_INFORMATION si = DACL_SECURITY_INFORMATION;
   unsigned int         i;

   char Msg[100];

   __try
   {
      // Obtain the DACL for the window station.

      if (!GetUserObjectSecurity(
             hwinsta,
             &si,
             psd,
             dwSidSize,
             &dwSdSizeNeeded)
      )
      if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
      {
         psd = (PSECURITY_DESCRIPTOR)HeapAlloc(
               GetProcessHeap(),
               HEAP_ZERO_MEMORY,
               dwSdSizeNeeded);

         if (psd == NULL) {
			sprintf(Msg, "HeapAlloc returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			__leave;
         }
            

         psdNew = (PSECURITY_DESCRIPTOR)HeapAlloc(
               GetProcessHeap(),
               HEAP_ZERO_MEMORY,
               dwSdSizeNeeded);

         if (psdNew == NULL){
			sprintf(Msg, "HeapAlloc 2 returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			__leave;
         }

         dwSidSize = dwSdSizeNeeded;

         if (!GetUserObjectSecurity(
               hwinsta,
               &si,
               psd,
               dwSidSize,
               &dwSdSizeNeeded)) {
			sprintf(Msg, "GetUserObjectSecurity returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			__leave;
         }
      }
      else
         __leave;

      // Create a new DACL.

      if (!InitializeSecurityDescriptor(
            psdNew,
            SECURITY_DESCRIPTOR_REVISION) ) {
		sprintf(Msg, "InitializeSecurityDescriptor returned an error %d", GetLastError());
		MessageBox(0, (char*)Msg, "error", MB_OK);
		__leave;
      }

      // Get the DACL from the security descriptor.

      if (!GetSecurityDescriptorDacl(
            psd,
            &bDaclPresent,
            &pacl,
            &bDaclExist)
      ) {
			sprintf(Msg, "GetSecurityDescriptorDacl returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			__leave;
      }

      // Initialize the ACL.

      ZeroMemory(&aclSizeInfo, sizeof(ACL_SIZE_INFORMATION));
      aclSizeInfo.AclBytesInUse = sizeof(ACL);

      // Call only if the DACL is not NULL.

      if (pacl != NULL)
      {
         // get the file ACL size info
         if (!GetAclInformation(
               pacl,
               (LPVOID)&aclSizeInfo,
               sizeof(ACL_SIZE_INFORMATION),
               AclSizeInformation)
         ) {
			sprintf(Msg, "GetAclInformation returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			__leave;
         }
      }

      // Compute the size of the new ACL.

      dwNewAclSize = aclSizeInfo.AclBytesInUse + (2*sizeof(ACCESS_ALLOWED_ACE)) + 
(2*GetLengthSid(psid)) - (2*sizeof(DWORD));

      // Allocate memory for the new ACL.

      pNewAcl = (PACL)HeapAlloc(
            GetProcessHeap(),
            HEAP_ZERO_MEMORY,
            dwNewAclSize);

      if (pNewAcl == NULL) {
			sprintf(Msg, "HeapAlloc 3 returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			__leave;
       };

      // Initialize the new DACL.

      if (!InitializeAcl(pNewAcl, dwNewAclSize, ACL_REVISION)){
			sprintf(Msg, "InitializeAcl returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			__leave;
      };

      // If DACL is present, copy it to a new DACL.

      if (bDaclPresent)
      {
         // Copy the ACEs to the new ACL.
         if (aclSizeInfo.AceCount)
         {
            for (i=0; i < aclSizeInfo.AceCount; i++)
            {
               // Get an ACE.
               if (!GetAce(pacl, i, &pTempAce)) {
			      sprintf(Msg, "GetAce returned an error %d", GetLastError());
				  MessageBox(0, (char*)Msg, "error", MB_OK);
				  __leave;
			   };

               // Add the ACE to the new ACL.
               if (!AddAce(
                     pNewAcl,
                     ACL_REVISION,
                     MAXDWORD,
                     pTempAce,
                    ((PACE_HEADER)pTempAce)->AceSize)
               ) {
			      sprintf(Msg, "AddAce returned an error %d", GetLastError());
				  MessageBox(0, (char*)Msg, "error", MB_OK);
				  __leave;
			   };
            }
         }
      }

      // Add the first ACE to the window station.

      pace = (ACCESS_ALLOWED_ACE *)HeapAlloc(
            GetProcessHeap(),
            HEAP_ZERO_MEMORY,
            sizeof(ACCESS_ALLOWED_ACE) + GetLengthSid(psid) -
                  sizeof(DWORD));

      if (pace == NULL) {
         sprintf(Msg, "HeapAlloc 4 returned an error %d", GetLastError());
         MessageBox(0, (char*)Msg, "error", MB_OK);
         __leave;
	  };

      pace->Header.AceType  = ACCESS_ALLOWED_ACE_TYPE;
      pace->Header.AceFlags = CONTAINER_INHERIT_ACE |
                   INHERIT_ONLY_ACE | OBJECT_INHERIT_ACE;
      pace->Header.AceSize  = sizeof(ACCESS_ALLOWED_ACE) +
                   GetLengthSid(psid) - sizeof(DWORD);
      pace->Mask            = GENERIC_ACCESS;

      if (!CopySid(GetLengthSid(psid), &pace->SidStart, psid)) {
	     sprintf(Msg, "CopySid returned an error %d", GetLastError());
	     MessageBox(0, (char*)Msg, "error", MB_OK);
	     __leave;
	  };

      if (!AddAce(
            pNewAcl,
            ACL_REVISION,
            MAXDWORD,
            (LPVOID)pace,
            pace->Header.AceSize)
      ) {
         sprintf(Msg, "AddAce 2 returned an error %d", GetLastError());
	     MessageBox(0, (char*)Msg, "error", MB_OK);
	     __leave;
	  };

      // Add the second ACE to the window station.

      pace->Header.AceFlags = NO_PROPAGATE_INHERIT_ACE;
      pace->Mask            = WINSTA_ALL;

      if (!AddAce(
            pNewAcl,
            ACL_REVISION,
            MAXDWORD,
            (LPVOID)pace,
            pace->Header.AceSize)
      ){
         sprintf(Msg, "AddAce 3 returned an error %d", GetLastError());
	     MessageBox(0, (char*)Msg, "error", MB_OK);
	     __leave;
	  };

      // Set a new DACL for the security descriptor.
      if (!SetSecurityDescriptorDacl(
            psdNew,
            TRUE,
            pNewAcl,
            FALSE)
      ){
         sprintf(Msg, "SetSecurityDescriptorDacl returned an error %d", GetLastError());
	     MessageBox(0, (char*)Msg, "error", MB_OK);
	     __leave;
	  };

      // Set the new security descriptor for the window station.

      if (!SetUserObjectSecurity(hwinsta, &si, psdNew)) {
		 sprintf(Msg, "SetUserObjectSecurity returned an error %d", GetLastError());
	     MessageBox(0, (char*)Msg, "error", MB_OK);
	     __leave;
	  };

      // Indicate success.

      bSuccess = TRUE;
   }
   __finally
   {
      // Free the allocated buffers.

      if (pace != NULL)
         HeapFree(GetProcessHeap(), 0, (LPVOID)pace);

      if (pNewAcl != NULL)
         HeapFree(GetProcessHeap(), 0, (LPVOID)pNewAcl);

      if (psd != NULL)
         HeapFree(GetProcessHeap(), 0, (LPVOID)psd);

      if (psdNew != NULL)
         HeapFree(GetProcessHeap(), 0, (LPVOID)psdNew);
   }

   return bSuccess;

}

BOOL AddAceToDesktop(HDESK hdesk, PSID psid)
{
   ACL_SIZE_INFORMATION aclSizeInfo;
   BOOL                 bDaclExist;
   BOOL                 bDaclPresent;
   BOOL                 bSuccess = FALSE;
   DWORD                dwNewAclSize;
   DWORD                dwSidSize = 0;
   DWORD                dwSdSizeNeeded;
   PACL                 pacl;
   PACL                 pNewAcl;
   PSECURITY_DESCRIPTOR psd = NULL;
   PSECURITY_DESCRIPTOR psdNew = NULL;
   PVOID                pTempAce;
   SECURITY_INFORMATION si = DACL_SECURITY_INFORMATION;
   unsigned int         i;

   __try
   {
      // Obtain the security descriptor for the desktop object.

      if (!GetUserObjectSecurity(
            hdesk,
            &si,
            psd,
            dwSidSize,
            &dwSdSizeNeeded))
      {
         if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
         {
            psd = (PSECURITY_DESCRIPTOR)HeapAlloc(
                  GetProcessHeap(),
                  HEAP_ZERO_MEMORY,
                  dwSdSizeNeeded );

            if (psd == NULL)
               __leave;

            psdNew = (PSECURITY_DESCRIPTOR)HeapAlloc(
                  GetProcessHeap(),
                  HEAP_ZERO_MEMORY,
                  dwSdSizeNeeded);

            if (psdNew == NULL)
               __leave;

            dwSidSize = dwSdSizeNeeded;

            if (!GetUserObjectSecurity(
                  hdesk,
                  &si,
                  psd,
                  dwSidSize,
                  &dwSdSizeNeeded)
            )
               __leave;
         }
         else
            __leave;
      }

      // Create a new security descriptor.

      if (!InitializeSecurityDescriptor(
            psdNew,
            SECURITY_DESCRIPTOR_REVISION)
      )
         __leave;

      // Obtain the DACL from the security descriptor.

      if (!GetSecurityDescriptorDacl(
            psd,
            &bDaclPresent,
            &pacl,
            &bDaclExist)
      )
         __leave;

      // Initialize.

      ZeroMemory(&aclSizeInfo, sizeof(ACL_SIZE_INFORMATION));
      aclSizeInfo.AclBytesInUse = sizeof(ACL);

      // Call only if NULL DACL.

      if (pacl != NULL)
      {
         // Determine the size of the ACL information.

         if (!GetAclInformation(
               pacl,
               (LPVOID)&aclSizeInfo,
               sizeof(ACL_SIZE_INFORMATION),
               AclSizeInformation)
         )
            __leave;
      }

      // Compute the size of the new ACL.
char Msg[500];
      dwNewAclSize = aclSizeInfo.AclBytesInUse +
            sizeof(ACCESS_ALLOWED_ACE) +
            GetLengthSid(psid) - sizeof(DWORD);

      // Allocate buffer for the new ACL.

      pNewAcl = (PACL)HeapAlloc(
            GetProcessHeap(),
            HEAP_ZERO_MEMORY,
            dwNewAclSize);

      if (pNewAcl == NULL)
	  {
		sprintf(Msg, "HeapAlloc returned an error %d", GetLastError());
		MessageBox(0, (char*)Msg, "error", MB_OK);
         __leave;
	  }

      // Initialize the new ACL.

      if (!InitializeAcl(pNewAcl, dwNewAclSize, ACL_REVISION))
	  {
		sprintf(Msg, "InitializeAcl returned an error %d", GetLastError());
		MessageBox(0, (char*)Msg, "error", MB_OK);
         __leave;
	  }

      // If DACL is present, copy it to a new DACL.

      if (bDaclPresent)
      {
         // Copy the ACEs to the new ACL.
         if (aclSizeInfo.AceCount)
         {
            for (i=0; i < aclSizeInfo.AceCount; i++)
            {
               // Get an ACE.
               if (!GetAce(pacl, i, &pTempAce))
                  __leave;

               // Add the ACE to the new ACL.
               if (!AddAce(
                  pNewAcl,
                  ACL_REVISION,
                  MAXDWORD,
                  pTempAce,
                  ((PACE_HEADER)pTempAce)->AceSize)
               )
	  {
		sprintf(Msg, "AddAce returned an error %d", GetLastError());
		MessageBox(0, (char*)Msg, "error", MB_OK);
         __leave;
	  }
            }
         }
      }

      // Add ACE to the DACL.

      if (!AddAccessAllowedAce(
            pNewAcl,
            ACL_REVISION,
            DESKTOP_ALL,
            psid)
			) 
	  {
		sprintf(Msg, "AddAccessAllowedAce returned an error %d", GetLastError());
		MessageBox(0, (char*)Msg, "error", MB_OK);
         __leave;
	  }

      // Set new DACL to the new security descriptor.

      if (!SetSecurityDescriptorDacl(
            psdNew,
            TRUE,
            pNewAcl,
            FALSE)
      )
	  {
		sprintf(Msg, "SetSecurityDescriptorDacl returned an error %d", GetLastError());
		MessageBox(0, (char*)Msg, "error", MB_OK);
         __leave;
	  }
      // Set the new security descriptor for the desktop object.

      if (!SetUserObjectSecurity(hdesk, &si, psdNew))
	  {
		sprintf(Msg, "SetUserObjectSecurity returned an error %d", GetLastError());
		MessageBox(0, (char*)Msg, "error", MB_OK);
         __leave;
	  }
      // Indicate success.

      bSuccess = TRUE;
   }
   __finally
   {
      // Free buffers.

      if (pNewAcl != NULL)
         HeapFree(GetProcessHeap(), 0, (LPVOID)pNewAcl);

      if (psd != NULL)
         HeapFree(GetProcessHeap(), 0, (LPVOID)psd);

      if (psdNew != NULL)
         HeapFree(GetProcessHeap(), 0, (LPVOID)psdNew);
   }

   return bSuccess;
}

PROCESS_HANDLE WINAPI TVPCreateProcess(const char* szCmdLine, ... /*arguments*/)
{
  

  int status;

#ifdef __TV_WINDOWS__
  STARTUPINFO si;
  PROCESS_INFORMATION pi;

  memset(&si,0,sizeof(si));
  si.cb=sizeof(si);
  RVCString Command = "\"";
  Command += szCmdLine;
  Command += "\"";

  char *nextArg;
  va_list ap;
  va_start(ap, szCmdLine);
  while ( nextArg = va_arg(ap,char *)) {
    Command += " ";
    Command += nextArg;
  }
  va_end(ap);

  status = CreateProcess(NULL, (char*)(const char*)Command, NULL, NULL ,FALSE, DETACHED_PROCESS, NULL, NULL, &si, &pi);

  if (status) 
    return pi.hProcess;
  return NULL;

#endif

#ifdef __TV_UNIX__
#ifdef USE_SYSTEM_COMMAND_IN_TVPCreateProcess
  RVCString Command = szCmdLine;
  char *nextArg;
  va_list ap;
  va_start(ap, szCmdLine);
  while ( nextArg = va_arg(ap,char *)) {
    Command += " ";
    Command += nextArg;
  }
  va_end(ap);
  system(Command.data());
  //fprintf(stderr,"Using system(%s) in TVPCreateProcess",Command.data());
  //fflush(stderr);
  return 0;

#else

  char* proc_args[100];
  RVCString rwProcArgs[100];
  int indx = 0;
  proc_args[indx++] = (char *) szCmdLine;
  va_list ap;
  va_start(ap, szCmdLine);
  char *nextArg;
  while ( nextArg = va_arg(ap,char *)) {
    rwProcArgs[indx] = nextArg;
    if (rwProcArgs[indx].contains("\"") ) {
      rwProcArgs[indx]=rwProcArgs[indx].strip(RVCString::both, '\"');
    }
    proc_args[indx] = (char *)rwProcArgs[indx].data();
    indx++;
  }
  va_end(ap);
  proc_args[indx] = NULL;


  pid_t pid;
  pid = fork();

  if ( -1 == pid ) {
    fprintf(stderr,"Error: (TVPCreateProcess) fork failed, Exiting!!!");
    return 0;
  } 
  else if(pid == 0) { // child process
    struct rlimit rlp;
    (void)getrlimit(RLIMIT_NOFILE, &rlp);
    int i;
    for (i = 3 ; i < rlp.rlim_cur ; i++) {
      (void)close(i);
    }
    status = execv(szCmdLine, proc_args);
    if(status == -1) { // signal from process if parent waiting???
      fprintf(stderr,"Error: (TVPCreateProcess) creation of child process failed, Exiting!!!");
      exit(1);
    }
  }
  else { // parent process pid is the processID of the new process.
#ifdef __TV_linux__
    (void)waitpid(pid, NULL,WNOHANG); // remove defunct process if process failed
#endif // __TV_linux__
    return pid;
  }

  return 0;
#endif // USE_SYSTEM_COMMAND_IN_TVPCreateProcess
#endif // __TV_UNIX__
}

static RVMutexLock CreateProcessAsUserMutex;

PROCESS_HANDLE WINAPI TVPCreateProcessAsUser(int UserNum, const char* szCmdLine, ... /*arguments*/)
{
  int status;

#ifdef __TV_WINDOWS__
  STARTUPINFO si;
  PROCESS_INFORMATION pi;

  memset(&si,0,sizeof(si));
  si.cb=sizeof(si);
  RVCString Command = "\"";
  Command += szCmdLine;
  Command += "\"";

  char *nextArg;
  va_list ap;
  va_start(ap, szCmdLine);
  while ( nextArg = va_arg(ap,char *)) {
    Command += " ";
    Command += nextArg;
  }
  va_end(ap);

  //////////////////////////////////////////////////////////////////////////
	
	RVMutexLock::LockGuard lock(CreateProcessAsUserMutex);
	  
	char UserName[100];
	char Msg[100];
	char szNum[10];
	HANDLE hToken;

	strcpy(UserName, "TestView");
	strcat(UserName, itoa(UserNum, szNum, 10));
	
	if (!LogonUser(UserName, ".", "IshayS", LOGON32_LOGON_INTERACTIVE, LOGON32_PROVIDER_DEFAULT, &hToken)) {
		sprintf(Msg, "LogonUser %s returned an error %d", UserName, GetLastError());
		MessageBox(0, (char*)Msg, "error", MB_OK);
		return FALSE;
	}
	  
	HDESK hdesk = NULL;
	HWINSTA hwinsta = NULL, hwinstaSave = NULL;
	PSID pSid = NULL;
	BOOL bResult = FALSE;

	static PSID pInteractiveSid = NULL;

	if ( pInteractiveSid == NULL )
	{
		// Build the Interactive Sid - "BUILTIN\LOCAL" SID : S-1-5-4  
		SID_IDENTIFIER_AUTHORITY sia = SECURITY_NT_AUTHORITY; // "-5-"
		AllocateAndInitializeSid( &sia, 1, 4, 0, 0, 0, 0, 0, 0, 0, &pInteractiveSid );

		// Save a handle to the caller's current window station.
		if ( (hwinstaSave = GetProcessWindowStation() ) == NULL) {
			sprintf(Msg, "GetProcessWindowStation returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			return FALSE;
		}

		// Get a handle to the interactive window station.
		hwinsta = OpenWindowStation(
		   "winsta0",                   // the interactive window station 
		   FALSE,                       // handle is not inheritable
		   READ_CONTROL | WRITE_DAC);   // rights to read/write the DACL

		if (hwinsta == NULL) {
			sprintf(Msg, "GetProcessWindowStation returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			return FALSE;
		}

		// To get the correct default desktop, set the caller's 
		// window station to the interactive window station.

		if (!SetProcessWindowStation(hwinsta)) {
			sprintf(Msg, "GetProcessWindowStation returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			return FALSE;
		}

		// Get a handle to the interactive desktop.

		hdesk = OpenDesktop(
		  "default",     // the interactive window station 
		  0,             // no interaction with other desktop processes
		  FALSE,         // handle is not inheritable
		  READ_CONTROL | // request the rights to read and write the DACL
		  WRITE_DAC | 
		  DESKTOP_WRITEOBJECTS | 
		  DESKTOP_READOBJECTS);

		// Restore the caller's window station.
		if (!SetProcessWindowStation(hwinstaSave)) {
			sprintf(Msg, "SetProcessWindowStation returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			return FALSE;
		}

		if (hdesk == NULL) {
			sprintf(Msg, "hdesk == NULL returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			return FALSE;
		}
		
		//we now grant access to the inteactive Sid, since adding ACE's to the DACL has a design
		//limit of about 60. see http://support.microsoft.com/kb/185292/EN-US
		//this way all the Logged on users  here will has access, since all of them of 
		//interactive type loggon

		// Get the SID for the client's logon session.
//		if (!GetLogonSID(hToken, &pSid)) {
//			sprintf(Msg, "GetLogonSID returned an error %d", GetLastError());
//			MessageBox(0, (char*)Msg, "error", MB_OK);
//			return FALSE;
//		}

		// Allow the interactive Sid full access to the windows station
		if (! AddAceToWindowStation(hwinsta, pInteractiveSid) ) {
			sprintf(Msg, "AddAceToWindowStation returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			return FALSE;
		}

		// Allow the interactive Sid full access to interactive desktop.
		if (! AddAceToDesktop(hdesk, pInteractiveSid) ) {
			sprintf(Msg, "AddAceToDesktop returned an error %d", GetLastError());
			MessageBox(0, (char*)Msg, "error", MB_OK);
			return FALSE;
		}
	}
			
    // free the buffer for the logon sid and the handles to the interactive windowstation and desktop
    if (pSid) HeapFree(GetProcessHeap(), 0, pSid);
    if (hwinsta) CloseWindowStation(hwinsta);
    if (hdesk) CloseDesktop(hdesk);
		
	ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
    //si.lpDesktop = "winsta0\\default";
	ZeroMemory( &pi, sizeof(pi) );

	//////////////////////////////////////////////////////////////////////////
	status = CreateProcessAsUser(hToken, NULL, (char*)(const char*)Command, NULL, NULL ,FALSE, DETACHED_PROCESS, NULL, NULL, &si, &pi);
	//////////////////////////////////////////////////////////////////////////
	
	if (!status) {
		sprintf(Msg, "CreateProcessAsUser returned an error %d\n %s", GetLastError(), (const char*)Command);
		MessageBox(0, (char*)Msg, "error", MB_OK);
	}

	// DO NOT close this handle.
	//CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

  if (status) 
    return pi.hProcess;
  return NULL;

#endif

}

int WINAPI TVPKillProcess(PROCESS_HANDLE& handle) {
	int Rtn = 1;
#ifdef __TV_WINDOWS__
	if(! TerminateProcess(handle, 1) ) {
		Rtn = 0;//failed to terminate process
	}
	CloseHandle(handle);
#endif
#ifdef __TV_UNIX__
	if (-1 == kill(handle, SIGKILL))
	  Rtn = 0;

	//fprintf(stderr,"Calling waitpid(%d,NULL,WNOHANG) in TVPKillProcess",handle);
	//fflush(stderr);
	(void)waitpid(handle, NULL,WNOHANG); // remove defunct process
#endif
	return Rtn;
}

/********************* TVP GET TIME ***********************/
/* The function returns a time string:   hh:mm:ss.mm      */
/**********************************************************/

const char* WINAPI TVPGetTime()
{
  static char res[512] = "0";
#ifdef __TV_WINDOWS__
  
   _strtime(res);
  
#endif
  
#ifdef __TV_UNIX__
  
  struct tm *time_now;
  time_t secs_now;
  
  tzset();
  time(&secs_now);
  
  /* Returns the best available approximation of local
     wall clock time */
#ifndef HAVE_LOCALTIME_R
  time_now = localtime(&secs_now);
#else
    struct tm tn;
    localtime_r(&secs_now,&tn); /* get dst information */
    time_now = &tn;
#endif

  
  /* Converts the character string to a string
     with format hh/mm/ss */
  strftime(res,10,"%T",time_now);
  
#endif
  
  return res;
}


/********************* TVP GET DATE ***********************/
/* The function returns a date string:   mm-dd-yy         */
/**********************************************************/

const char* WINAPI TVPGetDate()
{
  static char res[512] = "0";
#ifdef __TV_WINDOWS__
  
   _strdate(res);
   
#endif
  
#ifdef __TV_UNIX__
  
  struct tm *time_now;
  time_t secs_now;
  
  tzset();
  time(&secs_now);
  
  /* Returns the best available approximation of local
     wall clock time */
#ifndef HAVE_LOCALTIME_R
  time_now = localtime(&secs_now);
#else
    
    struct tm tn;
    localtime_r(&secs_now,&tn); /* get dst information */
    time_now = &tn;

#endif
  
  /* Converts the character string to a string
     with format mm/dd/yy */
  strftime(res,10,"%D",time_now);
  
#endif
  
  return res;
}


long WINAPI TVPWaitTime(long delta)
{
#ifdef __TV_WINDOWS__
  Sleep(delta);
#endif
#ifdef __TV_WINDOWS__keep
  timeb endtime;
  timeb curtime;
  //
  // get the delta time to wait (in millisec.)
  // and calculate the delta's.
  long deltaSec = delta/1000;
  short  deltaMillisec = (((long)delta) % 1000);

  //
  // calculate the end-time.
  ftime(&curtime);
  endtime.millitm = curtime.millitm + deltaMillisec;
  int add = 0;
  if (endtime.millitm > 1000)
  {
    endtime.millitm -= 1000;
    add++;
  }
  endtime.time = curtime.time+deltaSec+add;

  //
  // loop until checked time equals end-time.
  while(curtime.time < endtime.time || (curtime.time == endtime.time && curtime.millitm < endtime.millitm)) {
    Yield();
    ftime(&curtime);
  }

  //
  // return the actual delta.
  deltaSec += (curtime.time - endtime.time);
  deltaMillisec += (curtime.millitm - endtime.millitm);
  delta = deltaSec*1000 + deltaMillisec;
#endif

#ifdef __TV_UNIX__
  struct timeval  tv;

  tv.tv_sec = delta/1000;
  tv.tv_usec = (delta - tv.tv_sec*1000)*1000;
  select(0, NULL, NULL, NULL, &tv);
#endif

  return delta;
}

double WINAPI TVPSysTime()
{
  double systime;
#ifdef __TV_WINDOWS__
  timeb timebuf;
  ftime(&timebuf);
  systime = timebuf.time + ((double)timebuf.millitm)/1000.0;
#endif
#ifdef __TV_UNIX__
  struct timeval timebuf;
  gettimeofday(&timebuf, NULL);
  systime = timebuf.tv_sec + ((double)timebuf.tv_usec)/1000000.0;
#endif
  return systime;
}

/************************* LIBMAIN *********************************/
/*  DLL standart main                                              */
/*******************************************************************/
#ifdef __TV_WINDOWS__
#include <crtdbg.h>
BOOL WINAPI DllMain( HINSTANCE hinstDll,
                           DWORD fdwRreason,
                           LPVOID plvReserved)
{
  switch (fdwRreason){
    case DLL_PROCESS_ATTACH:
      _CrtSetDbgFlag(0);
      break;
    case DLL_PROCESS_DETACH:
      break;

  }

  return TRUE;
}
#endif

