/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __LTVSNV_H
#define __LTVSNV_H

#include <windows.h>

#define LINELEN 80
#define MSGLEN 500
#define MAX_ENV_TABLE 256

typedef enum { Save, Load } ParseMode;

BOOL TVSAddEntry(TableHandle h, const char *e, const char *v);
BOOL TVSIsSaveDone(TableHandle h,const char *e);
BOOL TVSUpdateSaveDone(TableHandle h, const char *e, int SaveDone);
void ErrorHandling(const char *msg);
BOOL IsConfigWord(const char *word);
BOOL TVSAbsPath(const char *path,char *newpath,int len);
void TVSDisplayError(const char *msg);
const char* TVSpath(const char* fullFileName);
BOOL TVSinit(const char *TestViewPath);
BOOL TVSLoadConfigWord(const char *TestViewPath);

#endif /* __LTVSNV_H   */

