/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* Copyright  1993-1995, Radview Software LTD. All Rights Reserved. */
/**********************************************************/
/*                                                        */
/* platform.h   -- platform header file                   */
/*                                                        */
/*         who        when          what                            */
/*      Iris        April 95  Created                         */
/*                                                        */
/**********************************************************/

#ifndef __TVEPLAT_H
#define __TVEPLAT_H

#include <windows.h>
#include <stdlib.h>
#include <stdarg.h>

#ifdef __TV_WINDOWS__

#ifdef TV_CONST       /* TV_CONST is NULL on UNIN and const on WINDOWS */
#undef TV_CONST
#endif
#define TV_CONST //const

#endif /* __TV_WINDOWS__ */

#ifdef __TV_UNIX__

#ifdef TV_CONST       /* TV_CONST is NULL on UNIN and const on WINDOWS */
#undef TV_CONST
#endif
#define TV_CONST

#endif /* __TV_UNIX__ */

#ifdef __TV_WINDOWS__

#ifdef strcasecmp
#undef strcasecmp
#endif
#define strcasecmp strcmpi

#ifdef strncasecmp
#undef strncasecmp
#endif
#define strncasecmp strncmpi

#endif /* __TV_WINDOWS__ */

#ifdef __TV_UNIX__

#ifdef strcmpi
#undef strcmpi
#endif
#define strcmpi strcasecmp

#ifdef stricmp
#undef stricmp
#endif
#define stricmp strcasecmp

#ifdef strncmpi
#undef strncmpi
#endif
#define strncmpi strncasecmp

#endif /* __TV_UNIX__ */

#ifdef __TV_UNIX__

#ifdef wsprintf
#undef wsprintf
#endif
#define wsprintf sprintf

#endif /* __TV_UNIX__ */

#ifdef __TV_UNIX__

#ifdef ltoa
#undef ltoa
#endif
#define ltoa(l,str,base) \
(                           \
  sprintf(str,"%ld",l), \
  str  \
)

#ifdef itoa
#undef itoa
#endif
#define itoa(i,str,base) \
(                           \
  sprintf(str,"%d",i), \
  str  \
)

#endif /* __TV_UNIX__ */


#ifdef __TV_WINDOWS__
#define PATH_SEP_CHAR ';'
#define PATH_SEP_STR  ";"
#endif
#ifdef __TV_UNIX__
#define PATH_SEP_CHAR ':'
#define PATH_SEP_STR  ":"
#endif


#if (defined _cplusplus) || (defined __cplusplus)
extern "C" {
#endif

const char*  TVPStrlwr(char* str);
const char*  TVPStrupr(char* str);
int  TVPExecApplication(const char* szCmdLine);
const char*  TVPGetTime();
const char*  TVPGetDate();
long  TVPWaitTime(long delta);

const char*  TVPResolveFilePath(const char* fileName, const char* pathvar);
const char*  TVPSearchPath(const char* fileName);
const char*  TVPFindfile(const char* fileName,const char* where,...);
const char*  TVPFINDFILE(const char* fileName,const char* where,...);
const char*  TVPFindfileNoTVEnv(const char* fileName,const char* where,...);
const char*  TVPGetFullName(const char* Old,char* New,int len);
BOOL  TVPAbsPath(const char *path,char *newpath,int len);

int  TVPFileExist(const char* fileName);
#ifdef __TV_UNIX__
int  TVPIsOpenFileADirectory(FILE* yy);
#endif
int  TVPIsClosedFileADirectory(const char* fileName);

void  TVPSplitPath(const char* path, char** dir, char** fname, char** ext);
const char*  TVPGetPathDirectory(const char* path);
const char*  TVPGetPathName(const char* path);
const char*  TVPGetPathExt(const char* path);

const char*  TVPMakePath(const char* dir, const char* fname, const char* ext);
const char*  TVPConcatDirAndName(const char* dir, const char* fname);
const char*  TVPReplacePathExt(const char* path, const char* newext);
const char* TVPAdjustPathLen(const char* oldpath, char* newpath, int len);

int  TVPChdir(const char* newDir);
const char*  TVPGetCwd();
void  TVPGetCurrentDir(char *path,int len);
const char*  TVPGetUserDir();
const char*  TVPGetTempName(const char *pathvar);

BOOL  TVPCopyFile(const char *FromFileName, const char *ToFileName);

#if (defined _cplusplus) || (defined __cplusplus)
}
#endif

#endif // __PLATFORM_H

