/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// UnicodeCType.h : Unicode CType functions
//

#ifndef _UNICODECTYPE_H
#define _UNICODECTYPE_H
#include "portable.h"
#include <ctype.h>
#ifdef __cplusplus
extern "C" {
#endif

//APIs
bool ULAPI w_isalpha(gt_wchar_t wChar);
bool ULAPI w_isdigit(gt_wchar_t wChar);
bool ULAPI w_isalnum(gt_wchar_t wChar);
bool ULAPI w_iscntrl(gt_wchar_t wChar);
bool ULAPI w_isspace(gt_wchar_t wChar);
bool ULAPI w_isblank(gt_wchar_t wChar);
bool ULAPI w_ispunct(gt_wchar_t wChar);
bool ULAPI w_isgraph(gt_wchar_t wChar);
bool ULAPI w_isprint(gt_wchar_t wChar);
bool ULAPI w_isupper(gt_wchar_t wChar);
bool ULAPI w_islower(gt_wchar_t wChar);
bool ULAPI w_istitle(gt_wchar_t wChar);
//bool ULAPI w_isxdigit(gt_wchar_t wChar);
bool ULAPI w_isisocntrl(gt_wchar_t wChar);
bool ULAPI w_isfmtcntrl(gt_wchar_t wChar);
bool ULAPI w_issymbol(gt_wchar_t wChar);
bool ULAPI w_isnumber(gt_wchar_t wChar);
bool ULAPI w_isnonspacing(gt_wchar_t wChar);
bool ULAPI w_isopenpunct(gt_wchar_t wChar);
bool ULAPI w_isclosepunct(gt_wchar_t wChar);
bool ULAPI w_isinitialpunct(gt_wchar_t wChar);
bool ULAPI w_isfinalpunct(gt_wchar_t wChar);
bool ULAPI w_iscomposite(gt_wchar_t wChar);
//bool ULAPI w_ishex(gt_wchar_t wChar);
//bool ULAPI w_isquote(gt_wchar_t wChar);
//bool ULAPI w_issymmetric(gt_wchar_t wChar);
bool ULAPI w_ismirroring(gt_wchar_t wChar);
//bool ULAPI w_isnonbreaking(gt_wchar_t wChar);
/*
 * Directionality macros.
 */
BYTE ULAPI w_getbiditype(gt_wchar_t wChar);
bool ULAPI w_isrtl(gt_wchar_t wChar);
bool ULAPI w_isltr(gt_wchar_t wChar);
bool ULAPI w_isstrong(gt_wchar_t wChar);
bool ULAPI w_isweak(gt_wchar_t wChar);
bool ULAPI w_isneutral(gt_wchar_t wChar);
bool ULAPI w_isseparator(gt_wchar_t wChar);
bool ULAPI w_iscjkchar(gt_wchar_t wChar);

/*
 * Other miscellaneous character property macros.
 */
bool ULAPI w_ishan(gt_wchar_t wChar);
bool ULAPI w_ishangul(gt_wchar_t wChar);
/**************************************************************************
 *
 * Functions for case conversion.
 *
 **************************************************************************/
gt_wchar_t ULAPI w_toupper(gt_wchar_t wChar);
gt_wchar_t ULAPI w_tolower(gt_wchar_t wChar);

gt_wchar_t ULAPI *w_strlwr( gt_wchar_t *string );
gt_wchar_t ULAPI *w_strupr( gt_wchar_t *string );
int ULAPI w_stricmp( const gt_wchar_t *string1, const gt_wchar_t *string2 );
int ULAPI w_strnicmp( const gt_wchar_t *string1, const gt_wchar_t *string2, size_t count );
int ULAPI w_strlen(const gt_wchar_t *string1);

gt_wchar_t ULAPI * w_strcat(gt_wchar_t *ws1, const gt_wchar_t *ws2);
gt_wchar_t ULAPI * w_strcpy(gt_wchar_t *ws1, const gt_wchar_t *ws2);
gt_wchar_t ULAPI * w_strncpy(gt_wchar_t *ws1, const gt_wchar_t *ws2, size_t n);

int ULAPI w_normalize( gt_wchar_t *pIn, int nInLen, gt_wchar_t *pDecomposed, int nMaxDecomposed );
#ifdef __cplusplus
}
#endif
#endif//_UNICODECTYPE_H
