/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// UniProp.h : Unicode character properties definitions
//

#ifndef UNIPROP_H
#define UNIPROP_H

#ifdef __TV_UNIX__
#include "gt_portable.h"
//typedef byte BYTE;
//typedef word WORD;
#endif //UNIX

typedef struct 
{
	BYTE byGeneralCategory;   // field 2
	BYTE nCanonicalCombiningClass; // field 3
	BYTE byBiDiCategory;		// field 4
//	BYTE DecimalDigitValue;
//	BYTE DigitValue;
	WORD pDecomposition[2];
	WORD wLowerUpperOffset;		// field 12/13
	BYTE byFlag;
} UNICODE_TYPE;


// General Ctegory
#define UNI_GC_Lu 1 /* Letter, Uppercase  */
#define UNI_GC_Ll 2 /* Letter, Lowercase */
#define UNI_GC_Lt 3 /* Letter, Titlecase */
#define UNI_GC_Mn 4 /* Mark, Non-Spacing */
#define UNI_GC_Mc 5 /* Mark, Spacing Combining */
#define UNI_GC_Me 6 /* Mark, Enclosing */
#define UNI_GC_Nd 7 /* Number, Decimal Digit */
#define UNI_GC_Nl 8 /* Number, Letter */
#define UNI_GC_No 9 /* Number, Other */
#define UNI_GC_Zs 10 /* Separator, Space */
#define UNI_GC_Zl 11 /* Separator, Line */
#define UNI_GC_Zp 12 /* Separator, Paragraph */
#define UNI_GC_Cc 13 /* Other, Control */
#define UNI_GC_Cf 14 /* Other, Format */
#define UNI_GC_Cs 15 /* Other, Surrogate */
#define UNI_GC_Co 16 /* Other, Private Use */
#define UNI_GC_Cn 17 /* Other, Not Assigned (no characters in the file have this property) */
//Informative Categories
#define UNI_GC_Lm 18 /* Letter, Modifier  */
#define UNI_GC_Lo 19 /* Letter, Other  */
#define UNI_GC_Pc 20 /* Punctuation, Connector  */
#define UNI_GC_Pd 21 /* Punctuation, Dash  */
#define UNI_GC_Ps 22 /* Punctuation, Open  */
#define UNI_GC_Pe 23 /* Punctuation, Close  */
#define UNI_GC_Pi 24 /* Punctuation, Initial quote (may behave like Ps or Pe depending on usage)  */
#define UNI_GC_Pf 25 /* Punctuation, Final quote (may behave like Ps or Pe depending on usage)  */
#define UNI_GC_Po 26 /* Punctuation, Other  */
#define UNI_GC_Sm 27 /* Symbol, Math  */
#define UNI_GC_Sc 28 /* Symbol, Currency */ 
#define UNI_GC_Sk 29 /* Symbol, Modifier  */
#define UNI_GC_So 30 /* Symbol, Other  */


// BiDirectional Category:
#define UNI_BC_L	1/* Left-to-Right */
#define UNI_BC_LRE	2 /* Left-to-Right Embedding */
#define UNI_BC_LRO	3 /* Left-to-Right Override */
#define UNI_BC_R	4/* Right-to-Left */
#define UNI_BC_AL	5/* Right-to-Left Arabic */
#define UNI_BC_RLE	6 /* Right-to-Left Embedding */
#define UNI_BC_RLO	7/* Right-to-Left Override */
#define UNI_BC_PDF	8 /* Pop Directional Format */
#define UNI_BC_EN	9 /* European Number */
#define UNI_BC_ES	10/* European Number Separator */
#define UNI_BC_ET	11/* European Number Terminator */
#define UNI_BC_AN	12/* Arabic Number */
#define UNI_BC_CS	13/* Common Number Separator */
#define UNI_BC_NSM	14/* Non-Spacing Mark */
#define UNI_BC_BN	15/* Boundary Neutral */
#define UNI_BC_B	16/* Paragraph Separator */
#define UNI_BC_S	17/* Segment Separator */
#define UNI_BC_WS	18/* Whitespace */
#define UNI_BC_ON	19/* Other Neutrals */

#define MAX_DECOMPOSE	20
// Flag Bit Mapping:
#define UNI_FLAG_MIRRORED  0x01
#define UNI_FLAG_CASE_OFFSET_POSITIVE  0x02

#endif
