/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// UniReader.cpp : Implementation of CUniFileApp and DLL registration.

#include "stdafx.h"
#include "UniFile.h"
#include "UniReader.h"
#include "gt_unicode.h"

#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>
#include <stdio.h>

/////////////////////////////////////////////////////////////////////////////
//

STDMETHODIMP CUniReader::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IUniReader,
	};

	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
//		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CUniReader::GetFileData(BSTR fileName, BSTR *fileData)
{
	USES_CONVERSION;
	// TODO: Add your implementation code here
	int fileHandle = _open(W2A(fileName), _O_RDONLY | _O_TEXT);
	if (fileHandle == -1)
		return S_FALSE;

	int nFileSize = _filelength(fileHandle);
	char *szData = new char[nFileSize + 1];
	_lseek(fileHandle, 3, SEEK_SET);
	int nBytesRead = _read(fileHandle, szData, nFileSize);
	_close(fileHandle);
	szData[nBytesRead] = '\0';
	
	int nChars = ANSIToUCS2(CP_UTF8, szData, -1, NULL, 0);
	wchar_t *wzData = new  wchar_t[nChars];
	ANSIToUCS2(CP_UTF8, szData, -1, wzData, nChars);

	*fileData = ::SysAllocString(wzData);

	delete [] wzData;
	delete []  szData;
	return S_OK;
}
