/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "gt_jshelper.h"
#include "gt_portable.h"
JSString* ANSINewStringCopyZ(JSContext *cx, const char *s)
{
	int nLen = ANSIToUCS2(CP_ACP, s, -1, NULL, 0);
	gt_wchar_t *wzStr = new gt_wchar_t[nLen];
	ANSIToUCS2(CP_ACP, s, -1, wzStr, nLen);

	JSString *ret = JS_NewUCStringCopyZ(cx, wzStr);
	delete [] wzStr;
	return ret;
}

StrWrapper ANSIGetStringBytes_F(JSString *str)
{
	gt_wchar_t *wzStr = JS_GetStringChars(str);

	int nLen = UCS2ToANSI(CP_ACP, wzStr, -1, NULL, 0);
	char *szStr = new char[nLen];
	UCS2ToANSI(CP_ACP, wzStr, -1, szStr, nLen);

	StrWrapper t(szStr);
	return t;
}

