/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  



#ifndef dRVJS_HH
#define dRVJS_HH

#include "rvjsapi.h"
#include "rvjsdbgapi.h"

#include "wlerrorlib.h"

namespace nJs {

//nJs
class DllExport iJSEmbedContext;

//RVJSGeneral
class DllExport nZTSEncription;

class DllExport cFileRef;
class DllExport iFile; //
class DllExport iFileMap;
class DllExport cRuntime;

DllExport iFile* ZTSEncriptionToFile( const char* );

typedef uintN tLineNumber;
typedef int tColumn;


// RVJSReport
class DllExport iReportThreadState;
class DllExport cReportThreadState;
class DllExport coReportThreadState;

class DllExport iEmbedderCallContext;
class DllExport cJSEmbedderCallContext;

class DllExport iReportInfo;
class DllExport ivReportInfo;
class DllExport iDebugExecReportInfo;
class DllExport iPlainReportInfo;
class DllExport cInternalReportInfo;

class DllExport iReportCommit;
class DllExport iExecReportCommit;
class DllExport iJSReportCommit;
class DllExport iJSExecReportCommit;

class DllExport cJSDReportCommit;


//nJsd
class DllExport	iContext;
#pragma warning( disable: 4275 )

class DllExport iScript;
class DllExport iScriptHookable;
class DllExport cScriptHookable;
class DllExport	iDMThreadState;
class DllExport cDMThreadState;
class DllExport iStackFrame;
class DllExport	iStackFrameLevel;
class DllExport	cIteratableStackFrame;
class DllExport iValue;
class DllExport cValueRooted;
class DllExport cValueHold;
class DllExport cPropertiesIter;
class DllExport iProperty;
class DllExport cProperty;
class DllExport iUi;
class DllExport iDebugger;
class DllExport iSpace;
class DllExport iInterruptionControlCommit;
class DllExport cInterruptionControlCommit;
class DllExport iSpaceUi;
class DllExport	cSpaceCompose;
class DllExport iVirtualLoadEngine;

typedef uintN tStackFrameIndex;
typedef uintN tPropertyIndex;




 	} // nJs


#endif // dRVJS_HH
