/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WebLoad_ComObjectClass_H
#define __WebLoad_ComObjectClass_H

#include "platform.h"

class iJSComPrivateData;

#if (defined_cplusplus) || (defined __cplusplus)
extern "C" {//to compile as C
#endif

#define ComScriptingFrmFile "comscripting.frm"

extern JSClass ComObjectClass;

typedef enum WL_CONVERSION_SOURCE {
  		WL_EMPTY,
			WL_CONVERSION_FUNCTION,
			WL_GET_PROPERTY,
			WL_SET_PROPERTY,
			WL_METHOD
//			WL_CByte,
//			WL_CInt,
//			WL_CLng,
//			WL_CFlt,
//			WL_CVARIANT,
//			WL_CIUnknown,
//			WL_CIDispatch
} WL_CONVERSION_SOURCE;


struct WLERRORINFO{

	WLERRORINFO()
	{
		m_ErrorIndex = 0;
		m_ConversionSource = WL_EMPTY;
		m_ErrorDescription = "";
		m_MethodName = "";
		m_IsArray = 0;
		m_ParamNumber = 0;
		m_hrLastError=-1;
		m_hrReturnedFromComLastFunction=-1;
		m_hrReturnedFromInvoke=-1;
		m_Description_hrReturnedFromComLastFunction="empty";
		m_Description_hrReturnedFromInvoke="empty";
		m_DescriptionRichObjectError = "empty";

	}

	WLERRORINFO(WL_CONVERSION_SOURCE ConversionSource,RVCString MethodName){

		m_ConversionSource = ConversionSource;
		m_MethodName = MethodName;
		m_IsArray = 0;
		m_ErrorIndex = 0;
		m_ErrorDescription = "";
		m_ParamNumber = 0;
		m_hrLastError=-1;
		m_hrReturnedFromComLastFunction=-1;
		m_hrReturnedFromInvoke=-1;
		m_Description_hrReturnedFromComLastFunction="empty";
		m_Description_hrReturnedFromInvoke="empty";
		m_DescriptionRichObjectError = "empty";
	}

	int m_ErrorIndex;
    RVCString m_ErrorDescription;
	RVCString m_MethodName;
	WL_CONVERSION_SOURCE m_ConversionSource;
	int m_IsArray;
	int m_ParamNumber;
	HRESULT m_hrLastError;
	HRESULT m_hrReturnedFromInvoke;
	HRESULT m_hrReturnedFromComLastFunction;
	RVCString m_Description_hrReturnedFromComLastFunction;
	RVCString m_Description_hrReturnedFromInvoke;
	RVCString m_DescriptionRichObjectError;
};



//	MSDN : Declaring functions as dllexport eliminates the need for a module-definition (.DEF) file.
bool RegisterComObject(JSContext *cx, JSObject *obj);

bool ThrowComError(JSContext *cx,WLERRORINFO &ErrInfo);

JSBool
GlobalComObject_PropertyGet(JSContext *cx, JSObject *obj, jsval id, jsval *vp);


#if (defined_cplusplus) || (defined __cplusplus)
}
#endif


#endif //__WebLoad_ComObjectClass_H
