/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __IJSCOMPRIVATEDATA__H
#define __IJSCOMPRIVATEDATA__H

#include <ordered.h>
#include "platform.h"
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the JSCOMOBJECT_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// JSCOMOBJECT_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.

#ifdef JSCOMOBJECT_EXPORTS
#define JSCOMOBJECT_API __declspec(dllexport)
#else
#define JSCOMOBJECT_API __declspec(dllimport)
#endif

struct WLERRORINFO;
class CMethodsHashDictionary;
class ComMethodPrivate;
class CMethodInfo;
class CObjectsHashDictionary;
struct JSCOM_INVOKE_PARAMS;
struct JSObject;

enum Object_RDS_Status{
	STANDARD_OBJECT,
	RDS_OBJECT,
	CREATED_VIA_RDS
};


class JSCOMOBJECT_API iJSComPrivateData {
public:
  
	iJSComPrivateData();
  virtual ~iJSComPrivateData();
  bool Init(const char* ClassName_, WLERRORINFO &m_ErrInfo,char* RemoteComputerName_ = "");
	HRESULT PtrIUnknown2PtrIDispatch(IUnknown *ptrIUnknown,
									 IDispatch **ptrIDispatch);

  void TypeInfoWarning();



	void SetptrIDispatch(IDispatchPtr& spIDispatch_);
//	IDispatch * GetptrIDispatch_WithoutAddref();
	
	//The one that call the function GetPtrIDispatch is responsible for the reference counter.
	IDispatchPtr GetptrIDispatch();
  void Set_ptr_methods_cache(CMethodsHashDictionary *ptr_methods_cache_);

  WORD GetInvokeType(const char* PropertyName);
	int FindCacheInvokeType(const char* PropertyName);
	int CanFindMethodInCache(const char* PropertyName);

  void SetTypeInfoExists(BOOL TypeInfoExists);
	BOOL GetTypeInfoExists();
	void SetRDS_Status(Object_RDS_Status status);
	Object_RDS_Status GetRDS_Status();

	int GetPropertyDispatcher(JSContext *cx,const char *name,/*out*/int *return_status, WLERRORINFO &m_ErrInfo,jsval *rval);
	//int SetPropertyDispatcher(const char* name,  VARIANT& Value);jsval *vp
	int SetPropertyDispatcher(const char* name, JSContext *cx,jsval *vp,  WLERRORINFO &m_ErrInfo);
	//int CallMethodDispatcher(JSContext *cx,jsval *vp,unsigned int length, VARIANT& Value);
	int CallMethodItemDispatcher(JSContext* cx, long indexInArray, WLERRORINFO &m_ErrInfo, jsval *rval);
	int CallMethodDispatcher(JSContext *cx,jsval *vp,unsigned int length,  WLERRORINFO &m_ErrInfo,  jsval *rval);
	 																				 
//	int CallDefaultPropertyDispatcher(JSContext *cx,jsval *vp,unsigned int length, VARIANT& Value);
	int CallDefaultPropertyDispatcher(JSContext *cx,jsval *vp,unsigned int length,  WLERRORINFO &m_ErrInfo, jsval *rval);

	void ConcatImplicitObjectMethod(const char* father_obejctName,const char* MethodName);


	void  SetHresultErrorInfo();

  void SetObjectClassName_RW(const char* ClassName_RW);
	RVCString GetObjectClassName_RW();

  int CallDefaultProperty_FillParams(VARIANT* Variant_array,unsigned int length,/*out*/JSCOM_INVOKE_PARAMS* Invoke_params);

	int CallInvoke(JSContext * cx,JSCOM_INVOKE_PARAMS* Invoke_params,  WLERRORINFO &m_ErrInfo,const char* Name_for_Error_Message);

//	EXCEPINFO *GetExceptionInfo();
//	void SetExceptionInfo(EXCEPINFO *pexcepinfo);
//		void PrintObjectCreate();

private:

	int FindGuid(  WLERRORINFO &m_ErrInfo);
//	int ConvertGUID();//NOT IN USE
	int CreateObject();
	int Call_GetIDsOfNames(const char*  MethodName_,WLERRORINFO &m_ErrInfo, DISPID *dispid_);

	//STILL NOT IN USE
	int VerifyMethod(const char* PropertyName,int InvokeType, int length,BOOL IsDefaultProperty);

  int CastingParam(VARIANT &param,int typeinfo_vt);

	int FindInvokeDISPID(const char* PropertyName,DISPID* dispid);
  CMethodInfo* FindMethodInfo(const char* PropertyName);

	int GetProperty_FillParams(const char* name,  WLERRORINFO &m_ErrInfo,/*out*/JSCOM_INVOKE_PARAMS* Invoke_params);

	int SetProperty_FillParams(const char* name,VARIANT& Value,  WLERRORINFO &m_ErrInfo,/*out*/JSCOM_INVOKE_PARAMS* Invoke_params);
	int CallMethod_FillParams(VARIANT* Variant_array,unsigned int length,  WLERRORINFO &m_ErrInfo,RVCString methodName,/*out*/JSCOM_INVOKE_PARAMS* Invoke_params);
//  int CallDefaultProperty_FillParams(VARIANT* Variant_array,unsigned int length,/*out*/JSCOM_INVOKE_PARAMS* Invoke_params);
//	int SetProperty_TI(const char* name,VARIANT& Value,/*out*/JSCOM_INVOKE_PARAMS* Invoke_params);
//	int CallInvoke(JSCOM_INVOKE_PARAMS* Invoke_params);
	
	int Convert_CastInvokeParamsDispatcher(const jsval *jsval_array, VARIANT* Variant_array,
																				 const int length,const char* name,
																			  WLERRORINFO &m_ErrInfo, JSContext *cx);

	int Convert_CastInvokeParams_TI(const jsval *jsval_array, VARIANT* Variant_array,
																				 const int length,const char* name,
																				 JSContext *cx,  WLERRORINFO &m_ErrInfo, RVOrderedIterator &sci);

	int Convert_CastInvokeParams_NoTI(const jsval *jsval_array, VARIANT* Variant_array,
																				 const int length,const char* name,
																				   WLERRORINFO &m_ErrInfo,JSContext *cx);

	//int DeleteSafeArrayMembers();

//	int JSVAL_TO_VARIANT(JSContext *cx,const jsval jsvalue,	int cache_vt_type,VARIANT &Variant_value);

//	int IsArrayOfSameTypes(VARIANT* Variant_array,int length);
	
//	void FormatErrorParameterMessage(int cache_vt_type,int jsval_type);
//	void FormatErrorArrayMessage(int ErrorIndex,int counter);

public:

  //pointer to global cache of objects Info
//  static RVHashDictionary *m_pObjectsCache;

//	RVOrdered *m_pVARIANTArrayPointerList;
  
  static CObjectsHashDictionary *m_pObjectsCache;

//  RVHashDictionary *m_pMethodsCache;
//  CMethodsHashDictionary *m_pMethodsCache;
private:


  RVCString m_ClassName_RW;
  RVCString m_RemoteComputerName_RW;
	char m_ObjectGUID_string[50];
	UUID m_ObjectGUID_UUID;
//  UUID m_default_interface_GUID;
	//IDispatch *m_ptrIDispatch;
	IDispatchPtr m_ptrIDispatch;//@@CComPtr




  BOOL m_RemoteConnection;
  BOOL m_TypeInfoExists;

	Object_RDS_Status m_RDS_Status; //enum

  //pointer to specific entery of the global cache 
  CMethodsHashDictionary *m_pMethodsCache;

  //Exception Info in IDispatch::Invoke
  //EXCEPINFO *m_pExcepInfo;

	//pure virtual functions
public:
	virtual bool BeforeGetProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, bool& exitMethod) = 0;    

	virtual bool AfterGetProperty (JSContext *cx, JSObject *obj, jsval id,
																 jsval *vp, bool& exitMethod, int ret,
																 WLERRORINFO &m_ErrInfo) = 0;

  virtual bool BeforeSetProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, bool& exitMethod) = 0;    

  virtual bool AfterSetProperty (JSContext *cx, JSObject *obj, jsval id, 
																 jsval *vp, bool& exitMethod, int ret,
																 WLERRORINFO &m_ErrInfo) = 0;

	virtual bool OnCreationOfJSComObject(JSContext* cx, JSObject* obj) = 0;  
  virtual iJSComPrivateData* CreateNewObject() = 0; 

//***************** Debug Functions ***********************
#ifdef _DEBUG

public:

  void ShowCache();
  int InitXMLObject(char* RemoteComputerName_ = "");//NOT IN USE
	void PrintObjectCreate(JSContext *cx);

	//IT IS USED ONLY TO PRINT A MESSAGE THAT THE OBJECT WAS CREATED.
	//THERE ISN'T ANY PROBLEM THAT IT IS STORED PER OBJECT BECAUSE 
	// WHEN USING MULTITHREDED ONLY ONE OBJECT IS CREATED.
	int RoundNumber;

#endif
//***************** End Debug Functions *******************

};


DllExport JSObject* CreateJSObject( iJSComPrivateData* pJSComPrivateData, JSContext* cx);//@@ for FTPlayBack


#endif
