/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "stdafx.h"
//#include <iostream.h>
#include <comdef.h>
#include <ordered.h>
#include <collstr.h>
#include <collint.h>
#include <collectable.h>
#include <jsdate.h>
#include "cache.h"
#include "HashDictionaries.h"
#include "loadthreadinstance.h"
#include "loadgeneratorscript.h"
#include "wlleprotocol.h"
#include "ComProtocol.h"
//#include "ErrorManager.h"

// CASTING THE ARGUMENTS FROM JSVAL_ARRAY. Variant_array KEEP THE CASTED ARGUMENTS
int iJSComPrivateData :: Convert_CastInvokeParamsDispatcher(const jsval *jsval_array, 
																											 VARIANT* Variant_array,
																											 const int length,
																											 const char* name,
																											 /*tempint InvokeType,*/
																											 WLERRORINFO &m_ErrInfo,
																											 JSContext *cx){
	
	int ret;
	CMethodInfo* method_params_RW;

	if (m_TypeInfoExists){

 		char* PropertyName_lcase = _strlwr(_strdup(name));
		int extra_prams_length = 0;
		m_ErrInfo.m_ErrorDescription = "";


		RVCollectableString tmp_MethodName_RW(PropertyName_lcase);
		free(PropertyName_lcase);

		//we try to find method in the cache
		method_params_RW = (CMethodInfo*)m_pMethodsCache->findValue(&tmp_MethodName_RW);

		//we diddn't succed - continue without TI
		if (method_params_RW == 0){
			ret  = Convert_CastInvokeParams_NoTI(jsval_array,Variant_array,length,name/*temp,DISPATCH_PROPERTYPUT*/,m_ErrInfo,cx);
		}
		else {
			RVOrderedIterator sci(*method_params_RW->GetParamList());
			ret = Convert_CastInvokeParams_TI(jsval_array,Variant_array,length,name,/*tempDISPATCH_PROPERTYPUT*/cx, m_ErrInfo, sci);
		}
	}

	else
		ret = Convert_CastInvokeParams_NoTI(jsval_array,Variant_array,length,name,/*tempDISPATCH_PROPERTYPUT*/m_ErrInfo,cx);

	return ret;
}

int iJSComPrivateData ::Convert_CastInvokeParams_TI(const jsval *jsval_array, VARIANT* Variant_array,
																				 const int length,const char* name,
																				 /*tempint InvokeType,*/JSContext *cx,  WLERRORINFO &m_ErrInfo, RVOrderedIterator &sci){

	int cache_vt_type,ret;
  RVCollectable* item;
  CParamterInfo* tmp_param_info;

	for (int counter = 0; counter < length; counter++){


		//"real-human" number 1,2,3...
		m_ErrInfo.m_ParamNumber = counter + 1;

		item = sci();

		if (item != NULL){
			tmp_param_info = (CParamterInfo*)item;
			cache_vt_type = tmp_param_info->GetType();//GET THE TYPE OF THE PARAMETER FROM THE CACHE
		}

		else{ 
			//pass without knowing TypeInfo
			cache_vt_type = VT_EMPTY;
		}

		ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,jsval_array[counter],
													 cache_vt_type,Variant_array[counter],m_ErrInfo,
													 this);

		if (ret != 0)
			return 1;
	}

	return 0;
}

int iJSComPrivateData :: Convert_CastInvokeParams_NoTI(const jsval *jsval_array, 
																								 VARIANT* Variant_array,
																								 const int length,
																								 const char* name,
																								 /*tempint InvokeType,*/
																								 WLERRORINFO &m_ErrInfo,
																								 JSContext *cx){


	int ret;

	for (int counter = 0; counter < length; counter++){


		//"real-human" number 1,2,3...
		m_ErrInfo.m_ParamNumber = counter + 1;

		ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,jsval_array[counter],
													 VT_EMPTY,Variant_array[counter],m_ErrInfo,
													 this);
/*
//test
		if (this->m_pVARIANTArrayPointerList != NULL){
			CVARIANTArrayPointer *pVARIANTArrayPointer;

			int ent = this->m_pVARIANTArrayPointerList->entries(); 

			while (pVARIANTArrayPointer =(CVARIANTArrayPointer*) this->m_pVARIANTArrayPointerList->pop() ){

				CStaticHelper :: VariantArrayClear_Destroy(pVARIANTArrayPointer->m_pVARIANT,
																									 pVARIANTArrayPointer->m_VARIANT_length);

				delete(pVARIANTArrayPointer);
			}
		}
*/

		if (ret != 0)
			return 1;
	}

	return 0;
}

