/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "stdafx.h"
//#include <iostream.h>
#include <RVFile.h>
#include <comdef.h>
#include <ordered.h>
#include <collstr.h>
#include <collint.h>
#include <collectable.h>
#include <jsdate.h>
#include "cache.h"
#include "HashDictionaries.h"
#include "loadengineglobals.h"
#include <oleauto.h>
#include "tracedll.h"
#include "ComMethodClass.h"
#include "wljsObjects.h"//FOR THE SUSPEND OF THE GARBAGE COLLECTOR LOCK.
#include "wlleprotocol.h"
#include "comprotocol.h"

#include "rvjsapi.h"

int iJSComPrivateData :: GetPropertyDispatcher(JSContext *cx,const char * name,int *return_status,  WLERRORINFO &m_ErrInfo,
																					jsval *rval){

	JSCOM_INVOKE_PARAMS Invoke_Params;
	int ret;
	VariantInit(&Invoke_Params.return_value);

	m_ErrInfo.m_ConversionSource = WL_GET_PROPERTY;
	m_ErrInfo.m_MethodName = name;
	m_ErrInfo.m_IsArray = 0;

	if (m_TypeInfoExists && CanFindMethodInCache(name)){

		int CustomInvokeType = FindCacheInvokeType(name);

		if (CustomInvokeType == SIMPLE_PROPERTY){

			*return_status = TI_SIMPLE_PROPERTY;

			ret = GetProperty_FillParams(name,m_ErrInfo,&Invoke_Params);
			if (ret !=0)
				return 1;

			ret = CallInvoke(cx,&Invoke_Params,m_ErrInfo,name);

			if (ret !=0){
				//m_ErrInfo.m_ErrorIndex = 62;
				VariantClear(&Invoke_Params.return_value);
				return 1;
			}

			*rval = CStaticHelper :: ConvertVariant2JSVAL(
																	Invoke_Params.return_value,cx,this,
																	GetRDS_Status(),name);
			VariantClear(&Invoke_Params.return_value);
			return 0;
		}
		else{

			*return_status = TI_NON_SIMPLE_PROPERTY;

			//there is no error in function call and return_status = 1
			//symbolies that this was not a property
			//*return_status = 1;
			return 0;
		}
	}
	else{ //No TypeInfo

		if (m_RDS_Status == CREATED_VIA_RDS){

			*return_status = NOTI_NON_SIMPLE_PROPERTY;

			return 0;
		}


//#define TI_SIMPLE_PROPERTY 1
//#define NOTI_SIMPLE_PROPERTY 2
//#define TI_NON_SIMPLE_PROPERTY 4
//#define NOTI_NON_SIMPLE_PROPERTY 8

		else{

			ret = GetProperty_FillParams(name,m_ErrInfo,&Invoke_Params);
			if (ret !=0)
				return 1;

            //Ishay March, August 05
            //there was a problem running a js method inside page from the agenda - the method 
            //will be recognized as a property. A change was made in Spider Monkey to recognize that
            //that is the purpose of RVJS_IsCallOpNext

            if (JS_TRUE == RVJS_IsCallOpNext(cx) && DISPATCH_METHOD != Invoke_Params.invoke_type) {
				//we need to let the JS know that we actually executed a method, and the Invoke_Params.invoke_type
				//sent here was wrong
                *return_status = TI_NON_SIMPLE_PROPERTY;  //its a method
                return 0;
/*
				WORD typeSave = Invoke_Params.invoke_type;
                Invoke_Params.invoke_type = DISPATCH_METHOD;
                ret = CallInvoke(cx,&Invoke_Params,m_ErrInfo,name);
                Invoke_Params.invoke_type = typeSave;
                //now run again to get a dispatch in the return value, or an error will be reported
                if (0 == ret && VT_EMPTY == Invoke_Params.return_value.vt) {
					Invoke_Params.invoke_type = typeSave;
			ret = CallInvoke(cx,&Invoke_Params,m_ErrInfo,name);
				}
*/					
            }
            else {
                ret = CallInvoke(cx,&Invoke_Params,m_ErrInfo,name);
            }

			if (ret !=0){
 				// hr == -2147352573 - Member not found -> will try to call a method
				// hr == -2147352562 - It's a property with parameters
				// hr == -2147024809 - The parameter is incorrect.

				VariantClear(&Invoke_Params.return_value);

				if ((m_ErrInfo.m_hrLastError == -2147352573) || 
					  (m_ErrInfo.m_hrLastError == -2147352562) ||
						(m_ErrInfo.m_hrLastError == -2147024809) ||
					//the last line was added by Vadim for SOAP SDK 2  - 23.08.2001 
						(m_ErrInfo.m_hrLastError == -2147352567))
						//the last line was added by Sergei for SOAP SDK 3  - 29.09.2003 
					 { 

					*return_status = NOTI_NON_SIMPLE_PROPERTY;

					return 0;
				}
                                else if (E_NOTIMPL == m_ErrInfo.m_hrLastError) {
                                  //@@@Ishay 19.1.2005
                                  //we are dealing here with a method and not a property.
                                  //we don't have the TypeInfo, so we don't know. and the current code doesn't call Invoke with DISPATCH_METHOD|DISPATCH_PROPERTYGET
                                  //since there are other function here to prepare the data.

                                  *return_status = TI_NON_SIMPLE_PROPERTY;  //its a method
                                  return 0;
                                }
				else{
					*return_status = NOTI_SIMPLE_PROPERTY;
					return 1;
				}

			}	//(ret !=0)

			else {

//				m_ErrInfo.m_ErrorIndex = 62;

				*return_status = NOTI_SIMPLE_PROPERTY;

				*rval = CStaticHelper :: ConvertVariant2JSVAL(
														Invoke_Params.return_value,cx,this,
														GetRDS_Status(),name);

				//VariantCopy(retval,&Invoke_Params.return_value);
				VariantClear(&Invoke_Params.return_value);

				return 0;
			}

		}  //NOT VIA RDS

	} //NO TypeInfo

//	}

	return 0;
}


int iJSComPrivateData :: GetProperty_FillParams(const char* name,  WLERRORINFO &m_ErrInfo,/*out*/JSCOM_INVOKE_PARAMS* Invoke_params){

	int ret;

	if (m_TypeInfoExists){

		ret = FindInvokeDISPID(name,&(Invoke_params->dispid));
		if (ret != 0)
			ret = Call_GetIDsOfNames(name,m_ErrInfo,&(Invoke_params->dispid));
	}

	else
		ret = Call_GetIDsOfNames(name,m_ErrInfo,&(Invoke_params->dispid));

	if (ret != 0){
		m_ErrInfo.m_ErrorIndex = 136;
		m_ErrInfo.m_ErrorDescription = name;
		return 1;
	}

	Invoke_params->invoke_type = DISPATCH_PROPERTYGET;

	Invoke_params->dis_params.cArgs = 0;
	Invoke_params->dis_params.cNamedArgs = NULL;
	Invoke_params->dis_params.rgdispidNamedArgs = 0;
	Invoke_params->dis_params.rgvarg = NULL;

	return 0;
}


int iJSComPrivateData :: SetProperty_FillParams(const char* name,VARIANT& Value,  WLERRORINFO &m_ErrInfo, /*out*/JSCOM_INVOKE_PARAMS* Invoke_params){

	int ret = 0;
  CMethodInfo* method_params_RW = NULL;

	if (m_TypeInfoExists){
    method_params_RW = FindMethodInfo(name);
		if (method_params_RW != NULL)
		  Invoke_params->dispid = method_params_RW->GetDISPID();
    else
			ret = Call_GetIDsOfNames(name,m_ErrInfo,&(Invoke_params->dispid));
	}

	else
		ret = Call_GetIDsOfNames(name,m_ErrInfo,&(Invoke_params->dispid));

	if (ret != 0){
		m_ErrInfo.m_ErrorIndex = 137;
		m_ErrInfo.m_ErrorDescription = name;
		return 1;
	}

  if (method_params_RW != NULL && method_params_RW->GetInvokeType() == DISPATCH_PROPERTYPUTREF)
  	Invoke_params->invoke_type = DISPATCH_PROPERTYPUTREF;
  else
	  Invoke_params->invoke_type = DISPATCH_PROPERTYPUT;

	//should be created "on heap" as far as we use this
	//pointer after quitting this function
	DISPID *dispidNamed = new DISPID();

	if (dispidNamed == NULL){
		m_ErrInfo.m_ErrorIndex = 137;
		m_ErrInfo.m_ErrorDescription = name;
		return 1;
	}

	*dispidNamed = DISPID_PROPERTYPUT;

	Invoke_params->dis_params.cArgs = 1;
	Invoke_params->dis_params.cNamedArgs = 1;
	Invoke_params->dis_params.rgdispidNamedArgs = dispidNamed;
	Invoke_params->dis_params.rgvarg = &Value;

	//Return Value in calling the DISPATCH_PROPERTYPUT should be NULL;
	//in order to save generic structure I pass VARIANT with VT_EMPTY
	Invoke_params->return_value.vt = VT_EMPTY;

	return 0;
}

int iJSComPrivateData :: CallMethod_FillParams(VARIANT* Variant_array,unsigned int length,  WLERRORINFO &m_ErrInfo,RVCString methodName,/*out*/JSCOM_INVOKE_PARAMS* Invoke_params){

	int ret;

	if (m_TypeInfoExists){
		ret = FindInvokeDISPID(methodName,&(Invoke_params->dispid));
		if (ret != 0)
			ret = Call_GetIDsOfNames(methodName,m_ErrInfo,&(Invoke_params->dispid));
	}
	else
		ret = Call_GetIDsOfNames(methodName,m_ErrInfo,&(Invoke_params->dispid));

	if (ret != 0){
		m_ErrInfo.m_ErrorIndex = 138;
		m_ErrInfo.m_ErrorDescription = methodName;
		return 1;
	}

	if (length > 1){
		//CVariantConvert convert;
		//ret = convert.ReverseVARIANTArray(Variant_array,length);

		ret = CStaticHelper :: ReverseVARIANTArray(Variant_array,length);
	}

	Invoke_params->invoke_type =DISPATCH_METHOD;

	//should be created "on heap" as far as we use this
	//pointer after quitting this function
	//DISPID *dispidNamed = new DISPID();
	//*dispidNamed = DISPID_PROPERTYPUT;

	Invoke_params->dis_params.cArgs = length;//0
	Invoke_params->dis_params.cNamedArgs = NULL;//null
	Invoke_params->dis_params.rgdispidNamedArgs = 0;//0
	Invoke_params->dis_params.rgvarg =Variant_array;//null


	return 0;
}

int iJSComPrivateData :: CallDefaultProperty_FillParams(VARIANT* Variant_array,
																									 unsigned int length,
																									 JSCOM_INVOKE_PARAMS* Invoke_params){

	int ret;

	//Default property allways has dispid=0
  Invoke_params->dispid = 0;

	if (length > 1){
		//CVariantConvert convert;
		//ret = convert.ReverseVARIANTArray(Variant_array,length);

		ret = CStaticHelper :: ReverseVARIANTArray(Variant_array,length);
	}

	Invoke_params->invoke_type = DISPATCH_PROPERTYGET;

	Invoke_params->dis_params.cArgs = length;
	Invoke_params->dis_params.cNamedArgs = NULL;
	Invoke_params->dis_params.rgdispidNamedArgs = 0;
	Invoke_params->dis_params.rgvarg =Variant_array;

	return 0;
}


int iJSComPrivateData :: SetPropertyDispatcher(const char* name, JSContext *cx,jsval *vp,  WLERRORINFO &m_ErrInfo){

	JSCOM_INVOKE_PARAMS Invoke_Params;
	int ret;

	//************Begin Workaround For Inherited interfaces**********
/*
	//checks wheather the method is Ok without checking the parameters
	if (m_TypeInfoExists) {
		//ret  = VerifyMethod(name, Invoke_Params.invoke_type,1);
		ret  = VerifyMethod(name, DISPATCH_PROPERTYPUT,1,FALSE);
		if (ret !=0){
			m_ErrInfo.m_ErrorIndex = 15;
			m_ErrInfo.m_ErrorDescription = name;
			return 1;
		}
	}
*/
	//************End Workaround For Inherited interfaces**********

	VARIANT Variant_Set_Value;
  VariantInit(&Variant_Set_Value);

	m_ErrInfo.m_ConversionSource = WL_SET_PROPERTY;
	m_ErrInfo.m_MethodName = name;
	m_ErrInfo.m_IsArray = 0;

//CAST THE vp TO VARIANT
	ret = Convert_CastInvokeParamsDispatcher(vp,&Variant_Set_Value,1,name,/*DISPATCH_PROPERTYPUT,*/m_ErrInfo,cx);
	if (ret !=0)
		return 1;

	ret = SetProperty_FillParams(name,Variant_Set_Value,m_ErrInfo,&Invoke_Params);
	if (ret !=0)
		return 1;

	ret = CallInvoke(cx,&Invoke_Params,m_ErrInfo,name);

	//delets the pointer that was created while
	//	calling DISPID *dispidNamed = new DISPID(); (SetProperty_TI)
	delete Invoke_Params.dis_params.rgdispidNamedArgs;
	VariantClear(Invoke_Params.dis_params.rgvarg);

	//VariantClear(&Invoke_Params.return_value);


	if (ret !=0){

		//m_ErrInfo.m_ErrorIndex = 62;
		return 1;
	}

	//delets the pointer that was created while
	//	calling DISPID *dispidNamed = new DISPID(); (SetProperty_TI)
	//delete Invoke_Params.dis_params.rgdispidNamedArgs;

	return 0;
}
//55825794
//66840406

int iJSComPrivateData::CallMethodItemDispatcher(JSContext* cx,
																								long indexInArray,
																								WLERRORINFO &m_ErrInfo,
																								jsval *rval)
{
	JSCOM_INVOKE_PARAMS Invoke_Params;
	int ret;
	m_ErrInfo.m_ConversionSource = WL_GET_PROPERTY;
	m_ErrInfo.m_MethodName = "[]";
	m_ErrInfo.m_IsArray = 0;
	RVCString rwMethodName("item");

	VariantInit(&Invoke_Params.return_value);

  VARIANT *Variant_array = new VARIANT [1];
 	VariantInit(&Variant_array[0]);
	Variant_array[0].vt = VT_I4;
	Variant_array[0].lVal = indexInArray;

	ret = CallMethod_FillParams(Variant_array,1, m_ErrInfo,rwMethodName,&Invoke_Params);
	if (ret !=0)
		return 1;

	ret = CallInvoke(cx,&Invoke_Params,m_ErrInfo, rwMethodName.data());
	if ( (ret == 0) && (m_ErrInfo.m_hrLastError == 0)){
		*rval = CStaticHelper :: ConvertVariant2JSVAL(  // rval THE RETURNED VALUE OF THE FUNCTION
																Invoke_Params.return_value,cx,this,
																GetRDS_Status(),
																rwMethodName);
	}

	VariantClear(&Invoke_Params.return_value);

	CStaticHelper :: VariantArrayClear_DestroyEx(Variant_array,1);

	if ( (ret !=0) || (m_ErrInfo.m_hrLastError == 1)){
		m_ErrInfo.m_ErrorIndex = 62;
		m_ErrInfo.m_ErrorDescription = "Property [] failed";
		return 1;
	}

	return 0;
}

int iJSComPrivateData :: CallMethodDispatcher(JSContext *cx,jsval *vp,
 																				 unsigned int length,
																				   WLERRORINFO &m_ErrInfo,
																					 jsval *rval
																					 ){
//																				 unsigned int length,  VARIANT& Value){

	JSCOM_INVOKE_PARAMS Invoke_Params;
	int ret,counter;

	ComMethodPrivate* pMethodPrv = (ComMethodPrivate*)JS_GetPrivate( cx, JSVAL_TO_OBJECT( vp[-2] ) );//GET THE OBJECT THAT WAS RETURNED FROM THE JS_GetPropert()
	const char *name = (pMethodPrv->GetName()).data();

	m_ErrInfo.m_ConversionSource = WL_METHOD;
	m_ErrInfo.m_MethodName = name;
	m_ErrInfo.m_IsArray = 0;


	VariantInit(&Invoke_Params.return_value);

  // Chaim - Remove special activeX hooks for emulation
  /*
	if (pMethodPrv->GetName().compareTo("load") == 0 && JSVAL_IS_STRING(vp[0]))
	{
		char * sUrl = JS_GetStringBytes( JS_ValueToString( cx, vp[0] ) );
		if (sUrl)
		{
			RVFile oFileURL(sUrl, "rb+");
			if (!oFileURL.isValid() || !oFileURL.Exists())
			{
				jsval fullURLString;
				jsval* URLString = new jsval(STRING_TO_JSVAL(JS_NewStringCopyZ(cx, sUrl)));
				JSBool bResult = JS_CallFunctionName( cx, JS_GetGlobalObject(cx) , "WLCalcURL" , 1, URLString , &fullURLString );
				const char* sFullURL = NULL;
				delete URLString;
				if( bResult )
				{
					sFullURL = JS_GetStringBytes( JS_ValueToString( cx, fullURLString ) );
				} else
				{
					//@@Report ERROR
				}
				vp[0] = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, sFullURL));
				//printf("*** Calling load with %s\n", JS_GetStringBytes(JS_ValueToString(cx, vp[0])));
			}
		}
	}

	if (pMethodPrv->GetName().compareTo("open") == 0 && length > 0  && JSVAL_IS_STRING(vp[1]))
	{
		char * sUrl = JS_GetStringBytes( JS_ValueToString( cx, vp[1] ) );
		if (sUrl)
		{
			RVFile oFileURL(sUrl, "rb+");
			if (!oFileURL.isValid() || !oFileURL.Exists())
			{
				jsval fullURLString;
				jsval* URLString = new jsval(STRING_TO_JSVAL(JS_NewStringCopyZ(cx, sUrl)));
				JSBool bResult = JS_CallFunctionName( cx, JS_GetGlobalObject(cx) , "WLCalcURL" , 1, URLString , &fullURLString );
				const char* sFullURL = NULL;
				delete URLString;
				if( bResult )
				{
					sFullURL = JS_GetStringBytes( JS_ValueToString( cx, fullURLString ) );
				} else
				{
					//@@Report ERROR
				}
				vp[1] = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, sFullURL));
				//printf("*** Calling load with %s\n", JS_GetStringBytes(JS_ValueToString(cx, vp[0])));
			}
		}
	}
  */


  VARIANT *Variant_array = new VARIANT [length];

  for (counter = 0; counter < (int)length; counter++){
 		VariantInit(&Variant_array[counter]);
  }

  // CASTING THE ARGUMENTS FROM JSVAL (vp). Variant_array KEEP THE CASTED ARGUMENTS
  ret = Convert_CastInvokeParamsDispatcher(vp,Variant_array,length,name,m_ErrInfo,cx);
  if (ret !=0)
	  return 1;

	ret = CallMethod_FillParams(Variant_array,length, m_ErrInfo,pMethodPrv->GetName(),&Invoke_Params);
	if (ret !=0)
		return 1;

	char Full_Function_TimerName[1024];
	char Full_Function_CounterName[1024];

	sprintf(Full_Function_TimerName,"%s::%s (Timer)",m_ClassName_RW,name);
	sprintf(Full_Function_CounterName,"%s::%s (Counter)",m_ClassName_RW,name);

	//const char* tmp = Full_Function_Name.data();
  iLEProtocolVCInMix* pLEProtocolVCInMix;
  bool AmIInThreadLevel = piLEProtocolProcess->AmIInThreadLevel(cx);

  if (AmIInThreadLevel)
    pLEProtocolVCInMix = &(iLEProtocolVCInMix&)piLEProtocolProcess->GetProtocolAgendaJSEmbedContext(cx);

  if(AmIInThreadLevel) {
    pLEProtocolVCInMix->resetTimer(Full_Function_TimerName);
	}

  //
  // The Following line added by Yahali to fix the Invoke type for case of 
  // getproperty with parameters .
  //@@Sergei the following crashes SOAP 3.....
	int nInvokeType = GetInvokeType(name);
	if (nInvokeType != 65535)
	{
		Invoke_Params.invoke_type = nInvokeType;
	}
	ret = CallInvoke(cx,&Invoke_Params,m_ErrInfo,name);

  if(AmIInThreadLevel) {
    pLEProtocolVCInMix->addCounter(Full_Function_CounterName);
  }

	if (ret == 0)
	{
    if(AmIInThreadLevel)
		{
      pLEProtocolVCInMix->sendTimer(Full_Function_TimerName);
    }
    //@@Sergei
		if (GetObjectClassName_RW().compareTo("MSSOAP.SoapClient30") != 0)
		{
			*rval = CStaticHelper :: ConvertVariant2JSVAL(Invoke_Params.return_value,cx,this, GetRDS_Status(), pMethodPrv->GetName());
		} else
		{
			size_t nNumberOfParameters = length + 1;
			jsval* vector = NULL;
			vector = new jsval[nNumberOfParameters];
			vector[0] = CStaticHelper :: ConvertVariant2JSVAL(Invoke_Params.return_value,cx,this, GetRDS_Status(), pMethodPrv->GetName());
			for (int counter = 1; counter < nNumberOfParameters; counter++)
			{
				vector[nNumberOfParameters - counter] = CStaticHelper :: ConvertVariant2JSVAL(Variant_array[counter-1],cx,this, GetRDS_Status(), pMethodPrv->GetName());
			}
			*rval = OBJECT_TO_JSVAL(JS_NewArrayObject(cx, nNumberOfParameters, vector));	
		}
	}

	VariantClear(&Invoke_Params.return_value);
	CStaticHelper :: VariantArrayClear_DestroyEx(Variant_array,length);

	if (ret !=0)
	{
		m_ErrInfo.m_ErrorIndex = 61;
		return 1;
	}

	return 0;
}


int iJSComPrivateData :: CallDefaultPropertyDispatcher(JSContext *cx,jsval *vp,
 																				 unsigned int length,  WLERRORINFO &m_ErrInfo, jsval *rval){
																				 //unsigned int length,  VARIANT& Value){

	JSCOM_INVOKE_PARAMS Invoke_Params;
	int ret,counter;
//  CMethodInfo* method_params_RW;
	VariantInit(&Invoke_Params.return_value);

  VARIANT *Variant_array = new VARIANT [length];

  for (counter = 0; counter < (int)length; counter++){
 		VariantInit(&Variant_array[counter]);
  }

  ret = Convert_CastInvokeParams_NoTI(vp,Variant_array,length,"The Same Fucking World",/*tempDISPATCH_PROPERTYGET*/m_ErrInfo ,cx);

	if (ret !=0)
		return 1;


//#define DISPATCH_METHOD         0x1
//#define DISPATCH_PROPERTYGET    0x2
//#define DISPATCH_PROPERTYPUT    0x4
//#define DISPATCH_PROPERTYPUTREF 0x8


//	ret = CallDefaultProperty_Method_FillParams(Variant_array,length,DISPATCH_PROPERTYGET,&Invoke_Params);
//	if (ret !=0)
//		return 1;





	ret = CallDefaultProperty_FillParams(Variant_array,length,&Invoke_Params);
	if (ret !=0)
		return 1;

	char Full_Function_TimerName[1024];
	char Full_Function_CounterName[1024];

	sprintf(Full_Function_TimerName,"%s::%s (Timer)",m_ClassName_RW,"Default_Property");
	sprintf(Full_Function_CounterName,"%s::%s (Counter)",m_ClassName_RW,"Default_Property");

  iLEProtocolVCInMix* pLEProtocolVCInMix;
  bool AmIInThreadLevel = piLEProtocolProcess->AmIInThreadLevel(cx);

  if (AmIInThreadLevel)
    pLEProtocolVCInMix = &(iLEProtocolVCInMix&)piLEProtocolProcess->GetProtocolAgendaJSEmbedContext(cx);

  if (AmIInThreadLevel){
    pLEProtocolVCInMix->resetTimer(Full_Function_TimerName);
  }

	ret = CallInvoke(cx,&Invoke_Params,m_ErrInfo,"Default Property");

	//In case, that the call of default property wasn't succesfull, we try
	//to call default method

	if (ret != 0){
//@@ANDA
    m_ErrInfo.m_ConversionSource = WL_GET_PROPERTY;
	  m_ErrInfo.m_MethodName = "toString";
	  m_ErrInfo.m_IsArray = 0;


	  ret = GetProperty_FillParams("toString",m_ErrInfo,&Invoke_Params);
	  if (ret !=0)
      return 1;
 
		Invoke_Params.invoke_type = DISPATCH_METHOD;
    if (AmIInThreadLevel){
      pLEProtocolVCInMix->resetTimer(Full_Function_TimerName);
    }
		ret = CallInvoke(cx,&Invoke_Params,m_ErrInfo,"Default Method");
	}


  if (AmIInThreadLevel){
    pLEProtocolVCInMix->addCounter(Full_Function_CounterName);
  }

	if (ret == 0){
    if (AmIInThreadLevel){
      pLEProtocolVCInMix->sendTimer(Full_Function_TimerName);
    }

		*rval = CStaticHelper :: ConvertVariant2JSVAL(
																Invoke_Params.return_value,cx,this,
																GetRDS_Status(),
																"Default_Property");
	}
/*
	VariantClear(&Invoke_Params.return_value);

  for (counter = 0; counter < (int)length; counter++){

		if ((Variant_array[counter].vt & VT_ARRAY) != 0){

			if ((Variant_array[counter].vt & VT_TYPEMASK) == VT_VARIANT){

				long uBound;
				uBound = uBound + 100;

			}

			SafeArrayDestroy(Variant_array[counter].parray);
		} //if VT_ARRAY
  }//for (global)

	CStaticHelper :: VariantArrayClear_Destroy(Variant_array,length);
  //delete [] Variant_array;
*/

	VariantClear(&Invoke_Params.return_value);

	CStaticHelper :: VariantArrayClear_DestroyEx(Variant_array,length);


	if (ret !=0){
//to be changed
		/*
		switch(m_InvokeType) {

			case INVOKE_FUNC :
				m_ErrInfo.m_ErrorIndex = 61;
				break;

			case INVOKE_PROPERTYGET :
			case INVOKE_PROPERTYPUT :
				m_ErrInfo.m_ErrorIndex = 62;
				break;

			case INVOKE_PROPERTYPUTREF :
				m_ErrInfo.m_ErrorIndex = 63;
				break;
		} //switch
*/
		return 1;
	}

	return 0;
}


int iJSComPrivateData :: CallInvoke(JSContext *cx,JSCOM_INVOKE_PARAMS* Invoke_params,  WLERRORINFO &m_ErrInfo,
															 const char* Name_for_Error_Message){

	EXCEPINFO pexcepinfo;
	pexcepinfo.wCode               = 1001;
	pexcepinfo.wReserved           = 0;
	pexcepinfo.bstrSource          = 0;
	pexcepinfo.bstrDescription     = 0;
	pexcepinfo.bstrHelpFile        = 0;
	pexcepinfo.dwHelpContext       = 0;
	pexcepinfo.pvReserved          = 0;
	pexcepinfo.pfnDeferredFillIn   = 0;
  pexcepinfo.scode               = 0;

	char error_description[1024] = "\0";
	char temp_error_description[1024]="\0";
	LPVOID lpMsgBuf; // LPVOID   A 32-bit pointer to an unspecified type
	TCHAR  *MsgBuf= NULL;

	m_ErrInfo.m_hrReturnedFromComLastFunction=0;//avidan this term will be set

	// later only if there will be an  exception


//#define DISPATCH_METHOD         0x1
//#define DISPATCH_PROPERTYGET    0x2
//#define DISPATCH_PROPERTYPUT    0x4
//#define DISPATCH_PROPERTYPUTREF 0x8

	try {
		m_ErrInfo.m_hrLastError = m_ptrIDispatch->Invoke(
																					Invoke_params->dispid,
																					IID_NULL,
																					GetUserDefaultLCID(),
																					Invoke_params->invoke_type,
																					&(Invoke_params->dis_params),
																					&Invoke_params->return_value,
																					&pexcepinfo,
																					NULL);
	}
	catch(_com_error & e) {
		RVCString error;
		error = "Error : exception occured in the function iJSComPrivateData :: CallInvoke" + e.Description();
		WlTraceMsg ( error );
    
    if (piLEProtocolProcess->AmIInThreadLevel(cx))
  		((iLEProtocolVCInMix&)piLEProtocolProcess->GetProtocolAgendaJSEmbedContext(cx)).report(WLLogMessage::Error, error.data());
	}

	if (Invoke_params->return_value.vt == VT_BOOL && Invoke_params->return_value.boolVal == FALSE)
	{
		if (Name_for_Error_Message && strcmp(Name_for_Error_Message, "load") == 0)
		{
			m_ErrInfo.m_ErrorIndex = 16;
			if (!ThrowComError(cx,m_ErrInfo))
				return JS_FALSE;
			else
			return JS_TRUE;
		}
	}

	m_ErrInfo.m_hrReturnedFromInvoke=m_ErrInfo.m_hrLastError;// SetErrorhrReturnedFromInvoke(m_hrLastError);
	if (FAILED(m_ErrInfo.m_hrLastError))
	{
		strcpy(error_description,m_ErrInfo.m_MethodName);
		strcat(error_description,", Reason : ");
		DWORD res = ::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM
																| FORMAT_MESSAGE_IGNORE_INSERTS,    NULL,
																m_ErrInfo.m_hrLastError,
																MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
																(LPTSTR) &lpMsgBuf, 0,NULL );


		strcat(error_description,(LPTSTR) lpMsgBuf);
		LocalFree( lpMsgBuf );

		if (m_ErrInfo.m_hrLastError == DISP_E_EXCEPTION){

			LPOLESTR temp_str_w = (LPOLESTR)pexcepinfo.bstrSource;
			USES_CONVERSION;
			if(temp_str_w!=NULL) {
				strcat(error_description," Exception Source : ");
			  strcat(error_description,OLE2A(temp_str_w));
			}


			LPOLESTR temp_str_w1 = (LPOLESTR)pexcepinfo.bstrDescription;
			if(temp_str_w1!=NULL) {
				strcat(error_description," Exception Description : ");
			  strcat(error_description,OLE2A(temp_str_w1));
			}

				if(pexcepinfo.bstrSource)
					SysFreeString(pexcepinfo.bstrSource);
				if(pexcepinfo.bstrDescription)
					SysFreeString(pexcepinfo.bstrDescription);
				if(pexcepinfo.bstrHelpFile)
					SysFreeString(pexcepinfo.bstrHelpFile);
			
		}

		strcat(error_description,"\0");
		m_ErrInfo.m_ErrorDescription = error_description;
		switch(m_ErrInfo.m_ConversionSource){

			case WL_GET_PROPERTY :
				m_ErrInfo.m_ErrorIndex = 162;
				break;

			case WL_SET_PROPERTY :
				m_ErrInfo.m_ErrorIndex = 163;
				break;

			case WL_METHOD :
				m_ErrInfo.m_ErrorIndex = 164;
				break;

			default :
				m_ErrInfo.m_ErrorIndex = 165;
				break;
		}

		Invoke_params->return_value.vt = VT_ERROR;

		return 1;
	}

	return 0;
}
