/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "stdafx.h"
//#include <iostream.h>
#include <comdef.h>
#include <ordered.h>
#include <collstr.h>
#include <collint.h>
#include <collectable.h>
#include "cache.h"
#include "HashDictionaries.h"

void iJSComPrivateData :: TypeInfoWarning(){
  //if (!m_TypeInfoExists)
   // cout<<"ComObject Warning : TypeInfo for this object does't availible"<<endl;
}

/*
int iJSComPrivateData ::VerifyMethod(const char* PropertyName,int InvokeType, int length,BOOL IsDefaultProperty){

  int extra_prams_length = 0;
  m_ErrInfo.m_ErrorDescription = "";
  CMethodInfo* method_params_RW;

  if (IsDefaultProperty == false){
    char* PropertyName_lcase = _strlwr(_strdup(PropertyName));


    RVCollectableString tmp_MethodName_RW(PropertyName_lcase);
    free(PropertyName_lcase);

    method_params_RW = (CMethodInfo*)m_pMethodsCache->findValue(&tmp_MethodName_RW);
 }

  else
    method_params_RW = m_pMethodsCache->GetDefaultPropertyParam();

  if (method_params_RW ==0)
     return 1;



	int inv = method_params_RW->GetInvokeType();
	if (InvokeType != method_params_RW->GetInvokeType()){

		switch(InvokeType) {

			case INVOKE_FUNC :	
				m_ErrInfo.m_ErrorIndex = 31;
				return 1;

			case INVOKE_PROPERTYGET :

				if ((method_params_RW->GetInvokeType() == INVOKE_PROPERTYGET + 
																									INVOKE_PROPERTYPUT) ||
						(method_params_RW->GetInvokeType() == INVOKE_PROPERTYGET + 
																									INVOKE_PROPERTYPUTREF)){

					//when we call a "get proprty" of the property, that isn't
					//read-only, there is the "put case" entery in the cache,
					//i.e. there is one pearameter more than it should be
					//in case of the "get property"

					extra_prams_length = 1;
					break;
				}

				else {
					m_ErrInfo.m_ErrorIndex = 32;
					return 1;
				}

			case INVOKE_PROPERTYPUT :

				if (method_params_RW->GetInvokeType() == INVOKE_PROPERTYGET + 
																								 INVOKE_PROPERTYPUT) 				
					break;

				else {
					m_ErrInfo.m_ErrorIndex = 32;
					return 1;
				}

			case INVOKE_PROPERTYPUTREF :

				if (method_params_RW->GetInvokeType() == INVOKE_PROPERTYGET + 
																								 INVOKE_PROPERTYPUTREF) 				
					break;

				else {
					m_ErrInfo.m_ErrorIndex = 33;
					return 1;
				}

			default :
				m_ErrInfo.m_ErrorIndex = 34;
				return 1;
		} //switch
	} //if (InvokeType != method_params_RW->GetInvokeType())


  if ((length + extra_prams_length < 
								method_params_RW->GetParamNumberMinimum()) || 

      (length + extra_prams_length > 
								method_params_RW->GetParamNumber())){
		
					//sets the "origin" of the error (function || property)
					switch(InvokeType) {

						case INVOKE_FUNC :	
							m_ErrInfo.m_ErrorIndex = 41;
							break;

						case INVOKE_PROPERTYGET :
						case INVOKE_PROPERTYPUT :
							m_ErrInfo.m_ErrorIndex = 42;
							break;

						case INVOKE_PROPERTYPUTREF :
							m_ErrInfo.m_ErrorIndex = 43;
							break;
					} //switch

					return 1;
  }

	return 0;

}
*/
//this function checks wheather the type of parameter
//will be succefully casted by COM object.
//In case that COM object can really cast it, we state
//that the parameter of this type can be passed and return 0
//in CastingParam function.
//In case that COM object can't cast the type of this param - 
// we return 1 and stop execution of the method with th error.

int iJSComPrivateData :: CastingParam(VARIANT &param,int typeinfo_vt){

  switch(typeinfo_vt){

    case VT_I4: 

      switch(param.vt){

        case VT_R8:         return 0;
        case VT_DISPATCH:   return 1;
        case VT_BOOL:       return 0;
        case VT_BSTR:       return 1;
        case VT_VARIANT:    return 0;          
      }

    case VT_R8: 

      switch(param.vt){

        case VT_I4:         return 0;
        case VT_DISPATCH:   return 1;
        case VT_BOOL:       return 0;
        case VT_BSTR:       return 1; 
        case VT_VARIANT:    return 0;          
      }
           
    case VT_BSTR:

      switch(param.vt){

        case VT_I4:         return 0;
        case VT_R8:         return 0;
        case VT_DISPATCH:   return 1; 
        case VT_BOOL:       return 0;       
        case VT_VARIANT:    return 0;          
      }


    case VT_DISPATCH:

      switch(param.vt){

        case VT_I4:         return 1;
        case VT_R8:         return 1;
        case VT_BSTR:       return 1; 
        case VT_BOOL:       return 1;       
        case VT_VARIANT:    return 0;          
      }

    case VT_BOOL:    

      switch(param.vt){

        case VT_I4:         return 0;
        case VT_R8:         return 0;
        case VT_BSTR:       return 1; 
        case VT_DISPATCH:   return 1; 
        case VT_VARIANT:    return 0;          
      }

    case VT_ERROR:          return 1; 

  } //  switch(typeinfo_vt){

  return 0;
}
