/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "tracedll.h"
#include "wlerrorlib.h"
#include "loadexceptions.h"
#include "loadreportinfo.h"
#include "wlxmlfuncs.h"
#include "wlxmlprivate.h"
#include <xercesc/dom/DOMProcessingInstruction.hpp>

XERCES_CPP_NAMESPACE_USE

#define CLASSNAME DOMProcessingInstruction
DEFAULT_GET_THIS_OBJECT(processinginstruction);

JSBool WLXMLProcessingInstructionEnumerate(JSContext *cx, JSObject *obj );


static JSClass wl_XMLProcessingInstructionClass = {
	"XMLProcessingInstructionObject",
	JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	WLXMLProcessingInstructionEnumerate,//JS_EnumerateStub
	JS_ResolveStub,
	JS_ConvertStub,
	WLXmlGenericFinalize
};




JSBool WLXMLProcessingInstructionEnumerate(JSContext *cx, JSObject *obj )
{
  //enumerate class is implemented for: (for a in xmlparse), it can be implemented later.
  DOMProcessingInstruction* pObj = processinginstruction_GetThisObject(cx, obj);
  
  if (pObj==NULL)
    return JS_TRUE;;

	return JS_TRUE;
}


METHOD_RET_XMLCHAR_NO_ARGS(processinginstruction, getTarget);
METHOD_RET_XMLCHAR_NO_ARGS(processinginstruction, getData);

static JSBool
processinginstruction_setData(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  DOMProcessingInstruction* pObj = processinginstruction_GetThisObject(cx, obj); 
  if (pObj)
  {
    XML_GET_XMLCHAR_ARGUMENT_CHECK(pcData, argv, 0, "attribute_setValue")
    TRY_XML_PARSER_STANDARD
      pObj->setData(pcData);//what abuot setting data to empty string ??
    CATCH_XML_PARSER_STANDARD(processinginstruction,setData)
  }  
	return JS_TRUE;
}


static JSFunctionSpec xmlProcessingInstruction_methods[] = {
  {"getTarget",   processinginstruction_getTarget, 0},
  {"getData",   processinginstruction_getData, 0},
  {"setData",   processinginstruction_setData, 0},
	{0}
};



PROPERTY_GETTER_RET_XMLCHAR(processinginstruction,target,getTarget) 
PROPERTY_GETTER_RET_XMLCHAR(processinginstruction,data,getData)

PROPERTY_SETTER_FOR_STRING(processinginstruction,data,setData)


static JSPropertySpec xmlProcessingInstruction_properties[] = {
  { "target" , 0, READONLY_PROPERTY_FLAGS , processinginstruction_prop_getTarget , JS_PropertyStub },
  { "data"   , 0, PROPERTY_FLAGS          , processinginstruction_prop_getData   , processinginstruction_prop_setData },
	{0}
};



//create new ProcessingInstruction object
jsval WLCreateProcessingInstructionObject(JSContext* cx, JSObject* obj, void* value, bool toDelete)
{
  if (!value)
    return JSVAL_NULL;

  CJSGCRequestBeginEnd GCGuard(cx); //lock GC for this action
	CWLXmlParserPrivate* prv = new CWLXmlParserPrivate((void*)value, CWLXmlParserPrivate::PROCESSING_INSTRUCTION, toDelete);
  JSObject* newObj = JS_NewObject(cx, &wl_XMLProcessingInstructionClass, NULL, NULL);
	JS_SetPrivate(cx, newObj, (void*)prv);
  return OBJECT_TO_JSVAL(newObj);
}

//when we'll define all classes
JSObject* rvAddXMLProcessingInstructionClass(JSContext *cx, JSObject *obj, JSObject* parent_proto)
{
  return JS_InitClass(cx, obj, parent_proto, &wl_XMLProcessingInstructionClass, NULL, 0, xmlProcessingInstruction_properties, xmlProcessingInstruction_methods, NULL, NULL);
}


