/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "tracedll.h"
#include "wlerrorlib.h"
#include "loadexceptions.h"
#include "loadreportinfo.h"
#include "wlxmlfuncs.h"
#include "wlxmlprivate.h"
#include <xercesc/dom/DOMText.hpp>

XERCES_CPP_NAMESPACE_USE

JSBool WLXMLTextEnumerate(JSContext *cx, JSObject *obj );


static JSClass wl_XMLTextClass = {
	"XMLTextObject",
	JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	JS_PropertyStub,
	WLXMLTextEnumerate,//JS_EnumerateStub
	JS_ResolveStub,
	JS_ConvertStub,
	WLXmlGenericFinalize
};




JSBool WLXMLTextEnumerate(JSContext *cx, JSObject *obj )
{
  //enumerate class is implemented for: (for a in xmlparse), it can be implemented later.
  DOMText* pObj = (DOMText*)CWLXmlParserPrivate::GetThisObject(cx, obj);
  
  if (pObj==NULL)
    return JS_TRUE;;

	return JS_TRUE;
}


static JSBool
text_splitText(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  DOMText* pObj = (DOMText*)CWLXmlParserPrivate::GetThisObject(cx, obj);
  if (pObj)
  {
    XML_GET_XMLSIZE_ARGUMENT_CHECK(nOffset, argv, 0, "splitText");
    DOMText* pNewObj =0;
    TRY_XML_PARSER_STANDARD
      pNewObj = pObj->splitText(nOffset);
    CATCH_XML_PARSER_STANDARD(text,splitText)
    *rval = WLCreateTextObject(cx, obj, pNewObj, false);//@@yossi who is responsible for this object??
  }
	return JS_TRUE;
}

static JSFunctionSpec xmlText_methods[] = {
  {"splitText",   text_splitText, 0},
	{0}
};


static JSPropertySpec xmlText_properties[] = {
	{0}
};


//create new Text object
jsval WLCreateTextObject(JSContext* cx, JSObject* obj, void* value, bool toDelete)
{
  if (!value)
    return JSVAL_NULL;

  CJSGCRequestBeginEnd GCGuard(cx); //lock GC for this action
	CWLXmlParserPrivate* prv = new CWLXmlParserPrivate((void*)value, CWLXmlParserPrivate::TEXT, toDelete);
  JSObject* newObj = JS_NewObject(cx, &wl_XMLTextClass, NULL, NULL);
	JS_SetPrivate(cx, newObj, (void*)prv);
  return OBJECT_TO_JSVAL(newObj);
}

//when we'll define all classes
JSObject* rvAddXMLTextClass(JSContext *cx, JSObject *obj, JSObject* parent_proto)
{
  return JS_InitClass(cx, obj, parent_proto, &wl_XMLTextClass, NULL, 0, xmlText_properties, xmlText_methods, NULL, NULL);
}


