/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "wlxmlfuncs.h"
//#include <xercesc/parsers/XercesDOMParser.hpp>
#include <xercesc/dom/DOM.hpp>
//#include <xercesc/dom/impl/DOMNodeImpl.hpp>
#include <xercesc/util/XMLString.hpp>
//#include <xercesc/util/PlatformUtils.hpp>
//#include <xercesc\util\XMLDeleterFor.hpp>
#include <xercesc/dom/DOMBuilder.hpp>
#include <xercesc/framework/MemBufInputSource.hpp>
#include <xercesc/framework/Wrapper4InputSource.hpp>

#include <xercesc/util/XMLUniDefs.hpp>
//#include <xercesc/dom/DOMNode.hpp>
//#include <xercesc/dom/DOM.hpp>
//#include <xercesc/util/XMLString.hpp>
//#include <xercesc/util/PlatformUtils.hpp>
//#include <xercesc/dom/DOMWriter.hpp>
#include <stdio.h>
#include <stdlib.h>

XERCES_CPP_NAMESPACE_USE

//from XMLCh to char*
void getCharFromXMLCh(char* output, const XMLCh* input)
{
  char* message = "";
  if (input)
  {
    char* message = XMLString::transcode(input);
	  strcpy(output, message);
	  XMLString::release(&message);
  }
  else
  {
    output[0]='\0';
  }
}

void getXMLChFromChar(XMLCh* output, const char* input)
{
  if (input)
  {
    XMLCh* message = XMLString::transcode(input);
    XMLString::copyString(output, (const XMLCh*)message);
	  XMLString::release(&message);
  }
  else
  {
     XMLString::copyString(output, XMLString::transcode(""));
  }
}



int main(int argc, char *argv[])
{
  char pcURI[1024] = "K:\\Q.a\\PR_Webload\\regression\\include\\xmlparser_test.xml";

  if (argc>1)
  {
	  strcpy(pcURI, argv[1]);
    printf("Parsing the following XML file: %s", pcURI);
  }
  else
  {
	  printf("**** Using defualt xml file !\n");
  }
  
  char cOutput[1024]="";
  XMLCh wcOutput[1024];

  ///initializing
  XMLPlatformUtils::Initialize();  

  static const XMLCh gLS[] = { chLatin_L, chLatin_S, chNull };
  DOMImplementation *impl = DOMImplementationRegistry::getDOMImplementation(gLS);
  DOMBuilder* parser = ((DOMImplementationLS*)impl)->createDOMBuilder(DOMImplementationLS::MODE_SYNCHRONOUS, 0);
  
  parser->setFeature(XMLUni::fgDOMWhitespaceInElementContent, false);

  parser->setFeature(XMLUni::fgXercesLoadExternalDTD, false);
  parser->setFeature(XMLUni::fgXercesUseCachedGrammarInParse, true);
  parser->setFeature(XMLUni::fgXercesCacheGrammarFromParse, true);
  parser->setFeature(XMLUni::fgXercesGenerateSyntheticAnnotations, false);
  parser->setFeature(XMLUni::fgXercesIgnoreAnnotations, true);
  parser->setFeature(XMLUni::fgDOMIgnoreEmptyTextNodes, true);//our flag

  parser->setProperty(XMLUni::fgXercesScannerName, (void*)XMLUni::fgWFXMLScanner);
  
  //parsing URI
  DOMDocument* pDocument = parser->parseURI(pcURI);

  /////////////////////////create empty document
  MemBufInputSource* memBufIS = new MemBufInputSource
    (
        (const XMLByte*)""
        , 0
        , "EmptyDoc"
        , false
    );
  DOMInputSource* domIn = new Wrapper4InputSource(memBufIS);
  DOMDocument* pEmptyDocument = parser->parse(*domIn);
  /////////////////////////////////////

  //startMillis = XMLPlatformUtils::getCurrentMillis();

  DOMElement* pDocElement = pDocument->getDocumentElement();

  getCharFromXMLCh(cOutput, pDocument->getNodeName());
  printf("pDocument.getNodeName(): %s\n", cOutput);

  printf("pDocument.getChildNodes().getLength(): %d\n", pDocument->getChildNodes()->getLength());

  getCharFromXMLCh(cOutput, pDocElement->getNodeName());
  printf("xmlDoc.getDocumentElement().getNodeName(): %s\n", cOutput);

  getXMLChFromChar(wcOutput, "NODE8");
  DOMElement* pNode8 = pDocument->createElement(wcOutput);
  getCharFromXMLCh(cOutput, pNode8->getNodeName());
  printf("Node8.getNodeName(): %s\n", cOutput);

  getXMLChFromChar(wcOutput, "NODE4");
  DOMNodeList* pNode4List = pDocument->getElementsByTagName(wcOutput);
  int nNode4Length = pNode4List->getLength();
  printf("pNode4->getLength(): %d\n", nNode4Length);

  getXMLChFromChar(wcOutput, "NODE5");
  DOMNodeList* pNode5List = pDocument->getElementsByTagName(wcOutput);
  DOMNode* pNode5First = pNode5List->item(0);
  getCharFromXMLCh(cOutput, pNode5First->getNodeName());
  printf("pNode5List.getLength: %d, ('NODE5').item(0).getNodeName: %s\n",pNode5List->getLength() ,cOutput);

  printf("pNode5First.getChildNodes().getLength(): %d\n", pNode5First->getChildNodes()->getLength());

  for (size_t i=0;i<pNode5First->getChildNodes()->getLength();i++)
  {
    getCharFromXMLCh(cOutput, pNode5First->getChildNodes()->item(i)->getNodeName());
    printf("pNode5First->getChildNodes()->item( %d )->getNodeName(): %s\n", i, cOutput);
  }

  getCharFromXMLCh(cOutput, pNode5First->getFirstChild()->getNodeName());
  printf("pNode5First.getFirstChild().getNodeName(): %s\n", cOutput);

  getCharFromXMLCh(cOutput, pNode5First->getLastChild()->getNodeName());
  printf("pNode5First.getLastChild().getNodeName(): %s\n", cOutput);

  getCharFromXMLCh(cOutput, pNode5First->getOwnerDocument()->getNodeName());
  printf("pNode5First.getOwnerDocument().getNodeName(): %s\n", cOutput);

  XMLSize_t uChildNodes = pNode5First->getOwnerDocument()->getChildNodes()->getLength();
  printf("pNode5First.getOwnerDocument().getChildNodes().getLength(): %d\n", pNode5First->getOwnerDocument()->getChildNodes()->getLength());

  DOMNode* pClonedNodeDeep = pNode5First->cloneNode(true);
  DOMNode* pClonedNodeShallow = pNode5First->cloneNode(false);

  printf("pNode5First.getChildNodes().getLength(): %d\n", pNode5First->getChildNodes()->getLength());

  printf("pClonedNodeDeep.getChildNodes().getLength(): %d\n", pClonedNodeDeep->getChildNodes()->getLength());
  
  printf("pClonedNodeShallow.getChildNodes().getLength(): %d\n", pClonedNodeShallow->getChildNodes()->getLength());

   //XMLDeleterFor<DOMNode> removeNode(pClonedNodeDeep);


/*
  DOMNodeImpl* pNode = (DOMNodeImpl*)pClonedNodeDeep;
  pClonedNodeDeep->setUserData("

setUserData(const XMLCh* key,
                                          void* data,
                                          DOMUserDataHandler* handler) = 0;
*/
//  pNode->setOwnerDocument(pDocument);

/*
  try
  {
    pEmptyDocument->adoptNode(pClonedNodeDeep);
  }
  catch (const XMLException& toCatch)                                                     \
  {                                                                                       \
    char* message = XMLString::transcode(toCatch.getMessage());                           \
    XMLString::release(&message);                                                         \
  }                                                                                       \
  catch (const DOMException& toCatch) {                                                   \
    char* message = XMLString::transcode(toCatch.msg);                                    \
    XMLString::release(&message);                                                         \
  }                                                                                       \
  catch (...) {                                                                           \
  }
  pEmptyDocument->release();
*/
  return 0;

}
